/* DUPLICATOR MYSQL SCRIPT CREATED ON : June 12, 2013, 11:35 pm */

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8_unicode_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8_unicode_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_duplicator` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `token` varchar(25) COLLATE utf8_unicode_ci NOT NULL,
  `packname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
  `zipsize` int(11) DEFAULT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) COLLATE utf8_unicode_ci NOT NULL,
  `settings` longtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8_unicode_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`)
) ENGINE=MyISAM AUTO_INCREMENT=521 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=60 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_title` text COLLATE utf8_unicode_ci NOT NULL,
  `post_excerpt` text COLLATE utf8_unicode_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8_unicode_ci NOT NULL,
  `pinged` text COLLATE utf8_unicode_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8_unicode_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=MyISAM AUTO_INCREMENT=32 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8_unicode_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `slug` (`slug`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8_unicode_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`)
) ENGINE=MyISAM AUTO_INCREMENT=18 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_pass` varchar(64) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;


/* INSERT TABLE DATA: wp_comments */
INSERT INTO `wp_comments` VALUES("1", "1", "Mr WordPress", "", "http://wordpress.org/", "", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "Hi, this is a comment.<br />To delete a comment, just log in and view the post&#039;s comments. There you will have the option to edit or delete them.", "0", "post-trashed", "", "", "0", "0");

/* INSERT TABLE DATA: wp_links */
INSERT INTO `wp_links` VALUES("1", "http://codex.wordpress.org/", "Documentation", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("2", "http://wordpress.org/news/", "WordPress Blog", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "http://wordpress.org/news/feed/");
INSERT INTO `wp_links` VALUES("3", "http://wordpress.org/extend/ideas/", "Suggest Ideas", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("4", "http://wordpress.org/support/", "Support Forum", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("5", "http://wordpress.org/extend/plugins/", "Plugins", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("6", "http://wordpress.org/extend/themes/", "Themes", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");
INSERT INTO `wp_links` VALUES("7", "http://planet.wordpress.org/", "WordPress Planet", "", "", "", "Y", "1", "0", "0000-00-00 00:00:00", "", "", "");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("511", "_site_transient_timeout_theme_roots", "1371081846", "yes");
INSERT INTO `wp_options` VALUES("512", "_site_transient_theme_roots", "a:5:{s:12:\"flexibility3\";s:7:\"/themes\";s:8:\"striking\";s:7:\"/themes\";s:12:\"twentyeleven\";s:7:\"/themes\";s:9:\"twentyten\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}", "yes");
INSERT INTO `wp_options` VALUES("3", "siteurl", "http://blogsforsales.com/video", "yes");
INSERT INTO `wp_options` VALUES("4", "blogname", "Video Promotion", "yes");
INSERT INTO `wp_options` VALUES("5", "blogdescription", "", "yes");
INSERT INTO `wp_options` VALUES("6", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("7", "admin_email", "anton241@herbalcuresandremedies.info", "yes");
INSERT INTO `wp_options` VALUES("8", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("9", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("10", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("13", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("14", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("18", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("19", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("20", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("22", "default_pingback_flag", "1", "yes");
INSERT INTO `wp_options` VALUES("24", "posts_per_page", "10", "yes");
INSERT INTO `wp_options` VALUES("25", "date_format", "F j, Y", "yes");
INSERT INTO `wp_options` VALUES("26", "time_format", "g:i a", "yes");
INSERT INTO `wp_options` VALUES("27", "links_updated_date_format", "F j, Y g:i a", "yes");
INSERT INTO `wp_options` VALUES("28", "links_recently_updated_prepend", "<em>", "yes");
INSERT INTO `wp_options` VALUES("29", "links_recently_updated_append", "</em>", "yes");
INSERT INTO `wp_options` VALUES("30", "links_recently_updated_time", "120", "yes");
INSERT INTO `wp_options` VALUES("31", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("33", "permalink_structure", "", "yes");
INSERT INTO `wp_options` VALUES("34", "gzipcompression", "0", "yes");
INSERT INTO `wp_options` VALUES("35", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("36", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("37", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("38", "active_plugins", "a:1:{i:0;s:25:\"duplicator/duplicator.php\";}", "yes");
INSERT INTO `wp_options` VALUES("39", "home", "http://blogsforsales.com/video", "yes");
INSERT INTO `wp_options` VALUES("40", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("41", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("42", "advanced_edit", "0", "yes");
INSERT INTO `wp_options` VALUES("43", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("44", "gmt_offset", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("46", "recently_edited", "", "no");
INSERT INTO `wp_options` VALUES("47", "template", "flexibility3", "yes");
INSERT INTO `wp_options` VALUES("48", "stylesheet", "flexibility3", "yes");
INSERT INTO `wp_options` VALUES("49", "comment_whitelist", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "blacklist_keys", "", "no");
INSERT INTO `wp_options` VALUES("51", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("53", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("54", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("55", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("56", "db_version", "22441", "yes");
INSERT INTO `wp_options` VALUES("57", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("58", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("59", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("60", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("61", "show_on_front", "posts", "yes");
INSERT INTO `wp_options` VALUES("62", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("63", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("64", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("65", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("66", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("67", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("68", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("69", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("70", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("71", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("74", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("75", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("76", "image_default_link_type", "file", "yes");
INSERT INTO `wp_options` VALUES("77", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("78", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("79", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("80", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("81", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("82", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("83", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("85", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("86", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("87", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("88", "widget_categories", "a:2:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("89", "widget_text", "a:5:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:191:\"<a href=\"http://anton343.wealthmech.hop.clickbank.net/\r\n\"><img src=\"http://blogsforsales.com/video/wp-content/uploads/2013/06/banner250static02.png\" alt=\"alt text\" style=\"border:none;\" /></a>\";s:6:\"filter\";b:0;}i:3;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:224:\"<center><script type=\"text/javascript\"><!--\r\namazon_ad_tag = \"freetos-20\"; amazon_ad_width = \"120\"; amazon_ad_height = \"600\";//--></script>\r\n<script type=\"text/javascript\" src=\"http://www.assoc-amazon.com/s/ads.js\"></script>\";s:6:\"filter\";b:0;}i:4;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:199:\"<center><a href=\"http://anton343.wealthmech.hop.clickbank.net/\r\n\"><img src=\"http://blogsforsales.com/video/wp-content/uploads/2013/06/banner250static02.png\" alt=\"alt text\" style=\"border:none;\" /></a>\";s:6:\"filter\";b:0;}i:5;a:3:{s:5:\"title\";s:0:\"\";s:4:\"text\";s:139:\"<a href=http://anton343.paiddraw.hop.clickbank.net>\r\n<img src=\"http://dxt8z9w4f93hl.cloudfront.net/creatives/728x90_ani.gif\" border=0></a> \";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("90", "widget_rss", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("91", "timezone_string", "", "yes");
INSERT INTO `wp_options` VALUES("92", "embed_autourls", "1", "yes");
INSERT INTO `wp_options` VALUES("93", "embed_size_w", "", "yes");
INSERT INTO `wp_options` VALUES("94", "embed_size_h", "600", "yes");
INSERT INTO `wp_options` VALUES("95", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("96", "page_on_front", "0", "yes");
INSERT INTO `wp_options` VALUES("97", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("98", "initial_db_version", "19470", "yes");
INSERT INTO `wp_options` VALUES("99", "wp_user_roles", "a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:62:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("100", "widget_search", "a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("101", "widget_recent-posts", "a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("102", "widget_recent-comments", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("103", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("104", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("105", "sidebars_widgets", "a:7:{s:19:\"wp_inactive_widgets\";a:2:{i:0;s:6:\"text-2\";i:1;s:6:\"text-3\";}s:9:\"sidebar-1\";a:4:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:6:\"text-4\";i:3;s:12:\"categories-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:1:{i:0;s:6:\"text-5\";}s:9:\"sidebar-5\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("114", "current_theme", "Flexibility3", "yes");
INSERT INTO `wp_options` VALUES("153", "cron", "a:5:{i:1371087298;a:1:{s:26:\"upgrader_scheduled_cleanup\";a:1:{s:32:\"0f83a1c581ea80c42222e04cd7b205a2\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;i:31;}}}}i:1371118262;a:3:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1371118282;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1371140058;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("199", "uninstall_plugins", "a:1:{s:25:\"duplicator/duplicator.php\";s:20:\"duplicator_uninstall\";}", "no");
INSERT INTO `wp_options` VALUES("200", "link_manager_enabled", "1", "yes");
INSERT INTO `wp_options` VALUES("324", "_site_transient_update_themes", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1371080098;s:7:\"checked\";a:5:{s:12:\"flexibility3\";s:3:\"1.0\";s:8:\"striking\";s:7:\"5.1.8.3\";s:12:\"twentyeleven\";s:3:\"1.5\";s:9:\"twentyten\";s:3:\"1.5\";s:12:\"twentytwelve\";s:3:\"1.1\";}s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("320", "_site_transient_timeout_wporg_theme_feature_list", "1371070121", "yes");
INSERT INTO `wp_options` VALUES("321", "_site_transient_wporg_theme_feature_list", "a:5:{s:6:\"Colors\";a:15:{i:0;s:5:\"black\";i:1;s:4:\"blue\";i:2;s:5:\"brown\";i:3;s:4:\"gray\";i:4;s:5:\"green\";i:5;s:6:\"orange\";i:6;s:4:\"pink\";i:7;s:6:\"purple\";i:8;s:3:\"red\";i:9;s:6:\"silver\";i:10;s:3:\"tan\";i:11;s:5:\"white\";i:12;s:6:\"yellow\";i:13;s:4:\"dark\";i:14;s:5:\"light\";}s:7:\"Columns\";a:6:{i:0;s:10:\"one-column\";i:1;s:11:\"two-columns\";i:2;s:13:\"three-columns\";i:3;s:12:\"four-columns\";i:4;s:12:\"left-sidebar\";i:5;s:13:\"right-sidebar\";}s:5:\"Width\";a:2:{i:0;s:11:\"fixed-width\";i:1;s:14:\"flexible-width\";}s:8:\"Features\";a:19:{i:0;s:8:\"blavatar\";i:1;s:10:\"buddypress\";i:2;s:17:\"custom-background\";i:3;s:13:\"custom-colors\";i:4;s:13:\"custom-header\";i:5;s:11:\"custom-menu\";i:6;s:12:\"editor-style\";i:7;s:21:\"featured-image-header\";i:8;s:15:\"featured-images\";i:9;s:15:\"flexible-header\";i:10;s:20:\"front-page-post-form\";i:11;s:19:\"full-width-template\";i:12;s:12:\"microformats\";i:13;s:12:\"post-formats\";i:14;s:20:\"rtl-language-support\";i:15;s:11:\"sticky-post\";i:16;s:13:\"theme-options\";i:17;s:17:\"threaded-comments\";i:18;s:17:\"translation-ready\";}s:7:\"Subject\";a:3:{i:0;s:7:\"holiday\";i:1;s:13:\"photoblogging\";i:2;s:8:\"seasonal\";}}", "yes");
INSERT INTO `wp_options` VALUES("279", "_site_transient_timeout_browser_26ca8ea8e60136335e5e56fd8bbfc4d6", "1371661680", "yes");
INSERT INTO `wp_options` VALUES("280", "_site_transient_browser_26ca8ea8e60136335e5e56fd8bbfc4d6", "a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:17:\"Internet Explorer\";s:7:\"version\";s:4:\"10.0\";s:10:\"update_url\";s:51:\"http://www.microsoft.com/windows/internet-explorer/\";s:7:\"img_src\";s:45:\"http://s.wordpress.org/images/browsers/ie.png\";s:11:\"img_src_ssl\";s:44:\"https://wordpress.org/images/browsers/ie.png\";s:15:\"current_version\";s:1:\"9\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}", "yes");
INSERT INTO `wp_options` VALUES("162", "dashboard_widget_options", "a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:30:\"http://blogsforsales.com/video\";s:4:\"link\";s:106:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://blogsforsales.com/video/\";s:3:\"url\";s:139:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://blogsforsales.com/video/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}", "yes");
INSERT INTO `wp_options` VALUES("284", "_transient_feed_mod_6d4b681098bf4aeb5947a3e427bf4c2b", "1371056889", "no");
INSERT INTO `wp_options` VALUES("285", "_transient_timeout_dash_20494a3d90a6669585674ed0eb8dcd8f", "1371100089", "no");
INSERT INTO `wp_options` VALUES("286", "_transient_dash_20494a3d90a6669585674ed0eb8dcd8f", "<p>This dashboard widget queries <a href=\"http://blogsearch.google.com/\">Google Blog Search</a> so that when another blog links to your site it will show up here. It has found no incoming links&hellip; yet. It&#8217;s okay &#8212; there is no rush.</p>\n", "no");
INSERT INTO `wp_options` VALUES("281", "_transient_timeout_feed_6d4b681098bf4aeb5947a3e427bf4c2b", "1371100089", "no");
INSERT INTO `wp_options` VALUES("282", "_transient_feed_6d4b681098bf4aeb5947a3e427bf4c2b", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:4:\"\n  \n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:33:\"\n    \n    \n    \n    \n    \n    \n  \";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:3:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"link:http://blogsforsales.com/video/ - Google Blog Search\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://www.google.com/search?ie=utf-8&q=link:http://blogsforsales.com/video/&tbm=blg&tbs=sbd:1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"Your search - <b>link:http://blogsforsales.com/video/</b> - did not match any documents.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://a9.com/-/spec/opensearch/1.1/\";a:3:{s:12:\"totalResults\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:10:\"startIndex\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:12:\"itemsPerPage\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:12:\"content-type\";s:28:\"text/xml; charset=ISO-8859-1\";s:4:\"date\";s:29:\"Wed, 12 Jun 2013 17:08:09 GMT\";s:7:\"expires\";s:2:\"-1\";s:13:\"cache-control\";s:18:\"private, max-age=0\";s:10:\"set-cookie\";a:2:{i:0;s:143:\"PREF=ID=cbc56337d8afe3d9:FF=0:TM=1371056889:LM=1371056889:S=Y_68pzsUckB58r90; expires=Fri, 12-Jun-2015 17:08:09 GMT; path=/; domain=.google.com\";i:1;s:212:\"NID=67=BN3JU_KtVJCk8y7s0ZZy7LAGBDbz50C1F-QGsZmpXwyH-pnCPisNhS8d64fG0Gqnd8VRS13yeTRJAqE1evjz-0595ONv6gSzSDP9cHq_J8MZAfMfo9U9gMSLVij62ykj; expires=Thu, 12-Dec-2013 17:08:09 GMT; path=/; domain=.google.com; HttpOnly\";}s:3:\"p3p\";s:122:\"CP=\"This is not a P3P policy! See http://www.google.com/support/accounts/bin/answer.py?hl=en&answer=151657 for more info.\"\";s:6:\"server\";s:3:\"gws\";s:16:\"x-xss-protection\";s:13:\"1; mode=block\";s:15:\"x-frame-options\";s:10:\"SAMEORIGIN\";}s:5:\"build\";s:14:\"20130602101200\";}", "no");
INSERT INTO `wp_options` VALUES("283", "_transient_timeout_feed_mod_6d4b681098bf4aeb5947a3e427bf4c2b", "1371100089", "no");
INSERT INTO `wp_options` VALUES("289", "_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1371100090", "no");
INSERT INTO `wp_options` VALUES("290", "_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1371056890", "no");
INSERT INTO `wp_options` VALUES("291", "_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51", "1371100090", "no");
INSERT INTO `wp_options` VALUES("292", "_transient_dash_4077549d03da2e451c8b5f002294ff51", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/05/ten-good-years/\' title=\'It’s been ten years since we started this thing, and what a long way we’ve come. From a discussion between myself and Mike Little about forking our favorite blogging software, to powering 18% of the web. It’s been a crazy, exciting, journey, and one that won’t stop any time soon. At ten years, it’s fun […] [&hellip;]\'>Ten Good Years</a> <span class=\"rss-date\">May 31, 2013</span><div class=\'rssSummary\'>It’s been ten years since we started this thing, and what a long way we’ve come. From a discussion between myself and Mike Little about forking our favorite blogging software, to powering 18% of the web. It’s been a crazy, exciting, journey, and one that won’t stop any time soon. At ten years, it’s fun […] [&hellip;]</div></li><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/05/the-next-10-starts-now/\' title=\'All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. Watching the feed of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the […] [&hellip;]\'>The Next 10 Starts Now</a> <span class=\"rss-date\">May 27, 2013</span><div class=\'rssSummary\'>All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. Watching the feed of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the […] [&hellip;]</div></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("293", "_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c", "1371100091", "no");
INSERT INTO `wp_options` VALUES("294", "_transient_feed_867bd5c64f85878d03a060509cd2f92c", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"Alex King: Twitter Tools 3.0.4: Twitter v1.1 API Compatibility\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=17215\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://alexking.org/blog/2013/06/12/twitter-tools-3-0-4-v1-1-api\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1375:\".threads-post-notice {\n	background: #e8e8e8;\n	padding: 10px;\n}\n.threads-post-notice a {\n	font-weight: bold;\n}\n\n<p>I&#8217;ve released Twitter Tools version 3.0.4 which now uses the Twitter v1.1 API. Since Twitter has turned off the 1.0 API, this is pretty much a &#8220;must upgrade&#8221; situation.</p>\n<p>If Twitter Tools has been active for you over the last few days, you&#8217;ll need to do a little cleanup:</p>\n<p>1. <a href=\"http://d.pr/i/qoaN\">enable the Tweet admin screens</a><br />\n2. <a href=\"http://d.pr/i/kK4K\">delete anything you don&#8217;t want (all of those &#8220;(no title)&#8221; ones, probably)</a></p>\n<p>Grab the code from <a href=\"https://github.com/crowdfavorite/wp-twitter-tools\">GitHub</a> where active development occurs, or from <a href=\"http://wordpress.org/plugins/twitter-tools/\">WordPress.org</a> where it is distributed.</p>\n<p>That should do it. As always post any weirdness you see in the <a href=\"http://wordpress.org/support/plugin/twitter-tools\">support forums</a>. While I can&#8217;t provide individual support, I do look for any issues and reports that would indicate a bug that I can fix.</p>\n<p class=\"threads-post-notice\">This post is part of the thread: <a href=\"http://alexking.org/blog/thread/twitter-tools\">Twitter Tools</a> &#8211; an ongoing story on this site. View the thread timeline for more context on this post.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 15:11:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WordPress.tv: Brad Parbs: Responsive Design Primer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19701\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2013/06/12/brad-parbs-responsive-design-primer-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:652:\"<div id=\"v-xO68kHri-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19701/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19701/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19701&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/12/brad-parbs-responsive-design-primer-2/\"><img alt=\"Brad Parbs: Responsive Design Primer\" src=\"http://videos.videopress.com/xO68kHri/video-a588e174ae_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 13:53:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WordPress.tv: Dr. Renee Hobbs: The Implementation Of WordPress in The Academia\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19695\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://wordpress.tv/2013/06/12/dr-renee-hobbs-the-implementation-of-wordpress-in-the-academia/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:705:\"<div id=\"v-m5p7LDci-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19695/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19695/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19695&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/12/dr-renee-hobbs-the-implementation-of-wordpress-in-the-academia/\"><img alt=\"Dr. Renee Hobbs: The Implementation Of WordPress in The Academia\" src=\"http://videos.videopress.com/m5p7LDci/video-5b1324f57b_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 13:09:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WordPress.tv: John Caserta: WordPress for Teachers\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19692\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.tv/2013/06/11/john-caserta-wordpress-for-teachers/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:650:\"<div id=\"v-6zDe6iau-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19692/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19692/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19692&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/11/john-caserta-wordpress-for-teachers/\"><img alt=\"John Caserta: WordPress for Teachers\" src=\"http://videos.videopress.com/6zDe6iau/video-8a99df7f02_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 05:07:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"WordPress.tv: Jonathan Friesem, Kari Lukovics, Daniel Klotz: Educational Use of WordPress at Harrington\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19688\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"http://wordpress.tv/2013/06/11/jonathan-friesem-kari-lukovics-daniel-klotz-educational-use-of-wordpress-at-harrington/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:754:\"<div id=\"v-qUK9EYg9-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19688/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19688/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19688&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/11/jonathan-friesem-kari-lukovics-daniel-klotz-educational-use-of-wordpress-at-harrington/\"><img alt=\"Jonathan Friesem, Kari Lukovics, Daniel Klotz: Educational Use of WordPress at Harrington\" src=\"http://videos.videopress.com/qUK9EYg9/video-da4ac6c057_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 23:44:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: Interview With Brand New Theme Club – TeslaThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7292\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Z4Euz_XasNc/interview-with-brand-new-theme-club-teslathemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9200:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemeslogo.jpg\" rel=\"thumbnail\"><img class=\"alignright size-full wp-image-7293\" alt=\"TeslaThemes Logo\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemeslogo.jpg?resize=128%2C106\" /></a>I&#8217;ve made it a habit to read WordPress related Press Releases despite how boring most of them are. Occasionally, I&#8217;ll come across something that is pretty interesting such as <a title=\"http://teslathemes.com/\" href=\"http://teslathemes.com/\">TeslaThemes</a>. TeslaThemes is a brand new theme club with the goal of producing one theme per month. In particular, I thought their <a title=\"http://teslathemes.com/wp-themes/coolstuff/\" href=\"http://teslathemes.com/wp-themes/coolstuff/\">Cool Stuff theme</a> introduced a unique way of displaying content via Post Formats and a timeline. After browsing around the site, I decided to get in touch with TeslaThemes to find out how they plan on surviving the WordPress theme market, especially as a theme club. <span id=\"more-7292\"></span></p>\n<p><strong>In an ever growing crowd of companies, what do you think will set TeslaThemes apart from the competition?</strong></p>\n<p>We are aware of this very fast growing market, and especially this makes us very confident in what we do and how we do. At this moment income is not a priority, we’re mainly focused on delivering really useful themes to end-users, we do not want to create this “<em>plastic</em>”, “<em>industrial</em>”, “<em>copy paste</em>” WordPress templates as so many do. The market is over saturated with themes and templates and they all look the same. People need something unique, that can stand out of the crowd. We have a very loyal group of followers that give us the boost and confidence for what we have planned.</p>\n<div id=\"attachment_7294\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesPricing.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesPricing.jpg?resize=500%2C187\" alt=\"Tesla Themes Pricing\" class=\"size-large wp-image-7294\" /></a><p class=\"wp-caption-text\">These prices will be changing soon</p></div>\n<p><strong>In your opinion, what makes a good WordPress theme?</strong></p>\n<p>Depends on who is asked. For many, they say 90% is design and 10% code, for others vice versa. We want to merge it to a golden middle, creating handcrafted design interface plus very intuitive customization process for the user, so that he enjoys personalizing his own website, without headache or paying additional developers for that. At the end of the day, when everything is done, what the rest see the design, its usability and navigation, how clean and understandable is it. For sure everyone appreciates it. No one has time to search on the page, our eyes must catch everything from a single glance. To resume, important is the design, the concept, perfect code and very intelligent and user friendly framework that will guide anyone.</p>\n<p><strong>Why have you chosen to develop commercial themes for WordPress instead of Joomla, or Drupal?</strong></p>\n<p>Frankly, we do not stop on WordPress, at this very minute we have 5 templates in the queue, where 1 is ecommerce. However, the main course is WordPress indeed. Our research shows that more and more people are opting for a simple yet complex blog or website based on WordPress, this is already both a trend and necessity. If at the beginning WordPress was meant for blogs, now it&#8217;s escalated to pretty big web applications that are using it. At TeslaThemes we can adapt any theme to any needs.</p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesWordPress.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesWordPress.jpg?resize=389%2C146\" alt=\"Tesla Themes WordPress\" class=\"aligncenter size-full wp-image-7295\" /></a></p>\n<p><strong>What is the Tesla Framework?</strong></p>\n<p>Tesla Framework is another one of our proud products. The decision to develop it was unanimous and instant. There are many reason why, first of all we were thinking about our customers who are purchasing our Premium Templates. We’ve noticed that not very many have any technical background, the tickets we were receiving at the time were related rather to lack of technical experience and WordPress knowledge than some technical problems of the theme. At a certain point we had a huge data base of Q&#038;A and decided to build our own Framework, adapting and combining all the issues we’ve got during our daily activity. The end result, without modesty is a brilliant tool that helps anyone to customize its template in a very simple and fun way. We noticed an 85% drop for tickets, since we launched it and all the feedback we get from our customers is just great. Another strong reason to make it was the technical aspect, it increased our theme development up to 40%. Now any Tesla developer can work on any of our themes without any problem, switching whenever is needed, it is a unique platform that saves time and development costs. At the end of the day Tesla Framework was a very inspired decision both for end-users and our developers.</p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesFramework.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesFramework.jpg?resize=500%2C201\" alt=\"TeslaThemes Framework\" class=\"aligncenter size-large wp-image-7296\" /></a></p>\n<p><strong>Theme clubs are a tough way to do business. Many have come and gone. Why have you decided to go with the club route instead of charging $60-$70 per theme?</strong></p>\n<p>That’s correct, Jeff. For sure we will not go for too long with club way. The reason we have so affordable prices for single themes and annual subscription, is lack of financial priority at the moment. Of course we are not Red Cross, we also have bills and want to drive nice cars and nice vacations. All the prices for sure will go up in the next few months. Our design and development department are working now on 5 templates that must come up by middle of July, 2013. The 24/7 support we have, the handcrafted design, uniqueness, they all cost money and I am sure, people want to have really the best and they will buy our themes. </p>\n<p><strong>One of my favorite designs from TeslaThemes is the Cool Stuff theme. What was the inspiration behind the timeline display of content?</strong></p>\n<p>That’s right, Cool Stuff is one of our best sellers. It is very simple and has a modern layout. The idea behind it was very simple, inspired by flat design trend we decided to create our first flat design theme. It was rather from fun, but turned out to be a success. As a matter of fact, 4 out of 5 themes we have in the queue, are flat. The timeline display gives a faster navigation thru the page, saves user’s time and keeps a higher focus on the content. And content is king!</p>\n<div id=\"attachment_7297\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesTimeline.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/TeslaThemesTimeline.jpg?resize=500%2C297\" alt=\"Tesla Themes Timeline\" class=\"size-large wp-image-7297\" /></a><p class=\"wp-caption-text\">Cool way of displaying content via post formats and a timeline</p></div>\n<p><strong>Do you have any opinions on themes bundling plugins whether they are commercial or free?</strong></p>\n<p>I think that bundling plugins (whether they are commercial or free) is not good for the end user. By nature, plugins need to be detached from the framework, because in case something goes wrong the plugin can be deactivated and the user can maintain a working website without losing traffic. On the other side, bundling plugins with a theme means to compel a user to use only one plugin for a given enhancement, when the user could have used another plugin, giving the same functionality, but which the user knows better how to use.</p>\n<p><strong>Why did you decide to license the themes under the same license WordPress has? (GPL V2)</strong></p>\n<p>Because adopting this kind of license for our themes is better than writing our own, and limit what our users can do with their themes. GPL gives a sense of freedom, and clients love to hear that they have the freedom to do whatever they want with their themes after they buy it. In addition, having this license gives us some advantages, like the opportunity to promote our marketplace on WordPress.org </p>\n<p><strong>Anything you would like to say to the WordPress Community?</strong></p>\n<p>To keep up and continue to innovate. Inspiration and satisfaction. The tough market is a risk indeed but let’s see it rather as an opportunity to stand out of the crowd with great service and products. The competition develops and brings real value for everyone.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Z4Euz_XasNc\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 22:19:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WPTavern: Experimental Plugin Review – Inline Preview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7284\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://feedproxy.google.com/~r/WordpressTavern/~3/IqjqafuFxhs/experimental-plugin-review-inline-preview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2162:\"<p><a title=\"http://www.chrisfinke.com/2013/06/11/inline-preview-plugin-for-wordpress/\" href=\"http://www.chrisfinke.com/2013/06/11/inline-preview-plugin-for-wordpress/\">Inline Preview</a> is a brand new plugin being developed by Christopher Finke. Instead of previewing posts in a new browser tab, this plugin adds an editor to the right of the post within the same tab enabling you to see what the post will look like.</p>\n<div id=\"attachment_7288\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/InlinePreview1.jpg\" rel=\"thumbnail\"><img class=\"size-full wp-image-7288\" alt=\"Inline Preview\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/InlinePreview1.jpg?resize=500%2C375\" /></a><p class=\"wp-caption-text\">Editor And Post In The Same Tab</p></div>\n<p>If you end up giving this plugin a try, be warned that once you click the preview button, the only way to close the inline preview area is to either reload the page or save the draft. Once I saw a screenshot of this plugin in action, I was initially excited because this is one of the features I saw in Ghost that intrigued me. However, this plugin is only at the experimental level and I&#8217;m not sure how far Chris is going to take it. But if he plans on putting more development time into it, here are a couple things on my checklist I&#8217;d like to see.</p>\n<ul>\n<li>Have the inline preview only show the content area of the website, no sidebar, no footer, none of the unnecessary details. Since my content area is only 600 pixels wide, it would make better use of my screen real estate.</li>\n<li>Real-time editing so that as I type or add images, I can see how those changes would look on the site.</li>\n<li>The ability to change the width of the post editor and the inline preview so that I can apply a size that works best for my monitor.</li>\n<li>An easy way to close the inline editor without having to reload the entire page.</li>\n</ul>\n<p>Anything else you can think of that would make a plugin like this useful to you?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/IqjqafuFxhs\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 20:31:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WP Android: You’ve Got Notifications!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"http://android.wordpress.org/?p=847\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://android.wordpress.org/2013/06/11/notifications/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3864:\"<p><a href=\"http://android.wordpress.org\"><img src=\"http://wpandroid.files.wordpress.com/2013/05/wordpress-for-android-2-4-wordpress-com-notifications.jpg?w=242&h=491\" alt=\"Version 2.4 of WordPress for Android: Notifications panel on a Samsung Galaxy S3\" width=\"242\" height=\"491\" class=\"alignright size-medium wp-image-861\" /></a>Need to get your WordPress.com or Jetpack notifications on the go? With version 2.4 of <a href=\"https://play.google.com/store/apps/details?id=org.wordpress.android&hl=en\">WordPress for Android</a> you&#8217;ll see all your Notifications right on your Android device.</p>\n<h3 id=\"scroll_to_here\">Step away yet stay connected</h3>\n<p>With the new streamlined Notifications view, you can step away from your computer but still stay connected to your readers. With just a few taps you can:</p>\n<ul>\n<li>Read comments and reply.</li>\n<li>Moderate new pending comments.</li>\n<li>Get stats highlights.</li>\n<li>See your new followers and follow them back.</li>\n<li>See who liked your posts.</li>\n</ul>\n<p>Don’t need so many notifications? You can turn off specific notification types (for example &#8220;Likes&#8221;) in the Settings panel. You can also mute entire blogs if it gets too noisy.</p>\n<p>Self-hosted WordPress.org blogs get to join the party, too! Simply connect your blog using the <a href=\"http://jetpack.me\">Jetpack plugin</a> and your self-hosted blog&#8217;s notifications will appear. Already have Jetpack set up? Then you don&#8217;t need to do a thing.</p>\n<div id=\"attachment_867\" class=\"wp-caption aligncenter\"><a href=\"http://wpandroid.files.wordpress.com/2013/05/wordpress-for-android-notification-center-pending.png\"><img src=\"http://wpandroid.files.wordpress.com/2013/05/wordpress-for-android-notification-center-pending.png?w=300&h=78\" alt=\"Pending notifications in the notification center\" width=\"300\" height=\"78\" class=\"size-medium wp-image-867\" /></a><p class=\"wp-caption-text\">See what&#8217;s going on with your blog quickly.</p></div>\n<div id=\"attachment_868\" class=\"wp-caption aligncenter\"><a href=\"http://wpandroid.files.wordpress.com/2013/05/wordpress-for-android-reply-to-comment-from-notification-center.png\"><img src=\"http://wpandroid.files.wordpress.com/2013/05/wordpress-for-android-reply-to-comment-from-notification-center.png?w=300&h=132\" alt=\"Replying to comments from the notification center\" width=\"300\" height=\"132\" class=\"size-medium wp-image-868\" /></a><p class=\"wp-caption-text\">Reply to comments with ease.</p></div>\n<h3>Additional improvements and bug fixes</h3>\n<p>We also added a few more nifty features in this release:</p>\n<ul>\n<li>A new menu icon has been added that matches up with the latest &#8216;Holo&#8217; design guidelines.</li>\n<li>Settings and Sign out options have been added to the overflow menu for easier access.</li>\n<li>New fonts added for easier readability.</li>\n<li>&#8230; and many more small bug fixes and reliability improvements.</li>\n</ul>\n<h3>What&#8217;s next?</h3>\n<p>We&#8217;ve got some great new features in the works including improvements to Media, Account Setup, and the Reader.</p>\n<p>A huge thanks to the contributors that worked on this release: <a href=\"http://wordpress.org/support/profile/beaucollins\">beaucollins</a>, <a href=\"http://wordpress.org/support/profile/daniloercoli\">daniloercoli</a>, <a href=\"http://wordpress.org/support/profile/mrroundhill\">mrroundhill</a>, <a href=\"http://wordpress.org/support/profile/isaackeyet\">isaackeyet</a>, and <a href=\"http://wordpress.org/support/profile/aagam94\">aagam94</a>.</p>\n<p>How do you like the new Notifications? Drop a comment here or follow us <a href=\"http://twitter.com/wpandroid\">@WPAndroid</a> to let us know!</p>\n<br />  <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=android.wordpress.org&blog=9426921&post=847&subd=wpandroid&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 19:28:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:3:\"Dan\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Interview With Internet Marketer Kevin Muldoon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7269\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:108:\"http://feedproxy.google.com/~r/WordpressTavern/~3/BHMHzDo53Fg/interview-with-internet-marketer-kevin-muldoon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:12146:\"<p><strong>Tell us who you are and how long you&#8217;ve been using WordPress.</strong></p>\n<p>My name is Kevin Muldoon. I am a writer, blogger and internet marketer. I am from Scotland but for the last two years I have been living in South America.</p>\n<p>I first tried WordPress in 2006. During that year I had tried just about every blogging script out there. The one I chose to use for my travel blog was Serendipity. I had been using CMS&#8217;s for several years so I started looking more into using blogging platforms to create small content websites. Eventually, that led me to WordPress and I have used it ever since. <span id=\"more-7269\"></span></p>\n<p><strong>I discovered you through BloggingTips.com. Every time I see your name, it&#8217;s behind a different blog. Are you in the business of creating and selling websites?</strong></p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/BloggingtipsLogo.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-full wp-image-7271\" alt=\"BloggingTips Logo\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/BloggingtipsLogo.jpg?resize=285%2C100\" /></a></p>\n<p>I have sold hundreds of websites over the years, though it is not something I always set out to do. When I sold <a title=\"http://www.bloggingtips.com/\" href=\"http://www.bloggingtips.com/\">BloggingTips</a> at the beginning of 2010, I had been working on it every day for 3 years. I was keen to do something else. My next blog, <a title=\"http://www.wphub.com\" href=\"http://www.wphub.com\">WP Mods</a>, was sold in part because of an upcoming trip throughout South America and partly to free up more time to work on other websites I was developing.</p>\n<p>To date I have over $200k worth of sales on Flippa, but I wouldn&#8217;t consider myself a website flipper. All of the websites I have sold have been developed from scratch by me.</p>\n<p><strong>I understand you make a substantial amount of your income from your work online. From your experience, which revenue generating technique has garnered the most cash?</strong></p>\n<p>I make 100% of my income online. I started working online in 2000. I was working in Finance at the time and would work on websites at night. I probably made a few hundred dollars a month, which was never enough to leave my full time job. I did make a few good sales from domains. One time in 2002 I bought a domain name at work at 8.30am and sold it at 12.00pm for around $300-$400. I had bigger sales but that was probably the most satisfying due to how quickly I turned a profit.</p>\n<p>Around 2004 I started making enough to work full time online. All of my money was coming from affiliate commissions. At the height of the gambling craze I was making over $20,000 a month. That helped pay off some debts from university and allowed some fun trips around the world.</p>\n<p>Today, I still make most of my money from affiliate referrals, adsense and banner ad sales. I am starting to make money from selling books and I earn money from freelance writing too.</p>\n<p><strong>Back in May of 2009, you and Sarah started a WordPress theme club titled appropriately enough, <a title=\"http://www.blogthemesclub.com/\" href=\"http://www.blogthemesclub.com/\">BlogThemesClub.com</a>. Whatever happened to the club and what valuable lessons did you learn from that experience?</strong></p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/BlogThemesClubLogo.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-full wp-image-7272\" alt=\"blogthemesclub\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/BlogThemesClubLogo.jpg?resize=444%2C111\" /></a></p>\n<p>haha We sold that one too :)</p>\n<p>That site developed out of BloggingTips.com. Through that site I had released several WordPress themes to the community free. We then looked into releasing premium designs to blog readers but later decided that it would be better long term to sell themes from a new domain.</p>\n<p>I am primarily a writer/marketer and Sarah is primarily a coder. Due to this, we had to outsource all the design work. This was not without its difficulties. Looking back, we probably should have brought in a designer as a partner from the start. That would have allowed us to develop themes quicker. I am sure we could have made it a success if we stuck to it though we decided to cut our losses and move on as we were spending a lot of time on it.</p>\n<p>It was a good experience and I did learn a lot from running a membership driven website and with working with a partner, so it is not something look back on with regret.</p>\n<p><strong>Do you find it difficult to generate content for your various sites or does it come natural?</strong></p>\n<p>No. That is something that I have never had a problem with. Never have, never will. I am always reading other blogs and I buy books regularly too, so I am never short of ideas. My personal blog <a title=\"http://www.kevinmuldoon.com\" href=\"http://www.kevinmuldoon.com\">KevinMuldoon.com</a> currently has 125 draft posts, all of which are partly written or have details of what needs to be written.</p>\n<p>The main problem is time to actually write. Over the next few months I need to greatly reduce my own writing responsibilities and bring in others to help me maintain my websites and blogs.</p>\n<p><strong>Obviously you&#8217;re only one person. What tips can you provide for those looking to hire people to write for their site?</strong></p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPModsLogo.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-full wp-image-7273\" alt=\"WPMods Logo\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPModsLogo.jpg?resize=258%2C69\" /></a></p>\n<p>Unless you want your website or blog to always remain at the same level, you need to bring people in to help you. With BloggingTips.com I had over a dozen people writing regularly. By the time I sold WPMods.com I had two or three people helping me write articles.</p>\n<p>Obviously, getting the right people is key. It can be tempting to just get the cheapest writers but you need to remember that sometimes a badly written post is worse than having no post published at all. At the start it can be a balancing act trying to keep writing costs down and turn a profit, but long term it is worth it. Generally speaking, I would rather spend money on hiring good writers than spending money on an advertising campaign or some SEO service.</p>\n<p>As you rightly point out, there is only one of me, so for me to move on and do other things, I need to hire other people. There is no other way round it. The old idiom &#8220;<strong>hire people smarter than you</strong>&#8221; definitely runs true, and once they know what you are looking for, you should feel comfortable letting them get on with their job. Spending too much time micro-managing them can be counter-productive.</p>\n<p><strong>What is it about WordPress that has you using it for just about every site you create?</strong></p>\n<p>Possibility.</p>\n<p>No other platform out there, blogging or otherwise, comes even close to offering the same level of customization that WordPress does. Can you think of any other platform that offers thousands and thousands of free and premium plugins and themes?</p>\n<p><strong>What is your biggest pet peeve with WordPress?</strong></p>\n<p>I would say it is that every plugin developer out there wants to hijack my admin area and place a large menu link on my admin sidebar. There are plugins that only take two minutes to set up and then you never need to configure them again, yet they hog my sidebar. All major plugin developers, including Automattic, seem to be doing this.</p>\n<p>I am aware that there are plugins out there that let me remove links from the main menu and put them somewhere else, however I do not feel that WordPress users should need to do this. Why should we have to go to the hassle of cleaning up their mess?</p>\n<p><strong>Where would you like to see WordPress 5 years from now?</strong></p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2009/02/wordpresslogo.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2009/02/wordpresslogo.png?resize=150%2C150\" alt=\"wordpresslogo\" class=\"aligncenter size-thumbnail wp-image-422\" /></a></p>\n<p>I like the fact that WordPress has started removing things like blogrolls and adding them back as plugins. The core version should not be too bloated.</p>\n<p>The problem is that there is so much functionality lacking from the core that you end up installing lots of plugins, thereby slowing down your site. Take commenting for example, WordPress blogs suffer from spam so badly that you need to install Akismet right off the bat. Then you need to install at least one additional plugin to reduce spam, whether it be to add a CAPTCHA field or trick bots into thinking they have completed all fields.</p>\n<p>Many people have turned to third-party commenting systems to address this, though they are not always ideal either. So, like many people, I have started using Jetpack for my comments. It works great, but using that plugin means that I a need to install many other things that I do not want installed.</p>\n<p>The same thing can be said about security. I have had a few of my blogs infected with malware over the last year so I now install security plugins on every WordPress website I own. It would be better if WordPress tackled this problem head on and make the product more secure. I understand that WordPress is always going to be targeted more than other platforms due to its popularity, though when it comes to the point of needing to install anti-spam and anti-malware plugins every time they use WordPress, you need to step back and think about whether the core product needs to be upgraded.</p>\n<p>Today, I have over a dozen plugins that I install on every website. I review the plugins I have installed regularly, though a quick check on my personal blog shows that I have 37 activated plugins. Many of these plugins address problems with other plugins or problems with the core. For example, I have&nbsp;Manual Control for Jetpack to stop the Jetpack plugin automatically enabling new modules they add and I have&nbsp;WP Missed Schedule installed to stop WordPress not publishing my articles on time (and never sending me an email to notify me of this).</p>\n<p>Last but not least, I think that WordPress is starting to look dated in some respects. Without doubt it is functional, but along the way it has lost its style. I use the WordPress iOS app regularly and it works great, however accessing WordPress through my browser seems clunky at times.</p>\n<p>WordPress has become the number one content management system in the world, though I think there is a danger of it losing its title as the best blogging platform. New blog platforms such as SquareSpace and Ghost are simplifying the whole process of blogging and allowing people to focus more on content instead of worrying about spam, viruses and configuring cache plugins.</p>\n<p>Competition is good and I hope that WordPress can take the best features of these new platforms and integrate it into their own platform.</p>\n<p><strong>Anything you&#8217;d like to say to the entire WordPress community?</strong></p>\n<p>I would encourage people to support plugin and theme developers where they can; whether it be telling others of their good work, making a donation or upgrading to their premium products. That being said, I also think WordPress users are allowed to be critical, even of those who release products for free. As a content producer, I understand why many developers get touchy about criticism, though it is essential to their products, and WordPress as a whole, getting better.</p>\n<p>So be supportive and be critical about something if you need to be, though make sure you are polite and professional when you do so. Those who complain for the sake of complaining deserve to be ignored :)</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/BHMHzDo53Fg\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 16:48:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"WPTavern: Recap Of WordCamp Milwaukee 2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7264\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://feedproxy.google.com/~r/WordpressTavern/~3/JbJHpoCeOY4/recap-of-wordcamp-milwaukee-2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:850:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WordCampMilwaukee2013Logo.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WordCampMilwaukee2013Logo.jpg?resize=216%2C108\" alt=\"WordCamp Milwaukee 2013 Logo\" class=\"alignright size-full wp-image-7265\" /></a>This past weekend, WordCamp Milwaukee 2013 took place. If you missed it, Brad Parbs has a <a href=\"http://snowdaygroup.com/wordcamp-milwaukee-2013-recap/\" title=\"http://snowdaygroup.com/wordcamp-milwaukee-2013-recap/\">short recap of the event</a> complete with links to a bunch of different slides from presentations. With over 300 attendees this go around, I congratulate the event organizers on another successful WordCamp. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/JbJHpoCeOY4\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Jun 2013 01:18:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:136:\"WordPress.tv: John Botte, Jason Narciso, Michael Chevalier, Lindsay Logan, Valerie: Panel on Developer/Designer/Strategist Communication\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19685\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:147:\"http://wordpress.tv/2013/06/10/john-botte-jason-narciso-michael-chevalier-lindsay-logan-valerie-panel-on-developerdesignerstrategist-communication/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:816:\"<div id=\"v-9XodB73t-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19685/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19685/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19685&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/10/john-botte-jason-narciso-michael-chevalier-lindsay-logan-valerie-panel-on-developerdesignerstrategist-communication/\"><img alt=\"John Botte, Jason Narciso, Michael Chevalier, Lindsay Logan, Valerie: Panel on Developer/Designer/Strategist Communication\" src=\"http://videos.videopress.com/9XodB73t/video-6718bc6c03_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 23:15:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WordPress.tv: Kylie Gusset: Dis [content] – A Panel on Blog Content\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19578\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://wordpress.tv/2013/06/10/kylie-gusset-dis-content-a-panel-on-blog-content/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:686:\"<div id=\"v-Qx2au1Vr-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19578/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19578/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19578&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/10/kylie-gusset-dis-content-a-panel-on-blog-content/\"><img alt=\"Kylie Gusset: Dis [content] &#8211; A Panel on Blog Content\" src=\"http://videos.videopress.com/Qx2au1Vr/video-b3f9e95ecd_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 18:35:39 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WordPress.tv: Aaron Ware: From Employee to Freelance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19675\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2013/06/09/aaron-ware-from-employee-to-freelance/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:654:\"<div id=\"v-7CYfHYk0-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19675/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19675/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19675&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/09/aaron-ware-from-employee-to-freelance/\"><img alt=\"Aaron Ware: From Employee to Freelance\" src=\"http://videos.videopress.com/7CYfHYk0/video-4058fa5bdf_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 18:30:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: When Commercial Themes Bundle Commercial Plugins, Users Lose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7255\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"http://feedproxy.google.com/~r/WordpressTavern/~3/0ZyY80tRsrU/when-commercial-themes-bundle-commercial-plugins-users-lose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6543:\"<p>Coen Jacobs developer for WooThemes has used his personal site to vent about <a title=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/\" href=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/\">commercial themes bundling commercial plugins</a>. There were at least two themes hosted on the ThemeForest marketplace that were bundling commercial WooThemes plugins along with a copy of GravityForms. Those themes have been <a title=\"http://themeforest.net/forums/thread/bundling-premium-gpl-plugins-on-themeforest-themes/100141\" href=\"http://themeforest.net/forums/thread/bundling-premium-gpl-plugins-on-themeforest-themes/100141\">temporarily hidden from view by ThemeForest</a> until they comply with revised guidelines. This is a great article filled with a number of great points but the comments are just as good.</p>\n<p><strong>It&#8217;s Just A Bad Idea</strong> &#8211; Bundling plugins with themes is already a bad practice but when those plugins have a commercial nature to them and need API access keys to work properly, it becomes an incredibly bad idea.</p>\n<p><strong>Support Nightmare</strong> &#8211; I love the infinite loop for support described by Coen so much, I&#8217;m just going to paste it here as it clearly illustrates how bad it can be for users to get support.</p>\n<ol>\n<li>The author of the plugin is WooThemes. “They should help me, right?”</li>\n<li>Wrong, they can’t help you. You haven’t purchased the plugin from WooThemes, so they can’t support you. This is not just because you haven’t purchased it from them, but they also have no way of knowing what’s been done with the code. This makes it virtually impossible to support the code.</li>\n<li>The WooThemes support crew will probably tell you to ask the theme author.</li>\n<li>The theme author has no real ways of supporting the plugins they bundle with the theme, simply because they didn’t write the plugin.</li>\n<li>The initial response of the theme author is often to contact the author of the plugin. Resume these steps at #1, infinite loop!</li>\n</ol>\n<p><strong>GPL</strong> &#8211; People are still confused when they see a theme or plugin licensed under the <a title=\"http://wordpress.org/about/gpl/\" href=\"http://wordpress.org/about/gpl/\">GPL</a> and then see licenses that specify the number of websites the plugin can be used on. Being licensed under the GPLv2 means the code is freely available and can be modified or redistributed. During the checkout process, if the word <em>restrict</em> is in the description it generates <em>red flags</em>. It&#8217;s important to note that most commercial GPL theme/plugin licenses deal strictly with how many sites will be supported by them based on which support license you buy. In some instances such as GravityForms, you&#8217;re not only purchasing a support license, but also an API access key that provides access to updates and other functionality. The API aspects of GravityForms have nothing to do with GPL. As <a title=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/#comment-9401\" href=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/#comment-9401\">Carl Hancock points out</a>, look at Akismet, VaultPress, or WordPress.com as good examples of plugins that are GPL but the features they offer are through an API/service which is not accessible because it&#8217;s a software as a service model.</p>\n<p>It&#8217;s important to note that redistributing any themes or plugins licensed under the GPL commercial or not for free or for a price is completely within the confines of the license as long as proper attribution is maintained and the copyright notice is left in tact. What the two themes on ThemeForest were doing was not illegal.</p>\n<p><strong>Abuse Of The Unlimited Sites License</strong> &#8211; This is an interesting one. Using GravityForms as an example, if you buy the unlimited sites option, you&#8217;ll have support for unlimited sites, support multi-site, have unlimited forms, unlimited entries, 1 year of updates, etc. <a title=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/#comment-9296\" href=\"http://coenjacobs.me/en/dont-buy-bundled-premium-plugins/#comment-9296\">According to Simone</a>, team leader of Your Inspiration Themes, they had purchased a Developer License granting them the ability to install GravityForms on an unlimited amount of sites. They were bundling GravityForms with their themes but in order for customers to receive upgrades, they would push out a new theme update which included the newest version of GravityForms.</p>\n<p>I have to give Simone credit for coming up with a somewhat creative way of being able to offer GForms updates without their theme customers needing to have an individual access key. However, because of how GravityForms works, they have the ability to turn off keys if they discover they  are used in such a way that <a title=\"http://www.gravityforms.com/terms-and-conditions/\" href=\"http://www.gravityforms.com/terms-and-conditions/\">violates their TOS</a>.</p>\n<p><strong>Not Getting What You Paid For</strong> &#8211; According to Simone, by bundling plugins like GForms in their themes, they are offering value. In reality, the are offering headaches. The following paragraph in Simone&#8217;s response is important to take note of.</p>\n<blockquote><p>Keep in mind that we are not re-selling the plugins and above all we don’t provide key licenses to our customers. When an update of those plugins is released, we will as soon as possible release a new theme update with the new version of the plugin. We know how important is to keep updated the WordPress installation.</p></blockquote>\n<p>When customers buy their themes, they&#8217;re not actually buying the plugins that are bundled with them. If that&#8217;s the case, why bother bundling the plugins at all? The only conclusion I can come to is that they are ripping off GravityForms and others while providing so called value to their customers.</p>\n<h2>Conclusion:</h2>\n<p>I hope YIT and ThemeForest have both learned their lesson in this ordeal. ThemeForest needs to tighten up its theme reviewing process. YIT needs to remove the commercial plugins until they can strike a unique reseller deal with both GForms and WooThemes. Since Simone claims their themes sold well without having any plugins, I hope they remove them because the overall practice of bundling plugins with themes is stupid.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/0ZyY80tRsrU\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 16:11:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WordPress.tv: Brian Casel: Building Your Niche Freelance Business With WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19665\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"http://wordpress.tv/2013/06/09/brian-casel-building-your-niche-freelance-business-with-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:710:\"<div id=\"v-feHnr6Fp-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19665/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19665/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19665&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/09/brian-casel-building-your-niche-freelance-business-with-wordpress/\"><img alt=\"Brian Casel: Building Your Niche Freelance Business With WordPress\" src=\"http://videos.videopress.com/feHnr6Fp/video-85c225c8b6_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 09 Jun 2013 13:26:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WordPress.tv: Jordan Gillman: Know Enough to Be Dangerous – Tweaking your WordPress Site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19574\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wordpress.tv/2013/06/08/jordan-gillman-know-enough-to-be-dangerous-tweaking-your-wordpress-site/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:730:\"<div id=\"v-3Sn0CBOx-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19574/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19574/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19574&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/08/jordan-gillman-know-enough-to-be-dangerous-tweaking-your-wordpress-site/\"><img alt=\"Jordan Gillman: Know Enough to Be Dangerous &#8211; Tweaking your WordPress Site\" src=\"http://videos.videopress.com/3Sn0CBOx/video-9a58d82171_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 09 Jun 2013 04:00:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WordPress.tv: Michael McKinnon: Hackers Ahoy! Batten Down The Hatches\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19600\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.tv/2013/06/08/michael-mckinnon-hackers-ahoy-batten-down-the-hatches/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:693:\"<div id=\"v-tEjvFYy4-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19600/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19600/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19600&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/08/michael-mckinnon-hackers-ahoy-batten-down-the-hatches/\"><img alt=\"Michael McKinnon: Hackers Ahoy! Batten Down The Hatches\" src=\"http://videos.videopress.com/tEjvFYy4/video-15d63849f6_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 09 Jun 2013 03:52:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WPTavern: Pretty WordPress Template Hierarchy Diagram\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7248\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://feedproxy.google.com/~r/WordpressTavern/~3/S8mjpUAuI8M/pretty-wordpress-template-hierarchy-diagram\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2171:\"<p>If there has been one graphical element that has seen some changes over the years, it&#8217;s the template hierarchy diagram. The <a title=\"http://codex.wordpress.org/Template_Hierarchy\" href=\"http://codex.wordpress.org/Template_Hierarchy\">original diagram</a> is located on the Codex and while it provides a graphical representation as to how Templates work within WordPress, it&#8217;s not pretty. I remember in 2008 when Michael Castilla took the original concept and simply <a title=\"http://wpcandy.com/teaches/wordpress-template-hierarchy-diagram/\" href=\"http://wpcandy.com/teaches/wordpress-template-hierarchy-diagram/\">added some style</a> to it. A few years later, Chip Bennett <a title=\"http://www.chipbennett.net/themes/template-hierarchy/wordpresstemplatehierarchy-rev-8/\" href=\"http://www.chipbennett.net/themes/template-hierarchy/wordpresstemplatehierarchy-rev-8/\">added detailed information</a> to the diagram. Just last month, <a title=\"http://wpdaily.co/wp-template-hierarchy-chart/\" href=\"http://wpdaily.co/wp-template-hierarchy-chart/\">Michelle created</a> a colorful version of the diagram.</p>\n<p>That brings us to the current day where Rami Abraham has taken Michelle&#8217;s colorful design and has not only been given its <a title=\"http://wphierarchy.com/\" href=\"http://wphierarchy.com/\">own domain name</a>, but has also made it interactive.</p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/PrettyTemplateHierarchy.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-large wp-image-7249\" alt=\"WordPress Template Hierarchy\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/PrettyTemplateHierarchy.jpg?resize=500%2C218\" /></a></p>\n<p>The core information remains the same but now if you click on any one of the various parts of the diagram, it will take you to the appropriate Codex page. Between the various diagrams and the Codex, there is no way of <strong>not</strong> knowing what goes on within the WordPress template process.</p>\n<p>Which template hierarchy resource do you find the most useful?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/S8mjpUAuI8M\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Jun 2013 15:34:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: How To Adopt A Plugin Or Put It Up For Adoption\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7244\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://feedproxy.google.com/~r/WordpressTavern/~3/GXyv4sYRk-s/how-to-adopt-a-plugin-or-put-it-up-for-adoption\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5272:\"<p>The other day, I was performing a plugin search for something to help me remove all the Post Revisions I had accumulated over the past few months as part of my clean-up process. Unfortunately, the plugin I used in the past was no longer available but it&#8217;s how I found that out that was the interesting thing. While the plugin was listed, the description said the plugin was empty and no long available. Just for giggles, I tried to install the plugin and nothing happened. Upon looking at the <a href=\"http://plugins.trac.wordpress.org/changeset/431935/delete-post-revisions\" title=\"http://plugins.trac.wordpress.org/changeset/431935/delete-post-revisions\">Trac changes for the plugin</a>, the last thing the plugin author did was delete all the files. After getting in touch with Otto about the plugin showing up in search results, he removed it but told me it wasn&#8217;t the proper way to go about closing a plugin down. So what is the proper way?</p>\n<h2>How To Orphan A Plugin:</h2>\n<p>Plugin authors have the ability to not only add other authors to the commit team but also hand over the entire plugin to someone else. Removing all the code related to the plugin is frowned upon because someone else could use that code either as a fork or the foundation for a similar type of plugin. But if you really want to have your plugin removed from the repository, sending an email to plugins@wordpress.org with your request should do the trick. If a plugin author decides to orphan a plugin that I&#8217;m using, I would really appreciate it if in the last update, somewhere within the readme or change log it stated that it would be the last version released and that it would no longer be supported. This would give ample opportunity for me to look at alternative plugins. </p>\n<h2>Adopting A Plugin:</h2>\n<p>There currently is no official way to adopt someone&#8217;s plugin. There has been some discussion in the past about creating an orphaned plugin program but those ideas never materialized. One of the reasons why the program never saw the light of day is because there were so few people wanting to adopt a plugin. Otto recommends trying to contact the author, and if that fails, email the plugins team plugins@wordpress.org. Show that you have code changes already made, as a good will thing, because what we don&#8217;t want is somebody taking over a plugin and making just superficial changes while putting their own name on it, sort of thing. So the plugins team verifies the code, tries to contact the original author, wait a reasonable time, etc. </p>\n<h2>WP Recycle:</h2>\n<p>There used to be a third party site that dealt exclusively with abandoned plugins called <a href=\"http://www.noupe.com/wordpress/wp-recycle-fresh-perpectives-for-starving-wordpress-plugins-73451.html\" title=\"http://www.noupe.com/wordpress/wp-recycle-fresh-perpectives-for-starving-wordpress-plugins-73451.html\">WPRecycle</a>. It was an offshoot of Pluginchief.com but it looks like the website has since gone offline. I&#8217;m going to try to get in touch with those behind WPRecycle to figure out why the program failed or why the site has gone offline. </p>\n<p>While researching for this post, I came across <a href=\"http://digwp.com/2012/10/abandoned-plugin-adoption-program/\" title=\"http://digwp.com/2012/10/abandoned-plugin-adoption-program/\">an article</a> published by Matt Jones on the Digwp website. Even though it was a pitch for the WPRecycle program, he <a href=\"http://digwp.com/wp-content/uploads/2012/10/infographic-abandoned-wp-plugins.jpg\" title=\"http://digwp.com/wp-content/uploads/2012/10/infographic-abandoned-wp-plugins.jpg\">came up with a stat that</a> showed 1/3 of the plugin repository at that time had the 2 year update warning. I wonder what those numbers are like today with 25,369 plugins in the repository.</p>\n<p>It&#8217;s worth noting that a plugin update can occur with no code changes taking place. If only a readme file of a plugin was changed this would count as an update and would reset the 2 year warning. </p>\n<h2>Just What Is Abandonment?</h2>\n<p>It&#8217;s hard to talk about plugin abandonment because there are no hard set rules that dictate when a plugin is officially abandoned. This was one of the biggest problems the core team faced when they discussed the requirements needed for a plugin to reach this status. A plugin with good code that doesn&#8217;t need to be updated for extended periods of time could be considered abandoned even though it wouldn&#8217;t be. </p>\n<p>Do you think orphaned plugins is a growing concern or is there a natural process in place that prevents this from ever becoming a serious problem? I would only consider it a serious problem if we reach a statistic where 50% or more of the plugins in the repository are abandoned. However, what if the total amount of plugins in the repository is 50,000 and 50% of those are dead? That still leaves us with 25,000 active plugins. What would the numbers have to be for a tipping point of users not finding the extensibility that has helped make WordPress as popular as it is today?</p>\n<p>Let&#8217;s continue this conversation in the comments. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/GXyv4sYRk-s\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Jun 2013 13:26:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"WordPress.tv: David Jenyns: WordPress and Video SEO\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19568\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.tv/2013/06/07/david-jenyns-wordpress-and-video-seo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:652:\"<div id=\"v-Bwuk5oEB-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19568/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19568/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19568&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/07/david-jenyns-wordpress-and-video-seo/\"><img alt=\"David Jenyns: WordPress and Video SEO\" src=\"http://videos.videopress.com/Bwuk5oEB/video-e4875b0ed4_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Jun 2013 11:46:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"WordPress.tv: Warren Denley: WordPress 101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19562\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.tv/2013/06/07/warren-denley-wordpress-101/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:634:\"<div id=\"v-vrBc5nsT-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19562/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19562/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19562&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/07/warren-denley-wordpress-101/\"><img alt=\"Warren Denley: WordPress 101\" src=\"http://videos.videopress.com/vrBc5nsT/video-ce94ba4e3b_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Jun 2013 11:07:17 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"Lorelle on WP: Help Spread the Word – Writing for the Web Class\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"http://lorelle.wordpress.com/?p=8785\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://lorelle.wordpress.com/2013/06/06/help-spread-the-word-writing-for-the-web-class/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:506:\"There is still room available in my Writing for the Web course at Clark College Corporate and Continuing Education in Vancouver, Washington, just across the river from Portland, Oregon. This professional development course runs from June 11 &#8211; 27, 2013 on Tuesdays and Thursdays from 9AM &#8211; Noon. The class size is limited so there [&#8230;]<img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=lorelle.wordpress.com&blog=72&post=8785&subd=lorelle&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 20:32:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Lorelle VanFossen\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WPTavern: Where Are They Now? – Len Kutchma Of WPCanada\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7234\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://feedproxy.google.com/~r/WordpressTavern/~3/oPB4PctF8rc/where-are-they-now-len-kutchma-of-wpcanada\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8524:\"<p>Since launching WPTavern.com, I&#8217;ve had the distinct pleasure to watch people become a part of this community with very little WordPress knowledge and within a few years, either work for themselves or for an established WordPress centric company. This new series will highlight folks that have been a part of the WPTavern community since the beginning to find out what they&#8217;re up to and what role, if any, WPTavern played in their success.  </p>\n<h2>The Interview:</h2>\n<p><strong>First off Len, can you tell us a little bit about yourself and what you&#8217;re up to these days?</strong></p>\n<p>I was born in Winnipeg back in &#8217;64 (yes, I&#8217;m that old) and moved to a small town in my late teens. I returned to Winnipeg about 30 years later, which is where I am now. I&#8217;ve worked in various fields including being self-employed for 13 years.</p>\n<p>I&#8217;ve been online in some form since 1999-2000. I started out by building my own static HTML sites. Like so many others I soon moved on to GeoCities and Tripod etc eventually settling on Blogger when it was still owned by Pyra Labs.</p>\n<p>I think it was 2006 when I quite accidentally discovered WordPress while surfing the web. I believe it was v2.0.4 and I was hooked! I immediately bought a hosting package, set up WordPress and haven&#8217;t looked back since.</p>\n<p>I was always on the search for new WordPress-centric sites and would pursue the Codex everyday in my search for knowledge. Before I knew it I started to help out in the WordPress support forums.</p>\n<p>These days I&#8217;m employed in the roofing/construction field although I would really like to move on to something else, what that is I have no idea. I still blog although not as often as I would like. Life keeps getting in the way.</p>\n<p><strong>Why did you decide to join the WPTavern forum in 2009?</strong></p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaJoinDate.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaJoinDate.jpg?resize=243%2C137\" alt=\"Len Kutchma Join Date\" class=\"aligncenter size-full wp-image-7236\" /></a></p>\n<p>I decided to join WPTavern back in 2009 for 2 reasons: a) I was eager to learn as much about WordPress as I could and b) I could see that the Tavern was going to become a thriving community and a rich source of information.</p>\n<p><strong>How did the WPTavern community help you progress with WordPress in the past 4 years?</strong></p>\n<p>This ties into my previous answer. When you&#8217;re passionate about something be it software or whatever else you can learn so much more by rubbing elbows and hanging out with others who share your passion. The Tavern forum quickly grew into a huge database of knowledge as I knew it would. Because of the social aspect of forums you just learn so much by reading various threads and by participating in discussions. More importantly the atmosphere was laid back and fun as opposed to a support forum. When you&#8217;re having fun you learn much more quickly.</p>\n<p><strong>What was your involvement with WeblogToolsCollection.com? </strong></p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaWeblogToolsCollection.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaWeblogToolsCollection.jpg?resize=500%2C124\" alt=\"Len Helping Out On Weblogtoolscollection\" class=\"aligncenter size-large wp-image-7237\" /></a></p>\n<p>My involvement with <a title=\"http://weblogtoolscollection.com/\" href=\"http://weblogtoolscollection.com/\">WeblogToolsCollection.com</a>. As I said earlier, I stumbled upon WordPress back in 2006 and started to search for WordPress-centric sites. That search led me to WeblogToolsCollection.com which at that time was the première WordPress-centric site. I visited the site every day including the forum. I soon gained an interest in WordPress themes. I started to help out in the WLTC forums by meticulously inspecting the various theme submissions. Mark Ghosh noticed my efforts and eventually made me an administrator in the forum. Prior to a new theme release being published on the main site it had to first pass my inspection in the forum where it was initially submitted. Of course I had help, there were a few others doing what I did, I was not alone.</p>\n<p>After some time I began to fill in as an author on the main site here and there when the regulars were on vacation etc.</p>\n<p>After a few years my involvement with the site began to wane, not because I lost interest, but because real life began to take over. My increasingly busy schedule in the real world left little to no time for the virtual one.</p>\n<p><strong>You have your own WordPress centric site now called WPCanada.ca is the site still active and what are your plans with it?</strong></p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaWPCanada.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/LenKutchmaWPCanada.jpg?resize=321%2C112\" alt=\"WPCanada Logo\" class=\"aligncenter size-full wp-image-7238\" /></a></p>\n<p>I have my own WordPress-centric site at <a title=\"http://WPCanada.ca\" href=\"http://WPCanada.ca\">WPCanada.ca</a> as well as a personal blog at <a title=\"http://lenkutchma.com/\" href=\"http://lenkutchma.com/\">LenKutchma.com</a>. Additionally I use WordPress multisite to showcase the various child themes I&#8217;ve built for the Genesis framework by StudioPress.&nbsp; <a href=\"http://demo.wpcanada.ca/\">http://demo.wpcanada.ca/</a></p>\n<p>The site is still active although I haven&#8217;t done much blogging lately. It&#8217;s been some time since I released a new Genesis child theme as well. The reason for this is, as I have stated above, is my busy schedule. When I get home at 8pm after putting in a 12 hour day it&#8217;s already 9pm by the time I have a shower and eat dinner. By then I&#8217;m exhausted and blogging or building a theme is the furthest thing from my mind.</p>\n<p>I plan to keep on blogging and building themes because I enjoy it. However I can only do so as time allows. It&#8217;s that darn &#8220;real life getting in the way&#8221; thing again.</p>\n<p><strong>Have you had a chance to attend a Canadian WordCamp? What&#8217;s the enthusiasm like up there for WordPress?</strong></p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WordCampWinnipegLogo2013.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WordCampWinnipegLogo2013.jpg?resize=500%2C118\" alt=\"WordCamp Winnipeg2013 Logo\" class=\"aligncenter size-large wp-image-7239\" /></a></p>\n<p>I&#8217;ve never been to a WordCamp. Ironically we had a WordCamp up here in my hometown of Winnipeg this past weekend. It was the first time Winnipeg has played host to a WordCamp. Unfortunately I was out of town for a few days in Ontario and could not make it. It was organized by Automattician and fellow Winnipegger Ian Stewart and from what I understand he did a fabulous job!</p>\n<p>There is a large and active WordPress community up here as evidenced by the regular local WordPress Meetups. The first time I attended a local meetup I was surprised by how many people shared my passion for WordPress.</p>\n<p><strong>Is there anything you&#8217;d like to say to the general WordPress Community?</strong></p>\n<p>What would I like to say to the General WordPress Community? I suppose this is where I say something deep and profound but alas that is not the case. Although I think the software is great I think the community that has developed around it is greater. I&#8217;ve had the chance to meet some wonderful people and make some cool friends. It is the community that makes WordPress what it is. You can develop the greatest product or service known to man but if no one notices or is interested it is destined to fail. In the WordPress Community I see people going out of their way to help others. In the end that is what life is about.</p>\n<p>Whether you are a theme author, plugin developer, doc writer, core contributor, forum helper, WordPress news publisher etc, the contributions are what make WordPress what it is. And it is these people who make the WordPress Community the most awesome community I&#8217;ve ever been involved with. To everyone I say thank you!</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/oPB4PctF8rc\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 18:25:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Alex King: Social 2.9.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=17083\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://alexking.org/blog/2013/06/06/social-2-9-1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1853:\".threads-post-notice {\n	background: #e8e8e8;\n	padding: 10px;\n}\n.threads-post-notice a {\n	font-weight: bold;\n}\n\n<p>We&#8217;ve released version 2.9.1 of <a href=\"http://wordpress.org/plugins/social\">Social</a>; a WordPress plugin from <a href=\"http://mailchimp.com\">MailChimp</a> that gives you these great features:</p>\n<ol>\n<li>broadcasting your posts to Facebook and Twitter</li>\n<li>allows commenters on your site to log in with Facebook or Twitter</li>\n<li>allows comments on your site to be broadcast to Facebook or Twitter</li>\n<li>pulls in reactions from Facebook and Twitter as comments on your blog posts</li>\n</ol>\n<p>The thing I love most about Social is the way it allows me to post on my site (and own my data), but still interact with my friends on Facebook and Twitter.</p>\n<p>All of these features are optional and can be enabled/disabled as necessary. Set-up is nice and easy &#8211; there is no need to log in as a developer and create a Facebook or Twitter app; you just log in and go.</p>\n<p>Version 2.9.1 brings the following changes:</p>\n<ul>\n<li>Support for threaded comments on Facebook pages</li>\n<li>New setting for which post types Social&#8217;s broadcasting should be enabled for</li>\n<li>Likes and RTs are no longer auto-approved (can be re-enabled if desired, see the <a href=\"http://wordpress.org/plugins/social/faq/\">FAQ</a>)</li>\n<li>Load avatars from Facebook and Twitter via https</li>\n<li>Address issues with high byte characters</li>\n<li>Work around a bug in the Local Avatars plugin</li>\n<li>Add a few language localizations</li>\n</ul>\n<p>It&#8217;s a great update, give it a try. Enjoy!</p>\n<p class=\"threads-post-notice\">This post is part of the thread: <a href=\"http://alexking.org/blog/thread/social\">Social</a> &#8211; an ongoing story on this site. View the thread timeline for more context on this post.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 15:14:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.tv: Travis Hensgen: Introducing MasterPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19227\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.tv/2013/06/06/travis-hensgen-introducing-masterpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:662:\"<div id=\"v-tj9fBObc-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19227/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19227/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19227&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/06/travis-hensgen-introducing-masterpress/\"><img alt=\"Travis Hensgen: Introducing MasterPress\" src=\"http://videos.videopress.com/tj9fBObc/video-4fb1c645b8_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 14:37:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Vlad Lasky: Beating Spam on your Blog or Website\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19559\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2013/06/06/vlad-lasky-beating-spam-on-your-blog-or-website/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:674:\"<div id=\"v-Vf0Zxz7R-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19559/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19559/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19559&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/06/vlad-lasky-beating-spam-on-your-blog-or-website/\"><img alt=\"Vlad Lasky: Beating SPAM on your Blog or Website\" src=\"http://videos.videopress.com/Vf0Zxz7R/video-a7f72f34f5_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 10:38:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WordPress.tv: Kathy Alice Brown: Demystifying WordPress SEO\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19386\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.tv/2013/06/05/kathy-alice-brown-demystifying-wordpress-seo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:668:\"<div id=\"v-vFk1jfkw-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19386/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19386/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19386&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/05/kathy-alice-brown-demystifying-wordpress-seo/\"><img alt=\"Kathy Alice Brown: Demystifying WordPress SEO\" src=\"http://videos.videopress.com/vFk1jfkw/video-db8a577aca_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 03:55:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WordPress.tv: Dylan Kuhn: Mad Mashups with WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19394\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2013/06/05/dylan-kuhn-mad-mashups-with-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:654:\"<div id=\"v-QBT0cX3o-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19394/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19394/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19394&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/05/dylan-kuhn-mad-mashups-with-wordpress/\"><img alt=\"Dylan Kuhn: Mad Mashups with WordPress\" src=\"http://videos.videopress.com/QBT0cX3o/video-db63f2ad8f_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 02:48:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Plugin Developers – Use Uninstall.php Please\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7227\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://feedproxy.google.com/~r/WordpressTavern/~3/0EGMgxgR6eU/plugin-developers-use-uninstall-php-please\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9610:\"<h2>A Bit Of History First:</h2>\n<p>On January 7th, 2008 I <a title=\"http://weblogtoolscollection.com/archives/2008/01/07/uninstall-is-there-such-a-thing/\" href=\"http://weblogtoolscollection.com/archives/2008/01/07/uninstall-is-there-such-a-thing/\">published an article</a> that brought up a subject not many in the community at the time knew about. At the time, I had only used WordPress for a little over 7 months. I decided to venture into the database WordPress was installed in and discovered several discrepancies such as information from plugins I had recently deactivated and deleted from my installation were still inside the database. It turned out that some plugins were leaving their data, settings, or tables behind. This was a big deal at the time because it was occurring without users ever being aware of the problem. The post generated a great discussion on how this problem could be solved and <a title=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/\" href=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/\">I highlighted some of the best responses</a> in a follow-up post.</p>\n<p>At least some plugin authors were already ahead of the game by providing uninstallation features that would remove every trace of the plugin upon deactivation but that created yet another issue. We decided that there should be a clear distinction between <strong>deactivation</strong> and <strong>uninstallation</strong>. Deactivating would leave all settings and data in tact while uninstallation would remove everything. We as a community proposed the idea of an uninstall function being created to keep the separation between the two actions. I had also proposed that guidelines on the WordPress plugin repository be tightened up to the point where plugins were required to have an uninstall option but that idea was shot down because of the proposal of more restrictions. The following idea was <a title=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/#comment-1208816\" href=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/#comment-1208816\">first proposed</a> by Alex:</p>\n<blockquote><p>The WP core should have an API hook for uninstalling a plugin. A plugin can register a certain function to this hook, if that function is called, the plugin will uninstall all its customizations. Then, if a plugin registered an uninstall function, add a link on the plugins page for the plugin to be uninstalled, e.g. right underneath “Deactive”. (Of course, uninstalling implies deactivitating.) Additionally, a plugin must have the ability to return if it was successful, and if it wasn’t, it must have a defined possibility to issue a message (e.g. steps to be performed manually).</p></blockquote>\n<p>Otto <a title=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/#comment-1209547\" href=\"http://weblogtoolscollection.com/archives/2008/01/12/uninstalling-conundrum-part-2/#comment-1209547\">agreed with Alex</a>.</p>\n<blockquote><p>Just like there are register_activation_hook and register_deactivation_hook functions, there needs to be a register_uninstall_hook function.</p>\n<p>Having such a registered hook would allow the plugin page to create an uninstall link for that plugin. This link would only be available if the plugin was already inactive. This leads to a natural two step process: deactivate then remove. We don’t want an implied deactivation, since this forces plugin authors to consider two different approaches to deactivation and uninstallation. Keep it simple.</p>\n<p>The uninstall button will call the uninstall hook for the plugin, which would take appropriate action to remove its options and tables and such.</p>\n<p>Seems like the best solution and keeps the interface clean and easy.</p></blockquote>\n<h2>The Implementation:</h2>\n<p>That discussion took place at the beginning of 2008. At the end of 2008, <a title=\"http://wordpress.org/news/2008/12/coltrane/\" href=\"http://wordpress.org/news/2008/12/coltrane/\">WordPress 2.7 &#8220;Coltrane&#8221;</a> was released to the world. The two biggest changes in WordPress 2.7 was the user interface redesign and the addition of auto-upgrades. But there was one more important addition in 2.7 that didn&#8217;t garner very much attention, <a title=\"http://codex.wordpress.org/Function_Reference/register_uninstall_hook\" href=\"http://codex.wordpress.org/Function_Reference/register_uninstall_hook\">register uninstall hook</a>. This hook as well as uninstall.php allowed the deactivation and uninstallation of plugins to be separate processes.</p>\n<p>Despite the presence of the uninstall hook, the <strong>emphasis is put on using the uninstall.php method</strong>. Not knowing why, I reached out to a guy that has over 50 plugins tied to his name, <a title=\"http://profiles.wordpress.org/coffee2code\" href=\"http://profiles.wordpress.org/coffee2code\" target=\"_blank\">Scott Reilly</a>. The following is our conversation which provides a clearer understanding of why one method is better than the other.</p>\n<p><em><strong>Jeff</strong> &#8211; Can you please explain why the uninstall.php method is the preferred method of uninstalling a plugin and its data versus using the uninstall hook?</em></p>\n<p><em><strong>Scott</strong> &#8211; It prevents the main plugin file from being run during uninstall, which can be problematic if the plugin runs code in the global space. It&#8217;s also better in that the uninstall code is centralized.</em></p>\n<p><em><strong>Jeff</strong> &#8211; Ok. Uninstall.php contains the uninstallation process while the hook can cause trouble. So as a plugin author, I would have control over and know exactly what is going to happen when using uninstall.php but if I were to rely on the hook, I wouldn&#8217;t exactly know what will happen, until the process occurs? Is my thinking correct?</em></p>\n<p><em><strong>Scott</strong> &#8211; Yes. If uninstall.php is present, that will be run when the plugin is uninstalled. If not present, then the main plugin file is run to check for the hook usage. depending on how the plugin is coded, it can cause problems if code is run in the global space (i.e. evaluated when the file is executed rather than properly wrapped into functions/classes that are called as needed). If you know what you&#8217;re doing, the hook can be used without ill effect. It&#8217;s safer to use uninstall.php, and a simpler recommendation to give most people.</em></p>\n<p>Plugin authors will need to first verify that <strong>register_uninstall_hook</strong> function exists because it didn&#8217;t prior to WordPress 2.7. Next, you&#8217;ll call your custom uninstall function to properly uninstall your plugin options. <strong>If you add uninstall functionality to your plugin, please add a warning of some type so that users will know that all data will be lost once the uninstallation process finishes.</strong></p>\n<h2>Still A Problem:</h2>\n<p>While cleaning up my database trying to figure out my <a title=\"http://www.wptavern.com/my-performance-woes\" href=\"http://www.wptavern.com/my-performance-woes\" target=\"_blank\">performance problems</a>, I noticed that there were a few tables created by plugins I had deleted a few years ago. Some of the tables contained a number of entries while others were just empty, but their unneeded presence annoyed me. This tells me that five years after the necessary functions were added to WordPress to uninstall plugins, plugin authors are still not utilizing them.</p>\n<p>This is my polite as can be request for authors of plugins that create, add or manipulate the database in any way to give end users the opportunity to restore their WordPress installation back to the way it was before they installed your plugin. To this day, users don&#8217;t have any idea about what is really going on in their database without actually going inside via phpMyAdmin which is always risky. I place this responsibility solely on the backs of plugin authors.</p>\n<h2>Further Reading:</h2>\n<p>Jacob Santos <a title=\"http://jacobsantos.com/blog/2008/general/wordpress-27-plugin-uninstall-methods\" href=\"http://jacobsantos.com/blog/2008/general/wordpress-27-plugin-uninstall-methods\" target=\"_blank\">published a detailed post</a> explaining the different plugin uninstallation methods.</p>\n<p><a title=\"http://lists.automattic.com/pipermail/wp-hackers/2010-May/031811.html\" href=\"http://lists.automattic.com/pipermail/wp-hackers/2010-May/031811.html\" target=\"_blank\">WordPress Hackers discussion in 2010</a> that discussed both options for uninstalling plugins. Be warned though, not every post maybe relevant to the original topic.</p>\n<p>Last but not least, check out the <a title=\"http://wordpress.org/plugins/wpdbspringclean/\" href=\"http://wordpress.org/plugins/wpdbspringclean/\" target=\"_blank\">WPDB SpringClean plugin</a>. This plugin will identify unoptimized tables and will allow you to optimize them by deleting the allocated unused space within a particular table. The plugin also optionally allows you to specify search criteria such as the minimum amount of overhead per table and minimum unused space for a table. (Anytime you perform work that involves the database, you should <strong>ALWAYS</strong> back up before moving forward.) Hat tip to <a href=\"http://profiles.wordpress.org/williamsba1\" title=\"http://profiles.wordpress.org/williamsba1\">Brad Williams</a>.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/0EGMgxgR6eU\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 05 Jun 2013 18:28:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"WordPress.tv: Mike Little, Simon Dickson: WordPress Co-founder Mike Little on The Birth of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19773\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:116:\"http://wordpress.tv/2013/06/04/mike-little-simon-dickson-wordpress-co-founder-mike-little-on-the-birth-of-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:749:\"<div id=\"v-evtysVF6-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19773/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19773/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19773&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/04/mike-little-simon-dickson-wordpress-co-founder-mike-little-on-the-birth-of-wordpress/\"><img alt=\"Mike Little, Simon Dickson: WordPress Co-founder Mike Little on The Birth of WordPress\" src=\"http://videos.videopress.com/evtysVF6/video-e6d3b09eb7_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Jun 2013 21:02:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WordPress.tv: Bret Simmons: Social Business and Personal Branding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19406\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wordpress.tv/2013/06/04/bret-simmons-social-business-and-personal-branding/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:680:\"<div id=\"v-qCr5gCVp-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19406/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19406/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19406&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/04/bret-simmons-social-business-and-personal-branding/\"><img alt=\"Bret Simmons: Social Business and Personal Branding\" src=\"http://videos.videopress.com/qCr5gCVp/video-ce6c59afec_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Jun 2013 20:27:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:29:\"WPTavern: My Performance Woes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7223\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://feedproxy.google.com/~r/WordpressTavern/~3/BwFliL6tmuI/my-performance-woes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6373:\"<p>For some unknown reason, the performance of this website over the past 2-3 weeks has been terrible. While writing posts, I would routinely see a warning that said I was disconnected from the server while taking forever to reconnect. Navigating the back-end of the site was a major pain as each page seemed to take forever to load. I also saw Internal 500 Server errors as well as MySQL database timeouts. While trying to diagnose what the problem was, I used the <a title=\"http://developer.yahoo.com/yslow/\" href=\"http://developer.yahoo.com/yslow/\">YSlow FireFox Extension</a> with Firebug and saw GET requests taking 3-20 seconds to load.</p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/longgetrequests.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-large wp-image-7224\" alt=\"Long Get Requests\" src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/06/longgetrequests.jpg?resize=500%2C137\" /></a></p>\n<p>Fed up with the performance, I created a trouble ticket with HostGator. I&#8217;ve never had a problem with this company in the two years I&#8217;ve used them and the support has been stellar. You can read their response to me in its <a title=\"http://pastebin.com/155jWya3\" href=\"http://pastebin.com/155jWya3\">entirety here</a> but the gist of their response was that certain plugins were creating such a load on the server that they were the source of my problems. They specifically mentioned these plugins:</p>\n<ul>\n<li>All related posts plugins (WordPress Related Posts, YARPP) can cause significantly high load in most cases.</li>\n<li>WPRobot3 and other auto-posters can also cause high load issues, and should be disabled if they are causing issues</li>\n<li>StatPress and other wordpress statistics software should also be disabled, as these too can consume too much CPU in certain cases. Use Google Analytics instead for statistics as well as Awstats which already comes by default on your account.</li>\n<li>WP Post Views is also a plugin that you&#8217;ll want to avoid as it causes significant resource usage.</li>\n<li>All In One SEO Pack has also been found to cause issues in many cases and we generally recommend using Greg&#8217;s High Performance SEO Pack in its place.</li>\n<li>Any other plugins that are not vital to your WordPress should be disabled.</li>\n</ul>\n<p>I knew at some point, YARPP was going to give me problems because of the resources it uses to create the relationships between posts. The weird thing is that my WordPress install has performed fine for a several weeks without a problem. All of the issues occurred suddenly. I wonder if YARPP reached the point where it was hitting the performance limits. Another plugin I&#8217;ve had problems with over the years is W3 Total Cache. Caching plugins have caused me so many problems that I&#8217;ve finally decided not to use them. In my opinion, using various techniques and optimizations, this site doesn&#8217;t need to use either to be fast. I only used one or the other because of the majority of WordPress literature that says you have to. </p>\n<p>So while I didn&#8217;t put a lot of thought and credibility into their response, I decided to go through my list of installed plugins and make the hard call on whether I needed them or not. It turns out I was able to axe about 6 plugins from my install. Those 6 did include W3 Total Cache and YARPP. I also took this opportunity to go inside of the database to drop and empty tables that were no longer necessary. While performing these tasks, I came across a few tables from plugins I had uninstalled about two years ago. <em>This will be a subject for another post.</em> After completing the spring cleanup, I&#8217;m happy to report that the site both on the front and back-ends is much more responsive. I&#8217;ve yet to run into a timeout or MySQL error. I can&#8217;t figure out which part of the clean-up process offered me the most benefit but I&#8217;d put money on the removal of both W3 and YARPP. </p>\n<p>After <a href=\"https://twitter.com/wptavern/status/341903935969320960\" title=\"https://twitter.com/wptavern/status/341903935969320960\">announcing the results on Twitter</a>, most people weren&#8217;t surprised to hear about YARPP possibly causing issues. It&#8217;s a shame because using Woopra to watch website traffic in real-time, I was able to see a bunch of people clicking on related posts through the YARPP widget. I&#8217;m now on the hunt for a service that can provide the horsepower to display related posts similar to <a href=\"http://www.wptavern.com/review-swiftype-search-plugin\" title=\"http://www.wptavern.com/review-swiftype-search-plugin\">how I use Swiftype</a> for search. The first service I&#8217;m going to try is called <a href=\"http://nrelate.com/\" title=\"http://nrelate.com/\">nRelate</a>. Look for a review in the near future. </p>\n<h2>Just Switch Hosts:</h2>\n<p>Why is it that at the first sign of trouble with a webhost, the first thing people tell you to do is move away to a different one? Have they not experienced what it&#8217;s like to move between webhosting companies? It&#8217;s not fun, at all. I use it as the nuclear option because the experience is so painful. This is a good time to reference an article I wrote in 2010, <a href=\"http://www.wptavern.com/14-things-to-consider-when-choosing-a-webhost-for-your-wordpress-powered-site\" title=\"http://www.wptavern.com/14-things-to-consider-when-choosing-a-webhost-for-your-wordpress-powered-site\">14 Things To Consider When Choosing A Webhost For Your WordPress Powered Site</a>. While there is a lot of great information in that post, the biggest take away is this:</p>\n<blockquote><p>Always type into Google “Name Of Webhosting Company Sucks” to get a grasp on the issues that have been reported with that particular webhost. When webhosting companies screw up, people are very vocal about it and will stop at nothing to complain to all who will listen. Unfortunately, the side effect to this research is that you’ll find out every webhosting company in existence, sucks. </p></blockquote>\n<p>It doesn&#8217;t matter which webhosting company I choose, someone out there will tell me how terrible they are and to switch to a different host. Talk about the ultimate feedback loop. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/BwFliL6tmuI\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Jun 2013 20:23:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WordPress.tv: Stephen Cronin: Actionable Analytics\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19484\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.tv/2013/06/04/stephen-cronin-actionable-analytics/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:650:\"<div id=\"v-Lxp0c32u-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19484/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19484/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19484&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/04/stephen-cronin-actionable-analytics/\"><img alt=\"Stephen Cronin: Actionable Analytics\" src=\"http://videos.videopress.com/Lxp0c32u/video-2a97c3c593_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 04 Jun 2013 19:53:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Vikki Maver: How to Write for an Online Audience\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19487\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2013/06/03/vikki-maver-how-to-write-for-an-online-audience/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:674:\"<div id=\"v-2NE7gIuV-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19487/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19487/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19487&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/03/vikki-maver-how-to-write-for-an-online-audience/\"><img alt=\"Vikki Maver: How to Write for an Online Audience\" src=\"http://videos.videopress.com/2NE7gIuV/video-c5da61b155_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Jun 2013 19:01:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: Matt Mullenweg Interviewed By CNN Money\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7203\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://feedproxy.google.com/~r/WordpressTavern/~3/9b8WI5yoA8o/matt-interviewed-by-cnn-money\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2103:\"<p>Matt Mullenweg was <a href=\"http://money.cnn.com/video/technology/2013/05/30/tech-co-wordpress-ceo-matt-mullenweg.cnnmoney\" title=\"http://money.cnn.com/video/technology/2013/05/30/tech-co-wordpress-ceo-matt-mullenweg.cnnmoney\">recently interviewed by CNN Money</a>. He had a couple of interesting answers for some of the questions asked. For example, when asked about being acquired, he responded that the only time he would consider being acquired is if he could run the company acquiring him. When asked about what they would be talking about 10 years from now, Matt said within the next 5 years, he believes the majority of WordPress usage will be from touch-driven devices. Last but not least, when he mentions failures, he believes that they didn&#8217;t embrace mobile soon enough because the open source community doesn&#8217;t like those closed platforms, but he still doesn&#8217;t feel like the mobile apps are really where they should be at. </p>\n<div class=\"aligncenter\"></div>\n<p>I find his comments on mobile apps especially interesting. I&#8217;ve used the WordPress for iOS app for some time now and while it&#8217;s definitely gotten better, some of the faults are not with the app itself, but with the device. I use an iPhone 4 and I&#8217;ve tried multiple times to write a blog post but each time I&#8217;ve given up in frustration. The auto-correct on the iPhone does more harm than good and the process for copying links from somewhere else to put inside the post just sucks. However, the app shines in comment notifications, post editing, and comment moderation. These three things are what makes the WordPress for iOS app the most useful to me. So what perplexes me is just how easy can the WordPress app make it to compose a post on the iPhone 4 before the device itself prevents any more improvements from happening? </p>\n<p>I want to hear from you on how you&#8217;re mobile experience has been with WordPress whether it&#8217;s with Blackberry, iPhone or Windows Phone 7?</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/9b8WI5yoA8o\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Jun 2013 19:00:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"WordPress.tv: John McKenna &amp; Yan Zhang: How WordPress is Empowering Diversity\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19481\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://wordpress.tv/2013/06/03/john-mckenna-yan-zhang-how-wordpress-is-empowering-diversity/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:702:\"<div id=\"v-0WL7RbDa-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19481/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19481/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19481&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/03/john-mckenna-yan-zhang-how-wordpress-is-empowering-diversity/\"><img alt=\"John McKenna & Yan Zhang: How WordPress is Empowering Diversity\" src=\"http://videos.videopress.com/0WL7RbDa/video-bae9c50b7a_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Jun 2013 18:11:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WPTavern: WordPress.com Makes Me Hulk Smash\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7208\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://feedproxy.google.com/~r/WordpressTavern/~3/52a8pPE_y38/wordpress-com-makes-me-hulk-smash\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3159:\"<p>Every now and then I&#8217;ll have a reason to visit <a href=\"http://www.wordpress.com\" title=\"http://www.wordpress.com\">WordPress.com</a>. I don&#8217;t visit the site often so occasionally, I&#8217;ll see redesigns that have occurred that throw me for a loop. This is one of those times. 99% of the time when I visit, it&#8217;s to login to the dashboard of my .com blog. The old design contained a series of Freshly Pressed posts, a navigation menu at the top and bottom of the website and was generally easy to navigate. However, when I log into WordPress.com in its current state, I&#8217;m greeted with a giant road block. This is when I begin the process of looking around the site to figure out where the link is to go straight to the dashboard of my website. The first place I look is the top area of the right-hand sidebar, clicking on links that I think will take me to where I need to go. </p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPdotComRightSidebar.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPdotComRightSidebar.jpg?resize=297%2C260\" alt=\"WordPress.com Right Hand Sidebar\" class=\"aligncenter size-full wp-image-7210\" /></a></p>\n<p>Nope, not there. I scroll down the website to find the footer with the links I need and nope, not there either. At this point, I&#8217;m frustrated, wanting the old WP.com design back. I start thinking that I&#8217;m on the wrong page. I find a way to logout, type WordPress.com into my address bar thinking I&#8217;m not on the correct site and once again, a blue page loads. After clicking on every other link on this page, I finally discover that the top menu has a link called My Blogs that has the dashboard login link I was looking for. What angers me about this experience is that I don&#8217;t use WordPress.com reader at all yet it&#8217;s the default active tab when I login. Most of my frustrations would disappear if instead, the My Blogs tab was activated by default. </p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/ReaderTab.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/ReaderTab.jpg?resize=300%2C172\" alt=\"WordPress.com Reader Tab\" class=\"aligncenter size-medium wp-image-7211\" /></a></p>\n<p>It&#8217;s equally as frustrating trying to find the official WordPress.com blog. So many wasted clicks trying to find that one stupid link which should be at the footer of the site on every page. I&#8217;ve given up looking for it on the site. Instead, I end up going to Google to find it that way. I don&#8217;t know who&#8217;s idea it was to create some sort of gateway page that is completely separate from the original WordPress.com but it&#8217;s like a giant blue obstacle course. The original WordPress.com design was at least consistent. </p>\n<p>I want to know if I&#8217;m the only one with this type of routine experience with WordPress.com? One things for sure, WordPress.com does a great job at making me feel like an idiot. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/52a8pPE_y38\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Jun 2013 16:50:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"WPTavern: More In-Depth WordPress History\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7199\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://feedproxy.google.com/~r/WordpressTavern/~3/NJ_4aTHoc3E/more-in-depth-wordpress-history\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1276:\"<p>Over the week-end, I had a chance to read <a title=\"http://wordpress.org/about/history/\" href=\"http://wordpress.org/about/history/\">chapter 3</a> of the WordPress history book which is an ongoing project by Siobhan McKeown. This is a fantastic project and one that I&#8217;m eagerly anticipating to read cover to cover. Chapter 3 is 37 pages long and covers the creation of WordPress from b2, b2++ into WordPress MU, how some of the earliest WordPress contributors became involved with the project, and perhaps most importantly, some of the core values that were developed early on that WordPress still tries to maintain to this day. Some of those values are:</p>\n<ul>\n<li>HTML Semantics and Web Standards Compliance</li>\n<li>Creating the lowest barrier to entry as possible</li>\n<li>Simplicity</li>\n<li>Unmatched User Experience</li>\n</ul>\n<p>In order to gauge where WordPress is going in the next 10 years, it&#8217;s important that we know what happened during the first 10. At one time, I thought I&#8217;d be the one writing the book on Matt and the history of WordPress but after reading Siobhan&#8217;s work, it&#8217;s clear that she is the right one for the job. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/NJ_4aTHoc3E\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 03 Jun 2013 15:15:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Narelle Hanratty: Recognizing the Cycles of Blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19478\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wordpress.tv/2013/06/02/narelle-hanratty-recognizing-the-cycles-of-blogging/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:682:\"<div id=\"v-rdKCeqE2-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19478/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19478/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19478&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/02/narelle-hanratty-recognizing-the-cycles-of-blogging/\"><img alt=\"Narelle Hanratty: Recognizing the Cycles of Blogging\" src=\"http://videos.videopress.com/rdKCeqE2/video-87650b4e1b_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 02 Jun 2013 18:10:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"WordPress.tv: Phil Steinke: 9 1/2 Free WordPress Plugins to Keep You Sane While Blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19471\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"http://wordpress.tv/2013/06/02/phil-steinke-9-12-free-wordpress-plugins-to-keep-you-sane-while-blogging/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:725:\"<div id=\"v-Orni3R7B-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19471/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19471/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19471&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/02/phil-steinke-9-12-free-wordpress-plugins-to-keep-you-sane-while-blogging/\"><img alt=\"Phil Steinke: 9 1/2 Free WordPress Plugins to Keep You Sane While Blogging\" src=\"http://videos.videopress.com/Orni3R7B/video-ac811a2795_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 02 Jun 2013 16:58:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Anthony Hortin: Getting Started with WooCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19444\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://wordpress.tv/2013/06/01/anthony-hortin-getting-started-with-woocommerce/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:674:\"<div id=\"v-h3zx5hVT-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19444/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19444/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19444&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/01/anthony-hortin-getting-started-with-woocommerce/\"><img alt=\"Anthony Hortin: Getting Started with WooCommerce\" src=\"http://videos.videopress.com/h3zx5hVT/video-9a314f4748_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 01 Jun 2013 15:05:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WordPress.tv: Gary Pendergast: WordPress Performance Tuning\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19441\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.tv/2013/06/01/gary-pendergast-wordpress-performance-tuning/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:674:\"<div id=\"v-JPGj1tkZ-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19441/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19441/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19441&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/06/01/gary-pendergast-wordpress-performance-tuning/\"><img alt=\"Gary Pendergast: WordPress Performance Tuning\" src=\"http://videos.videopress.com/JPGj1tkZ/video-dc59114bc7_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 01 Jun 2013 13:00:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WPTavern: PSA: Don’t Give Your Money To The WPUA\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7182\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"http://feedproxy.google.com/~r/WordpressTavern/~3/Bx4fwX6ndUc/psa-dont-give-your-money-to-the-wpua\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6810:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAlogo.jpg\" rel=\"thumbnail\"><img class=\"alignright size-full wp-image-7183\" alt=\"WPUA Logo\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAlogo.jpg?resize=215%2C67\" /></a>The <a title=\"http://wpua.org\" href=\"http://wpua.org\">WordPress Users Association</a> was launched in December of 2010 with the goal of providing a central place for WordPress users to swap war stories, learn how to get the most out of WordPress, and take part in getting special discounts on themes and plugins. Fast forward three years later and the idea appears to have been a bust, despite the look and feel of their website. <em>*Note: This organization has no association to WordPress.org, the WordPress Foundation, or any official aspect of the WordPress project.</em></p>\n<p>Curious about what happened as well as whether they were still accepting payments or not, I reached out to a couple of their corporate sponsors as well as a few of their earlier members to get their accounts of what it was like to be a part of the WPUA. I also signed up for a monthly membership to see if the website was still processing payments and indeed they are. Thankfully Clickbank, their payment processor has a 60 day money back guarantee which I&#8217;ll be utilizing very soon.</p>\n<p>Two of the four platinum level sponsors I contacted, responded. I wanted to know what their experience was like and if they were still currently sponsoring the website. I did reach out to founder John Pozadzides through his personal site OneMansBlog and Twitter a few days ago but at the time of being published, have yet to receive a response. </p>\n<p><strong>Vsellis:</strong> <em>I don&#8217;t think the site has been active for quite a while. I ended my sponsorship a long time ago and see my logo is still up there but I don&#8217;t think there is any activity.</em></p>\n<p><strong>Synthesis Managed WordPress Hosting By Copyblogger Media:</strong> <em>JohnP gave me an account and we simply participated in the forums. We are no longer active though will support anything John is doing.</em></p>\n<p>Then I got in touch with Matthew McGarity, one of the first members to join the WPUA where he shared his experience with the site:</p>\n<p><em>Even after launching, the site wasn&#8217;t terribly active. I suspect that it&#8217;s dead now, considering the front page has remained virtually unchanged since I first registered in September 2010. Also, its Twitter feed appears to be on auto-pilot like the French radio station on &#8220;Lost.&#8221;</em></p>\n<p><em>The site forum&#8217;s design made it difficult to participate in conversations, and it ended up being more work than I cared for. The forums had no RSS feeds, and their email digests were limited to the day&#8217;s top-10 conversations. Something that notified me of new subjects and/or replies to conversations I was a part of would have helped me participate. But remembering to log into the site on a regular basis wasn&#8217;t worth it. I made suggestions on improving this experience; the site owner Wesley Williams took them under serious consideration, but I don&#8217;t think they were ever enabled.</em></p>\n<p><em>John P. and Cali promoted the site at its launch, and friends of mine advertised there. But I don&#8217;t know if they&#8217;re involved now.</em></p>\n<p><em>At one time, I think they were considering the design of some WordPress certifications (developer, etc.) and the related curriculum/criteria for each, but that didn&#8217;t go anywhere, probably due to lack of value and potential acceptance (e.g. anyone can get certified for anything by anyone).</em></p>\n<p><em>I had a free membership, which limited my access on the site to value propositions that might change my desire to use the site. I&#8217;m savvy and keyed into the open source community enough that I am able to extract the benefits/help I need without having to pay for membership on a site like this. But that is just me.</em></p>\n<h2>Free Themes:</h2>\n<p>While browsing through the four pages of themes offered to paying members only, I noticed most of them didn&#8217;t impress me very much. But more importantly, they are all 2-3 years out of date. Instead of linking themes directly to a repository, the themes were manually uploaded to WPUA. Using outdated themes is a big no no as some of the ones on this site could still contain the <a href=\"http://www.wptavern.com/the-aftermath-of-the-timthumb-vulnerability\" title=\"http://www.wptavern.com/the-aftermath-of-the-timthumb-vulnerability\">TimThumb vulnerability</a>. </p>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAthemes.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAthemes.jpg?resize=500%2C211\" alt=\"Outdated Themes\" class=\"aligncenter size-large wp-image-7184\" /></a></p>\n<h2>Plugins:</h2>\n<p>Their plugins leave a lot to be desired. The plugins that are offered are tailored for internet marketers and are certainly not worth the price of admission. Just seeing one named PopupDomination gives me a bad feeling.</p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAPlugins.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAPlugins.jpg?resize=182%2C167\" alt=\"WPUA Plugins\" class=\"aligncenter size-full wp-image-7189\" /></a></p>\n<h2>Video Training:</h2>\n<p>Although there are a bunch of training videos on WPUA.org, none of them work. Instead, when you try to view them, the following error message pops up. Head to <a href=\"http://wordpress.tv/\" title=\"http://wordpress.tv/\">WordPress.TV</a> instead.</p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAOutDatedPlugin.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WPUAOutDatedPlugin.jpg?resize=500%2C285\" alt=\"Stream Not Available\" class=\"aligncenter size-large wp-image-7186\" /></a></p>\n<h2>Conclusion:</h2>\n<p>Despite their front-page, numerous claims and somewhat active forums (free accounts mostly), this is not a website you want to be giving your money to. The purpose of this post is to inform anyone who may have come across the WordPress Users Association either by way of a Google search or a link and is interested in becoming a paid member. <strong>Don&#8217;t</strong>. Despite the money back guarantee, there is nothing on this website worth paying for. </p>\n<p><strong>*Update 6/04/2013*</strong><br />\nI have successfully completed the refund process. While it was not easy or as straightforward as it could be, I did get my money back. </p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/Bx4fwX6ndUc\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 21:45:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Dev Blog: Ten Good Years\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2606\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/05/ten-good-years/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9851:\"<p><img class=\"alignright\" alt=\"\" align=\"right\" src=\"http://wpdotorg.files.wordpress.com/2013/05/wp10.jpg\" width=\"316\" height=\"164\" />It&#8217;s been ten years since we started this thing, and what a long way we&#8217;ve come. From a discussion between myself and <a href=\"http://mikelittle.org/\">Mike Little</a> about <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">forking our favorite blogging software</a>, to powering 18% of the web. It&#8217;s been a crazy, exciting, journey, and one that won&#8217;t stop any time soon.</p>\n<p>At ten years, it&#8217;s fun to reflect on our beginnings. We launched WordPress on 27th May 2003, but that wasn&#8217;t inception. Go back far enough, and you can <a href=\"http://zengun.org/weblog/archives/2001/06/post1958/\">read a post by Michel Valdrighi</a> who, frustrated by the self-hosted blogging platforms available, decided to write his own software; &#8220;b2, a PHP+MySQL alternative to Blogger and GreyMatter.&#8221; b2 was easy to install, easy to configure, and easy for developers to extend. Of all the blogging platforms out there, <a href=\"http://cafelog.com\">b2</a> was the right one for me: I could write my content and get it on the web quickly and painlessly.</p>\n<p>Sometimes, however, life gets in the way. In 2002, Michel stopped maintaining b2. Over time, security flaws became apparent and updates were needed and, while the b2 community could write patches and fixes, no one was driving the software forward. We were lucky that Michel decided to release b2 under the GPL; the software may have been abandoned, but we weren&#8217;t without options. A fork was always a possibility. That was where it stood in January 2003, when <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">I posted about forking b2</a> and <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">Mike responded</a>. The rest, as they say, is history.</p>\n<p>From the very beginning to the present day, I&#8217;ve been impressed by the thought, care, and dedication that WordPress&#8217; developers have demonstrated. Each one has brought his or her unique perspective, each individual has strengthened the whole. It would be impossible to thank each of them here individually, but their achievements speak for themselves. In WordPress 1.2 the new Plugin API made it easy for developers to extend WordPress. In the same release <code>gettext()</code> internationalization opened WordPress up to every language (hat tip: <a href=\"http://ryan.boren.me/\">Ryan Boren</a> for spending hours wrapping strings with gettext). In WordPress 1.5 our Theme system made it possible for WordPress users to quickly change their site&#8217;s design: there was huge resistance to the theme system from the wider community at the time, but can you imagine WordPress without it? Versions 2.7, 2.8, and 2.9 saw improvements that let users install and update their plugins and themes with one click. WordPress has seen a redesign by <a href=\"http://v2.happycog.com/create/wordpress/?p=design/wordpress/\">happycog</a> (2.3) and gone under extensive user testing and redesign (<a href=\"http://www.slideshare.net/edanzico/riding-the-crazyhorse-future-generation-wordpress-presentation\">Crazyhorse</a>, Liz Danzico and Jen Mylo, WordPress 2.5). In WordPress 3.0 we merged WordPress MU with WordPress &#8212; a huge job but 100% worth it. And in WordPress 3.5 we revamped the media uploader to make it easier for people to get their images, video, and media online.</p>\n<p>In sticking to our commitment to user experience, we&#8217;ve done a few things that have made us unpopular. The <a href=\"http://tech.gaeatimes.com/index.php/archive/wordpress-wysiwyg-editor-is-a-disaster/\">WYSIWYG editor</a> was hated by many, especially those who felt that if you have a blog you should know HTML. Some developers hated that we stuck with our code, refusing to rewrite, but it&#8217;s always been the users that matter: better a developer lose sleep than a site break for a user. Our code isn&#8217;t always beautiful, after all, when WordPress was created most of us were still learning PHP, but we try to make a flawless experience for users.</p>\n<p>It&#8217;s not all about developers. WordPress&#8217; strength lies in the diversity of its community. From the start, we wanted a low barrier to entry and we came up with our &#8220;famous 5 minute install&#8221;. This brought on board users from varied technical background: people who didn&#8217;t write code wanted to help make WordPress better. If you couldn&#8217;t write code, it didn&#8217;t matter: you could answer a question in the support forums, write documentation, translate WordPress, or build your friends and family a WordPress website. There is <a href=\"https://make.wordpress.org/\">space in the community</a> for anyone with a passion for WordPress.</p>\n<p>It&#8217;s been wonderful to see all of the people who have used WordPress to build their home on the internet. Early on <a href=\"http://wordpress.org/news/2004/04/switchers/\">we got excited</a> by <a href=\"http://wordpress.org/news/2004/04/more-switchers/\">switchers</a>. From a community of tinkerers we grew, as writers such as <a href=\"http://ma.tt/2004/05/om-malik/\">Om Malik</a>, <a href=\"http://dougal.gunters.org/blog/2004/05/15/mark-pilgrim-switches/\">Mark Pilgrim</a>, and <a href=\"http://ma.tt/2004/07/mollycom-switches/\">Molly Holzschlag</a> made the switch to WordPress. Our commitment to effortless publishing quickly paid off and has continued to do so: <strong>the WordPress 1.2 release saw 822 downloads per day, our latest release, WordPress 3.5, has seen 145,692 per day.</strong></p>\n<p>I&#8217;m continually amazed by what people have built with WordPress. I&#8217;ve seen <a href=\"http://justintimberlake.com/main/\">musicians</a> and <a href=\"http://ma.tt/2013/01/neil-leifer-on-wordpress/\">photographers</a>, magazines such as <a href=\"http://life.time.com/\">Life</a>, <a href=\"http://boingboing.net/\">BoingBoing</a>, and the <a href=\"http://observer.com/\">New York Observer</a>, <a href=\"http://www.compliance.gov/\">government websites</a>, a <a href=\"http://josephscott.org/archives/2011/05/pressfs-a-wordpress-filesystem/\">filesystem</a>, <a href=\"http://www.ymcanyc.org/association/pages/y-mvp\"> mobile applications</a>, and even <a href=\"http://www.viper007bond.com/2010/06/12/so-apparently-wordpress-can-guide-missiles/\">seen WordPress guide missiles</a>.</p>\n<p>As the web evolves, WordPress evolves. Factors outside of our control will always influence WordPress&#8217; development: today it&#8217;s mobile devices and retina display, tomorrow it could be Google Glass or technology not yet conceived. A lot can happen in ten years! As technology changes and advances, WordPress has to change with it while remaining true to its core values: making publishing online easy for everyone. How we rise to these challenges will be what defines WordPress over the coming ten years.</p>\n<p><strong>To celebrate ten years of WordPress, we&#8217;re working on a book about our history.</strong> We&#8217;re carrying out interviews with people who have involved with the community from the very beginning, those who are still around, and those who have left. It&#8217;s a huge project, but we wanted to have something to share with you on the 10th anniversary. To learn about the very early days of WordPress, just after Mike and I forked b2 <a href=\"http://wordpress.org/about/history/\">you can download Chapter 3 right here</a>. We&#8217;ll be releasing the rest of the book serially, so watch out as the story of the last ten years emerges.</p>\n<p>In the meantime, <a href=\"http://ma.tt/2013/05/dear-wordpress/\"> I penned my own letter to WordPress</a> and other community members have been sharing their thoughts:</p>\n<ul>\n<li><a href=\"http://zed1.com/journalized/archives/2013/01/25/wordpress-a-10-year-journey/\">Mike Little on our Ten Year Journey</a>.</li>\n<li>Core contributor Helen Hou-Sandi <a href=\"http://helen.wordpress.com/2013/05/27/happy-10th-wordpress-and-thanks-from-my-little-family/\">wishes WordPress happy birthday</a>.</li>\n<li>Peter Westwood on <a href=\"http://blog.ftwr.co.uk/archives/2013/05/27/a-decade-gone-more-to-come/\">a decade gone</a>.</li>\n<li>Support rep Mika Epstein <a href=\"http://ipstenu.org/2013/you-me-and-wp/\">on her WordPress journey</a>.</li>\n<li>Dougal Campbell <a href=\"http://dougal.gunters.org/blog/2013/05/27/instagram-my-wife-suzecampbell-and-i-celebrating-the-wordpress-10th-anniversary-with-bbq-in-our-wordpress-shirts-wp10/\">celebrating with his wife, Suze</a>.</li>\n<li>Otto on <a href=\"http://ottodestruct.com/blog/2013/how-wp-affected-me/\">how WordPress affected him</a>.</li>\n</ul>\n<p>You can see how WordPress&#8217; 10th Anniversary was celebrated all over the world <a href=\"http://wp10.wordpress.net/\">by visiting the wp10 website</a>, according to Meetup we had 4,999 celebrators.</p>\n<p>To finish, I just want to say thank you to everyone: to the developers who write the code, to the designers who make WordPress sing, to the worldwide community translating WordPress into so many languages, to volunteers who answer support questions, to those who make WordPress accessible, to the systems team and the plugin and theme reviewers, to documentation writers, event organisers, evangelists, detractors, supporters and friends. Thanks to the jazzers whose music inspired us and whose names are at the heart of WordPress. Thanks to everyone who uses WordPress to power their blog or website, and to everyone who will in the future. Thanks to WordPress and its community that I&#8217;m proud to be part of.</p>\n<p>Thank you. I can&#8217;t wait to see what the next ten years bring.</p>\n<p><em>Final thanks to <a href=\"http://siobhanmckeown.com/\">Siobhan McKeown</a> for help with this post.</em></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 17:54:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"WPTavern: iThemes On The Future Of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7178\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://feedproxy.google.com/~r/WordpressTavern/~3/YFjljnCJuSU/ithemes-on-the-future-of-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1639:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2009/08/ithemeslogo.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2009/08/ithemeslogo.png?resize=255%2C69\" alt=\"iThemes Logo\" class=\"alignright size-full wp-image-2310\" /></a>It&#8217;s hard to disagree with anything Cory Miller says in his <a href=\"http://ithemes.com/2013/05/28/the-future-of-wordpress-6-keys/\" title=\"http://ithemes.com/2013/05/28/the-future-of-wordpress-6-keys/\">6 Keys To The Future Of WordPress Post</a>. One of his keys is Blogging. He&#8217;s right in that blogging is the history and heritage of the WordPress software but over the past few years, so much has been done to try to rid the stigma of WordPress being just for blogging. That seems like a trend that will continue so the challenge is, how do we maintain that heritage without it dissolving?</p>\n<p>The first key correlates with another in Identity. To this day, if you ask 10 people what is WordPress, you&#8217;re likely to get at least 7 different answers ranging anywhere from blogging system, publishing platform, to content management system and to top it off, all the answers are correct. The questions Cory asks are very important: <strong>What is WordPress? What is it supposed to do for people? And how do we preserve and protect that while innovating and adapting?</strong> Each feature, each enhancement, everything that goes into WordPress should be focused around the answers to those questions.</p>\n<p>Overall, I think Cory nailed it.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/YFjljnCJuSU\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 17:39:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WPTavern: 10th Anniversary Interview With WordPress Co-Founder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:114:\"http://feedproxy.google.com/~r/WordpressTavern/~3/A_0z7n20F44/10th-anniversary-interview-with-wordpress-co-founder\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2731:\"<p>WordPress developer Simon Dickson had the chance to sit down with WordPress co-founder Mike Little for about a half hour during their WordPress 10th anniversary party. This is one of the longest interviews with Mike that I&#8217;ve seen and it covers his history of using computers, programming, the beginnings of WordPress and several other topics. One of the biggest takeaways I&#8217;ve had from watching all the interviews with Mike Little is that he is just as humble if not more so than Matt Mullenweg. </p>\n<div class=\"aligncenter\"></div>\n<p>When you listen to the story of how WordPress began from Mike&#8217;s perspective, you begin to realize how the planets must have been aligned in order for those two to meet. There are a couple of different time points in the early days of WordPress that could have changed everything. For example, the lead developer for b2 disappeared without a trace for several months. Because of the disappearance and the presence of major bugs as well as the domain coming up for renewal, Matt published his <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">Software Dilemma post</a> where Mike Little volunteered to help out with the forking of b2. If the lead developer didn&#8217;t disappear, would we be using WordPress today? Then there&#8217;s the mass exodus from MoveableType in 2004 after they announced MT3 would have a $70.00 fee attached to it. Considering MT was one of the leading platforms at the time, had MT continued to be free, how would that have affected WordPress as we know it? Last but not least, TextPattern appeared to be everything Matt wanted in a publishing platform but because of its license, decided not to work with it. If TextPattern would have been licensed under the GPL at the time, would WordPress have been created? Ironically, TextPattern is now licensed under the GPL version 2, the same license as WordPress. </p>\n<p>A couple of other tidbits to take away from this interview:</p>\n<ul>\n<li>Mike Little was responsible for the Links Manager in b2 which ended up as a part of WordPress.</li>\n<li>All of the settings pages, Mike wrote the original options code for those</li>\n<li>He is also responsible for the WP-Configsample.php file to prevent people from overwriting settings</li>\n<li>WordCamp UK Birmingham changed Mikes life because of the amount of people he saw raise their hand when asked how many people make most or all of their living from WordPress.</li>\n</ul>\n<p>Mike was around during the mass exodus from MoveableType in 2004. I&#8217;d like to know if he noticed it, or had any thoughts on that part of WordPress history.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/A_0z7n20F44\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 15:06:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"WordPress.tv: Gene Hammett: Designers &amp; Developers: Creating New Revenue Streams with WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19428\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://wordpress.tv/2013/05/31/gene-hammett-designers-developers-creating-new-revenue-streams-with-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:737:\"<div id=\"v-0qiNzDDW-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19428/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19428/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19428&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/05/31/gene-hammett-designers-developers-creating-new-revenue-streams-with-wordpress/\"><img alt=\"Gene Hammett: Designers & Developers: Creating New Revenue Streams with WordPress\" src=\"http://videos.videopress.com/0qiNzDDW/video-894a3dabff_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 13:49:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WordPress.tv: Nicole Rose Dion: Integrating Social Media into WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=19418\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wordpress.tv/2013/05/31/nicole-rose-dion-integrating-social-media-into-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:692:\"<div id=\"v-P93FfuY0-1\" class=\"video-player\">\n</div>\n<br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/19418/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/19418/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=19418&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/05/31/nicole-rose-dion-integrating-social-media-into-wordpress/\"><img alt=\"Nicole Rose Dion: Integrating Social Media into WordPress\" src=\"http://videos.videopress.com/P93FfuY0/video-9882729fdc_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 12:39:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Matt: A Contrarian Futurist\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=42442\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"http://ma.tt/2013/05/a-contrarian-futurist/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:174:\"<p>David Cowan writes as <a href=\"http://allthingsd.com/20130528/a-contrarian-futurist/\">A Contrarian Futurist</a>, with thoughts on wearable computing and cyber warfare.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 May 2013 21:47:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Matt\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WPTavern: New eBook On How To Become A WordPress Development Professional\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://www.wptavern.com/?p=7163\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:125:\"http://feedproxy.google.com/~r/WordpressTavern/~3/7IMi52ow5Yc/new-ebook-on-how-to-become-a-wordpress-development-professional\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5389:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WordPressDevelopmentProfessional.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/05/WordPressDevelopmentProfessional.jpg?resize=245%2C75\" alt=\"WordPress Development Professional  Logo\" class=\"alignright size-full wp-image-7164\" /></a>Always on the lookout for new resources to share with others to help learn WordPress related topics, I came across an <a href=\"http://wpthemetutorial.com/downloads/wordpress-development-professional/\" title=\"http://wpthemetutorial.com/downloads/wordpress-development-professional/\">eBook published</a> ($29.99-$39.99) by long time WordPress developer <a href=\"http://profiles.wordpress.org/curtismchale\" title=\"http://profiles.wordpress.org/curtismchale\">Curtis McHale</a>. I got in touch with Curtis to ask him a few questions concerning his book, including whether or not he plans on contributing to the WordPress handbook project.</p>\n<p><strong>What was the inspiration for writing the book?</strong></p>\n<p>I wanted to write the book after dealing with so much code from beginning developers. Yes it was bad, but they just didn&#8217;t know any better so what else could you expect? My hope was that by reading the book a beginning developer, or developer not familiar with WordPress, would have a great set of road signs as they built stuff.</p>\n<p>No it doesn&#8217;t cover every part of WordPress, but it&#8217;s a great overview so that the reader is left with a way to evaluate all the random tutorials you come across online. There are a lot of bad ones, and when you don&#8217;t have any framework to judge them you just use the bad ones with the good..</p>\n<p><strong>Have you seen a good response to the book since its release?</strong></p>\n<p>I&#8217;d say it depends on how you want to measure it. Am I sitting back in a pool of money not doing client work? Nope. Book sales were pretty good at the beginning but they have tapered off quite a bit.</p>\n<p>Out of the few review copies I sent out anyone that has provided any feedback has said that the content is good and does hit it&#8217;s goal.</p>\n<p>Ultimately it&#8217;s still super awesome to wake up and see a book sale, or make a sale on the weekend. I&#8217;m pretty happy with getting it out there and I&#8217;d do another one. So yes I am happy with the response.</p>\n<p><strong>What do you hope readers will gain after reading your book?</strong></p>\n<p>As I said above, a way to judge all the information on WordPress out there. The problem is not finding what you want, it&#8217;s finding something <strong>good</strong>.</p>\n<p>This book is not for experienced developers. You may pick up a few tips/hints but it won&#8217;t be revolutionary at all.</p>\n<p><strong>What will readers find in WordPress Development Professional that they wouldn&#8217;t be able to find in the Codex?</strong></p>\n<p>First, it&#8217;s all in one spot. You don&#8217;t have to dive between 50 different pages to find best practices on Themes, plugins…</p>\n<p>Outside of that, you get a good insight in to how I develop projects. It&#8217;s always interesting to see what someone else does different from you. It at least can make you evaluate the way you do things to see if you&#8217;re right and I&#8217;m wrong.</p>\n<p><strong>Have you thought about contributing to any of the Handbook projects such as Developing WordPress Themes (in adherence to the theme review guidelines) or Developing Plugins for the repository?</strong></p>\n<p>Yes and I was in on a few meetings for the handbooks at the beginning, but I&#8217;m terrible at keeping up with all the IRC meetings. Technically I&#8217;m a Theme Reviewer (haven&#8217;t done much in a while) and I&#8217;ve done a bunch of documentation for 3.5 on specific functions.</p>\n<p>If you really tracked my contributions you&#8217;d find a flurry of activity in one spot (like documentation) then I go dark for a while. With the 3.5 documentation I just got on the blog post about things that were needed and knocked off 10 functions in an afternoon. Did a bit of clean up and then I haven&#8217;t done much with docs since. I had about the same thing going with Theme Review, did a bunch then a few here and there, then I haven&#8217;t done much.</p>\n<p>I always think that I should be doing more to assist, but then it&#8217;s a matter of finding time.</p>\n<p><strong>Are there any plans for a second edition?</strong></p>\n<p>Yes there are plans for a second Edition. I&#8217;ve got a bunch of notes going on things I should check up on, some spelling mistakes have been submitted. I&#8217;d like to add screencasts for some portions as well.</p>\n<p>It&#8217;s more likely that I&#8217;ll release a few other &#8216;micro courses&#8217;. I&#8217;ve got outlines for Transients, Roles and Caps, and post meta. They&#8217;d have a book, screencasts blog content and access to a general help/discussion forum. Costs will probably be between $10 &#8211; $20 and to keep access to the support forum after a year there will be some fee. At least that&#8217;s my pricing thoughts today. Once I get the outlines done I&#8217;ll put them out to my email list (you know the proven customers) for some voting to see which one goes first.</p>\n<img src=\"http://feeds.feedburner.com/~r/WordpressTavern/~4/7IMi52ow5Yc\" height=\"1\" width=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 30 May 2013 20:56:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 12 Jun 2013 17:08:10 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"159535\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Wed, 12 Jun 2013 17:00:29 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20130602101200\";}", "no");
INSERT INTO `wp_options` VALUES("297", "_transient_timeout_dash_aa95765b5cc111c56d5993d476b1c2f0", "1371100091", "no");
INSERT INTO `wp_options` VALUES("300", "_transient_feed_a5420c83891a9c88ad2a4f04584a5efc", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 16:45:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Michael Adams (mdawaffe)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Broken Link Checker\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/broken-link-checker/#post-2441\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 08 Oct 2007 21:35:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2441@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"This plugin will check your posts, comments and other content for broken links and missing images, and notify you if any are found.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Janis Elsts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"W3 Total Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/w3-total-cache/#post-12073\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 Jul 2009 18:46:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12073@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:132:\"Easy Web Performance Optimization (WPO) using caching: browser, page, object, database, minify and content delivery network support.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Frederick Townes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 6 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Advanced Custom Fields\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/advanced-custom-fields/#post-25254\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 17 Mar 2011 04:07:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"25254@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"Fully customise WordPress edit screens with powerful fields. Boasting a professional interface and a powerfull API, it’s a must have for any web dev\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"elliotcondon\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WP Super Cache\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/wp-super-cache/#post-2572\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Nov 2007 11:40:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2572@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"A very fast caching engine for WordPress that produces static html files.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Donncha O Caoimh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/captcha/#post-26129\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Apr 2011 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26129@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"This plugin allows you to implement super security captcha form into web forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Google Analytics for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.org/plugins/google-analytics-for-wordpress/#post-2316\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 14 Sep 2007 12:15:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2316@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:145:\"Track your WordPress site easily and with lots of metadata: views per author &#38; category, automatic tracking of outbound clicks and pageviews.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 12 Jun 2013 17:08:11 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Wed, 12 Jun 2013 17:20:20 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Wed, 12 Jun 2013 16:45:20 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130602101200\";}", "no");
INSERT INTO `wp_options` VALUES("299", "_transient_timeout_feed_a5420c83891a9c88ad2a4f04584a5efc", "1371100091", "no");
INSERT INTO `wp_options` VALUES("298", "_transient_dash_aa95765b5cc111c56d5993d476b1c2f0", "<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://alexking.org/blog/2013/06/12/twitter-tools-3-0-4-v1-1-api\' title=\'.threads-post-notice { background: #e8e8e8; padding: 10px; } .threads-post-notice a { font-weight: bold; } I’ve released Twitter Tools version 3.0.4 which now uses the Twitter v1.1 API. Since Twitter has turned off the 1.0 API, this is pretty much a “must upgrade” situation. If Twitter Tools has been active for you over the last few days, you’ll need to do a [&hellip;]\'>Alex King: Twitter Tools 3.0.4: Twitter v1.1 API Compatibility</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/06/12/brad-parbs-responsive-design-primer-2/\' title=\' [&hellip;]\'>WordPress.tv: Brad Parbs: Responsive Design Primer</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/06/12/dr-renee-hobbs-the-implementation-of-wordpress-in-the-academia/\' title=\' [&hellip;]\'>WordPress.tv: Dr. Renee Hobbs: The Implementation Of WordPress in The Academia</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/06/11/john-caserta-wordpress-for-teachers/\' title=\' [&hellip;]\'>WordPress.tv: John Caserta: WordPress for Teachers</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/06/11/jonathan-friesem-kari-lukovics-daniel-klotz-educational-use-of-wordpress-at-harrington/\' title=\' [&hellip;]\'>WordPress.tv: Jonathan Friesem, Kari Lukovics, Daniel Klotz: Educational Use of WordPress at Harrington</a></li></ul></div>", "no");
INSERT INTO `wp_options` VALUES("303", "_transient_timeout_feed_57bc725ad6568758915363af670fd8bc", "1371100091", "no");
INSERT INTO `wp_options` VALUES("304", "_transient_feed_57bc725ad6568758915363af670fd8bc", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/plugins/browse/new/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress Plugins » View: Newest\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 16:48:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"DP Debug Menu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/dp-debug-menu/#post-52278\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 19 Apr 2013 14:22:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"52278@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Quickly shows the template used for current page, number of queries, and execution time for PHP code.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Dan- Lucian Stefancu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"Disable Jetpack Carousel on Mobile\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/plugins/disable-jetpack-carousel-on-mobile/#post-54252\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 20:15:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54252@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"Disables Jetpack Carousel on mobile devices.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Steven Gliebe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Shop Menu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/shop-menu/#post-53241\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 May 2013 21:16:12 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53241@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"This plugin creates the goods menu of your store using shortcode. The menu is loaded with ajax.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"hidaka.bizplugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"bbPress - Notices\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/bbpress-notices/#post-54443\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 12 Jun 2013 08:16:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54443@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"An extension for bbPress to easily show notices at the top of all forum pages.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"mordauk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Remind101 Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/remind101/#post-54303\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 07 Jun 2013 13:20:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54303@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:176:\"LicenseURI: <a href=\"http://www.gnu.org/licenses/gpl-2.0.html\" rel=\"nofollow\">http://www.gnu.org/licenses/gpl-2.0.html</a>\n\nInclude a widget of recent from a remind101 account.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"okorpheus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Wordpress Auction Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/ultimate-auction/#post-54232\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 07:04:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54232@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"Awesome plugin to host auctions on your wordpress site and sell anything you want.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Nitesh Singh\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"WP Easy Leads\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/wp-easy-leads/#post-53817\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 28 May 2013 14:10:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53817@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"WP Easy Leads is a lead generating plugin that lets you create your own lead page to capture lead.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"MamdaniWeb\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"PauPress - A CRM for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/plugins/paupress/#post-51667\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 06 Apr 2013 19:32:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"51667@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"Supercharge your user profiles. Simple, powerful contact relationship management.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"havahula\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"WP News feed widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/wp-news-feed-widget/#post-54246\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 17:25:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54246@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"A simple news feed widget with pagination\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"tabrisrp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Restore Default Widgets\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/plugins/restore-default-widgets/#post-54247\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 17:47:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54247@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"Restores default WordPress widgets unregistered by themes and plugins.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Steven Gliebe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Fiat Alert Bar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/fiat-alert-bar/#post-54358\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 10 Jun 2013 02:09:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54358@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"Create an alert bar that can be edited like a normal post and placed anywhere in your site via the [fiatalert] shortcode.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:3:\"Ben\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"Simple Social by Allembru\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/plugins/simple-social-by-allembru/#post-54245\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 17:09:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54245@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:134:\"A simple social sharing plugin that uses the native API&#039;s of each social network in order to maintain full sharing functionality.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"allembru\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Zaki Like Dislike Comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.org/plugins/zaki-like-dislike-comments/#post-54243\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 16:24:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54243@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"This plugin implements a &#34;like/dislike&#34; rating system for comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Riccardo Conte\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"WP Composer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/plugins/composer/#post-54355\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 09 Jun 2013 19:58:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54355@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"Adding Composer dependency management to WP CLI.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Sean Fisher\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Bistri Video Call Button\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wordpress.org/plugins/bistri-video-call-button/#post-54235\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 06 Jun 2013 10:20:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"54235@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"Show to your visitors that you are available for a video call\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"rcaddoux\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:41:\"http://wordpress.org/plugins/rss/view/new\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 12 Jun 2013 17:08:11 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:7:\"expires\";s:29:\"Wed, 12 Jun 2013 17:23:34 GMT\";s:13:\"cache-control\";s:0:\"\";s:6:\"pragma\";s:0:\"\";s:13:\"last-modified\";s:31:\"Wed, 12 Jun 2013 16:48:34 +0000\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130602101200\";}", "no");
INSERT INTO `wp_options` VALUES("295", "_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1371100091", "no");
INSERT INTO `wp_options` VALUES("296", "_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c", "1371056891", "no");
INSERT INTO `wp_options` VALUES("301", "_transient_timeout_feed_mod_a5420c83891a9c88ad2a4f04584a5efc", "1371100091", "no");
INSERT INTO `wp_options` VALUES("302", "_transient_feed_mod_a5420c83891a9c88ad2a4f04584a5efc", "1371056891", "no");
INSERT INTO `wp_options` VALUES("310", "_transient_dash_de3249c4736ad3bd2cd29147c4a0d43e", "<h4>Most Popular</h4>\n<h5><a href=\'http://wordpress.org/plugins/wordpress-importer/\'>WordPress Importer</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=wordpress-importer&amp;_wpnonce=e6ac04baaa&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'WordPress Importer\'>Install</a>)</span>\n<p>Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.</p>\n<h4>Newest Plugins</h4>\n<h5><a href=\'http://wordpress.org/plugins/fiat-alert-bar/\'>Fiat Alert Bar</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=fiat-alert-bar&amp;_wpnonce=51f5b88b5f&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Fiat Alert Bar\'>Install</a>)</span>\n<p>Create an alert bar that can be edited like a normal post and placed anywhere in your site via the [fiatalert] shortcode.</p>\n", "no");
INSERT INTO `wp_options` VALUES("287", "_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "1371100090", "no");
INSERT INTO `wp_options` VALUES("288", "_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:50:\"\n	\n	\n	\n	\n	\n	\n	\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 02 Jun 2013 02:32:53 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://wordpress.org/?v=3.6-beta3-24432\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Ten Good Years\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/05/ten-good-years/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/news/2013/05/ten-good-years/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 17:54:35 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Meta\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2606\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:343:\"It&#8217;s been ten years since we started this thing, and what a long way we&#8217;ve come. From a discussion between myself and Mike Little about forking our favorite blogging software, to powering 18% of the web. It&#8217;s been a crazy, exciting, journey, and one that won&#8217;t stop any time soon. At ten years, it&#8217;s fun [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9852:\"<p><img class=\"alignright\" alt=\"\" align=\"right\" src=\"http://wpdotorg.files.wordpress.com/2013/05/wp10.jpg\" width=\"316\" height=\"164\" />It&#8217;s been ten years since we started this thing, and what a long way we&#8217;ve come. From a discussion between myself and <a href=\"http://mikelittle.org/\">Mike Little</a> about <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">forking our favorite blogging software</a>, to powering 18% of the web. It&#8217;s been a crazy, exciting, journey, and one that won&#8217;t stop any time soon.</p>\n<p>At ten years, it&#8217;s fun to reflect on our beginnings. We launched WordPress on 27th May 2003, but that wasn&#8217;t inception. Go back far enough, and you can <a href=\"http://zengun.org/weblog/archives/2001/06/post1958/\">read a post by Michel Valdrighi</a> who, frustrated by the self-hosted blogging platforms available, decided to write his own software; &#8220;b2, a PHP+MySQL alternative to Blogger and GreyMatter.&#8221; b2 was easy to install, easy to configure, and easy for developers to extend. Of all the blogging platforms out there, <a href=\"http://cafelog.com\">b2</a> was the right one for me: I could write my content and get it on the web quickly and painlessly.</p>\n<p>Sometimes, however, life gets in the way. In 2002, Michel stopped maintaining b2. Over time, security flaws became apparent and updates were needed and, while the b2 community could write patches and fixes, no one was driving the software forward. We were lucky that Michel decided to release b2 under the GPL; the software may have been abandoned, but we weren&#8217;t without options. A fork was always a possibility. That was where it stood in January 2003, when <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/\">I posted about forking b2</a> and <a href=\"http://ma.tt/2003/01/the-blogging-software-dilemma/#comment-445\">Mike responded</a>. The rest, as they say, is history.</p>\n<p>From the very beginning to the present day, I&#8217;ve been impressed by the thought, care, and dedication that WordPress&#8217; developers have demonstrated. Each one has brought his or her unique perspective, each individual has strengthened the whole. It would be impossible to thank each of them here individually, but their achievements speak for themselves. In WordPress 1.2 the new Plugin API made it easy for developers to extend WordPress. In the same release <code>gettext()</code> internationalization opened WordPress up to every language (hat tip: <a href=\"http://ryan.boren.me/\">Ryan Boren</a> for spending hours wrapping strings with gettext). In WordPress 1.5 our Theme system made it possible for WordPress users to quickly change their site&#8217;s design: there was huge resistance to the theme system from the wider community at the time, but can you imagine WordPress without it? Versions 2.7, 2.8, and 2.9 saw improvements that let users install and update their plugins and themes with one click. WordPress has seen a redesign by <a href=\"http://v2.happycog.com/create/wordpress/?p=design/wordpress/\">happycog</a> (2.3) and gone under extensive user testing and redesign (<a href=\"http://www.slideshare.net/edanzico/riding-the-crazyhorse-future-generation-wordpress-presentation\">Crazyhorse</a>, Liz Danzico and Jen Mylo, WordPress 2.5). In WordPress 3.0 we merged WordPress MU with WordPress &#8212; a huge job but 100% worth it. And in WordPress 3.5 we revamped the media uploader to make it easier for people to get their images, video, and media online.</p>\n<p>In sticking to our commitment to user experience, we&#8217;ve done a few things that have made us unpopular. The <a href=\"http://tech.gaeatimes.com/index.php/archive/wordpress-wysiwyg-editor-is-a-disaster/\">WYSIWYG editor</a> was hated by many, especially those who felt that if you have a blog you should know HTML. Some developers hated that we stuck with our code, refusing to rewrite, but it&#8217;s always been the users that matter: better a developer lose sleep than a site break for a user. Our code isn&#8217;t always beautiful, after all, when WordPress was created most of us were still learning PHP, but we try to make a flawless experience for users.</p>\n<p>It&#8217;s not all about developers. WordPress&#8217; strength lies in the diversity of its community. From the start, we wanted a low barrier to entry and we came up with our &#8220;famous 5 minute install&#8221;. This brought on board users from varied technical background: people who didn&#8217;t write code wanted to help make WordPress better. If you couldn&#8217;t write code, it didn&#8217;t matter: you could answer a question in the support forums, write documentation, translate WordPress, or build your friends and family a WordPress website. There is <a href=\"https://make.wordpress.org/\">space in the community</a> for anyone with a passion for WordPress.</p>\n<p>It&#8217;s been wonderful to see all of the people who have used WordPress to build their home on the internet. Early on <a href=\"http://wordpress.org/news/2004/04/switchers/\">we got excited</a> by <a href=\"http://wordpress.org/news/2004/04/more-switchers/\">switchers</a>. From a community of tinkerers we grew, as writers such as <a href=\"http://ma.tt/2004/05/om-malik/\">Om Malik</a>, <a href=\"http://dougal.gunters.org/blog/2004/05/15/mark-pilgrim-switches/\">Mark Pilgrim</a>, and <a href=\"http://ma.tt/2004/07/mollycom-switches/\">Molly Holzschlag</a> made the switch to WordPress. Our commitment to effortless publishing quickly paid off and has continued to do so: <strong>the WordPress 1.2 release saw 822 downloads per day, our latest release, WordPress 3.5, has seen 145,692 per day.</strong></p>\n<p>I&#8217;m continually amazed by what people have built with WordPress. I&#8217;ve seen <a href=\"http://justintimberlake.com/main/\">musicians</a> and <a href=\"http://ma.tt/2013/01/neil-leifer-on-wordpress/\">photographers</a>, magazines such as <a href=\"http://life.time.com/\">Life</a>, <a href=\"http://boingboing.net/\">BoingBoing</a>, and the <a href=\"http://observer.com/\">New York Observer</a>, <a href=\"http://www.compliance.gov/\">government websites</a>, a <a href=\"http://josephscott.org/archives/2011/05/pressfs-a-wordpress-filesystem/\">filesystem</a>, <a href=\"http://www.ymcanyc.org/association/pages/y-mvp\"> mobile applications</a>, and even <a href=\"http://www.viper007bond.com/2010/06/12/so-apparently-wordpress-can-guide-missiles/\">seen WordPress guide missiles</a>.</p>\n<p>As the web evolves, WordPress evolves. Factors outside of our control will always influence WordPress&#8217; development: today it&#8217;s mobile devices and retina display, tomorrow it could be Google Glass or technology not yet conceived. A lot can happen in ten years! As technology changes and advances, WordPress has to change with it while remaining true to its core values: making publishing online easy for everyone. How we rise to these challenges will be what defines WordPress over the coming ten years.</p>\n<p><strong>To celebrate ten years of WordPress, we&#8217;re working on a book about our history.</strong> We&#8217;re carrying out interviews with people who have involved with the community from the very beginning, those who are still around, and those who have left. It&#8217;s a huge project, but we wanted to have something to share with you on the 10th anniversary. To learn about the very early days of WordPress, just after Mike and I forked b2 <a href=\"http://wordpress.org/about/history/\">you can download Chapter 3 right here</a>. We&#8217;ll be releasing the rest of the book serially, so watch out as the story of the last ten years emerges.</p>\n<p>In the meantime, <a href=\"http://ma.tt/2013/05/dear-wordpress/\"> I penned my own letter to WordPress</a> and other community members have been sharing their thoughts:</p>\n<ul>\n<li><a href=\"http://zed1.com/journalized/archives/2013/01/25/wordpress-a-10-year-journey/\">Mike Little on our Ten Year Journey</a>.</li>\n<li>Core contributor Helen Hou-Sandi <a href=\"http://helen.wordpress.com/2013/05/27/happy-10th-wordpress-and-thanks-from-my-little-family/\">wishes WordPress happy birthday</a>.</li>\n<li>Peter Westwood on <a href=\"http://blog.ftwr.co.uk/archives/2013/05/27/a-decade-gone-more-to-come/\">a decade gone</a>.</li>\n<li>Support rep Mika Epstein <a href=\"http://ipstenu.org/2013/you-me-and-wp/\">on her WordPress journey</a>.</li>\n<li>Dougal Campbell <a href=\"http://dougal.gunters.org/blog/2013/05/27/instagram-my-wife-suzecampbell-and-i-celebrating-the-wordpress-10th-anniversary-with-bbq-in-our-wordpress-shirts-wp10/\">celebrating with his wife, Suze</a>.</li>\n<li>Otto on <a href=\"http://ottodestruct.com/blog/2013/how-wp-affected-me/\">how WordPress affected him</a>.</li>\n</ul>\n<p>You can see how WordPress&#8217; 10th Anniversary was celebrated all over the world <a href=\"http://wp10.wordpress.net/\">by visiting the wp10 website</a>, according to Meetup we had 4,999 celebrators.</p>\n<p>To finish, I just want to say thank you to everyone: to the developers who write the code, to the designers who make WordPress sing, to the worldwide community translating WordPress into so many languages, to volunteers who answer support questions, to those who make WordPress accessible, to the systems team and the plugin and theme reviewers, to documentation writers, event organisers, evangelists, detractors, supporters and friends. Thanks to the jazzers whose music inspired us and whose names are at the heart of WordPress. Thanks to everyone who uses WordPress to power their blog or website, and to everyone who will in the future. Thanks to WordPress and its community that I&#8217;m proud to be part of.</p>\n<p>Thank you. I can&#8217;t wait to see what the next ten years bring.</p>\n<p><em>Final thanks to <a href=\"http://siobhanmckeown.com/\">Siobhan McKeown</a> for help with this post.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/news/2013/05/ten-good-years/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"The Next 10 Starts Now\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 May 2013 20:47:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2594\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:365:\"All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. Watching the feed of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3901:\"<p>All around the globe today, people are celebrating the 10th anniversary of the first WordPress release, affectionately known as #wp10. <a href=\"http://wp10.wordpress.net\">Watching the feed</a> of photos, tweets, and posts from Auckland to Zambia is incredible; from first-time bloggers to successful WordPress-based business owners, people are coming out in droves to raise a glass and share the &#8220;holiday&#8221; with their local communities. With hundreds of parties going on today, it&#8217;s more visible than ever just how popular WordPress has become.</p>\n<p><strong>Thank you to everyone who has ever contributed to this project: your labors of love made this day possible.</strong></p>\n<p>But today isn&#8217;t just about reflecting on how we got this far (though I thought <a href=\"http://ma.tt/2013/05/dear-wordpress/\">Matt&#8217;s reflection on the first ten years</a> was lovely). We are constantly moving forward. As each release cycle begins and ends (3.6 will be here soon, promise!), we always see an ebb and flow in the contributor pool. Part of ensuring the longevity of WordPress means mentoring new contributors, continually bringing new talent and fresh points of view to our family table.</p>\n<p>I am beyond pleased to announce that this summer we will be mentoring 8 interns, most of them new contributors, through <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2013\">Google Summer of Code</a> and the <a href=\"https://live.gnome.org/OutreachProgramForWomen/2013/JuneSeptember\">Gnome Outreach Program for Women</a>. Current contributors, who already volunteer their time working on WordPress, will provide the guidance and oversight for a variety of exciting projects  this summer. Here are the people/projects involved in the summer internships:</p>\n<ul>\n<li><strong><strong>Ryan McCue</strong>, </strong>from Australia, working on a JSON-based REST API. Mentors will be Bryan Petty and Eric Mann, with a reviewer assist from Andrew Norcross.</li>\n<li><strong>Kat Hagan</strong>, from the United States, working on a Post by Email plugin to replace the core function. Mentors will be Justin Shreve and George Stephanis, with an assist from Peter Westwood.</li>\n<li><strong>Siobhan Bamber</strong>, from Wales, working on a support (forums, training, documentation) internship. Mentors will be Mika Epstein and Hanni Ross.</li>\n<li><strong>Frederick Ding</strong>, from the United States, working on improving portability. Mentors will be Andrew Nacin and Mike Schroder.</li>\n<li><strong>Sayak Sakar</strong>, from India, working on porting WordPress for WebOS to Firefox OS. Mentor will be Eric Johnson.</li>\n<li><strong>Alex Höreth</strong>, from Germany, working on  adding WordPress native revisions to the theme and plugin code editors. Mentors will be Dominik Schilling and Aaron Campbell, with a reviewer assist from Daniel Bachhuber.</li>\n<li><strong>Mert Yazicioglu</strong>, from Turkey, working on ways to improve our community profiles at profiles.wordpress.org. Mentors will be Scott Reilly and Boone Gorges.</li>\n<li><strong>Daniele Maio</strong>, from Italy, working on a native WordPress app for Blackberry 10. Mentor will be Danilo Ercoli.</li>\n</ul>\n<p>Did you notice that our summer cohort is as international as the #wp10 parties going on today? I can only think that this is a good sign.</p>\n<p>It&#8217;s always a difficult process to decide which projects to mentor through these programs. There are always more applicants with interesting ideas with whom we&#8217;d like to work than there are opportunities. Luckily, WordPress is a free/libre open source software project, and anyone can begin contributing at any time. Is this the year for you? We&#8217;d love for you to join us as we work toward #wp20. <img src=\'http://wordpress.org/news/wp-includes/images/smilies/icon_wink.gif\' alt=\';)\' class=\'wp-smiley\' /> </p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"http://wordpress.org/news/2013/05/the-next-10-starts-now/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.6 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 11 May 2013 03:44:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2584\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:374:\"WordPress 3.6 Beta 3 is now available! This is software still in development and we really don’t recommend that you run it on a production site — set up a test site just to play with the new version. To test WordPress 3.6, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). Beta [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2452:\"<p>WordPress 3.6 Beta 3 is now available!</p>\n<p>This is software still in development and <strong>we <em>really</em> don’t recommend that you run it on a production site</strong> — set up a test site just to play with the new version. To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.6-beta3.zip\">download the beta here</a> (zip).</p>\n<p>Beta 3 contains about a hundred changes, including improvements to the image Post Format flow (yay, drag-and-drop image upload!), a more polished revision comparison screen, and a more quote-like quote format for Twenty Thirteen.</p>\n<p>As a bonus, we now have oEmbed support for the popular music-streaming services <a href=\"http://www.rdio.com/\">Rdio</a> and <a href=\"http://www.spotify.com/\">Spotify</a> (the latter of which kindly created an oEmbed endpoint a mere 24 hours after we lamented their lack of one). Here&#8217;s an album that&#8217;s been getting a lot of play as I&#8217;ve been working on WordPress 3.6:</p>\n<p><iframe width=\"500\" height=\"250\" src=\"https://rd.io/i/Qj5r8SE//?source=oembed\" frameborder=\"0\"></iframe></p>\n<p><iframe src=\"https://embed.spotify.com/?uri=spotify:album:6dJZDZMNdBPZrJcNv57bEq\" width=\"300\" height=\"380\" frameborder=\"0\" allowtransparency=\"true\"></iframe></p>\n<p>Plugin developers, theme developers, and WordPress hosts should be testing beta 3 extensively. The more you test the beta, the more stable our release candidates and our final release will be.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.6\">everything we&#8217;ve fixed</a> so far.</p>\n<p>We&#8217;re looking forward to your feedback. If you find a bug, please report it, and if you’re a developer, try to help us fix it. We&#8217;ve already had more than 150 contributors to version 3.6 — it&#8217;s not too late to join in!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/05/wordpress-3-6-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.6 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 29 Apr 2013 22:48:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2579\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"WordPress 3.6 Beta 2 is now available! This is software still in development and we really don’t recommend that you run it on a production site — set up a test site just to play with the new version. To test WordPress 3.6, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). The [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2057:\"<p>WordPress 3.6 Beta 2 is now available!</p>\n<p>This is software still in development and <strong>we <em>really</em> don’t recommend that you run it on a production site</strong> — set up a test site just to play with the new version. To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.6-beta2.zip\">download the beta here</a> (zip).</p>\n<p>The longer-than-usual delay between beta 1 and beta 2 was due to poor user testing results with the Post Formats UI. Beta 2 contains a modified approach for format choosing and switching, which has done well in user testing. We&#8217;ve also made the Post Formats UI hide-able via Screen Options, and set a reasonable default based on what your theme supports.</p>\n<p>There were a lot of bug fixes and polishing tweaks done for beta 2 as well, so definitely check it out if you had an issues with beta 1.</p>\n<p>Plugin developers, theme developers, and WordPress hosts should be testing beta 2 extensively. The more you test the beta, the more stable our release candidates and our final release will be.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.6\">everything we&#8217;ve fixed</a> so far.</p>\n<p>We&#8217;re looking forward to your feedback. If you find a bug, please report it, and if you’re a developer, try to help us fix it. We&#8217;ve already had more than 150 contributors to version 3.6 — it&#8217;s not too late to join in!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"Summer Mentorship Programs: GSoC and Gnome\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 25 Apr 2013 03:18:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2573\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"As an open source, free software project, WordPress depends on the contributions of hundreds of people from around the globe &#8212; contributions in areas like core code, documentation, answering questions in the support forums, translation, and all the other things it takes to make WordPress the best publishing platform it can be, with the most [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:5071:\"<p>As an open source, free software project, WordPress depends on the contributions of hundreds of people from around the globe &#8212; contributions in areas like core code, documentation, answering questions in the support forums, translation, and all the other things it takes to make WordPress the best publishing platform it can be, with the most supportive community. This year, we&#8217;re happy to be participating as a mentoring organization with two respected summer internship programs: <a href=\"http://www.google-melange.com/gsoc/homepage/google/gsoc2013\">Google Summer of Code (GSoC)</a> and the Gnome Outreach Program for Women.</p>\n<h3>Google Summer of Code</h3>\n<p>GSoC is a summer internship program funded by Google specifically for college/university student developers to work on open source coding projects. We have participated in the Google Summer of Code program in the past, and have enjoyed the opportunity to work with students in this way. Some of our best core developers were GSoC students once upon a time!</p>\n<p><a href=\"http://codex.wordpress.org/GSoC2013#Mentors\">Our mentors</a>, almost 30 talented developers with experience developing WordPress, will provide students with guidance and feedback over the course of the summer, culminating in the release of finished projects at the end of the program if all goes well.</p>\n<p>Students who successfully complete the program earn $5,000 for their summer efforts. Interested, or know a college student (newly accepted to college counts, too) who should be? All the information you need about our participation in the program, projects, mentors, and the application process is available on the <a href=\"http://codex.wordpress.org/GSoC2013\">GSoC 2013 page in the Codex</a>.</p>\n<h3>Gnome Outreach Program for Women</h3>\n<p>It&#8217;s not news that women form a low percentage of contributors in most open source projects, and WordPress is no different. We have great women in the contributor community, including some in fairly visible roles, but we still have a lot of work to do to get a representative gender balance on par with our user base.</p>\n<p>The Gnome Outreach Program for Women aims to provide opportunities for women to participate in open source projects, and offers a similar stipend, but there are three key differences between GSoC and Gnome aside from the gender requirement for Gnome.</p>\n<ol>\n<li><span style=\"font-size: 13px;line-height: 19px\">The Gnome program allows intern projects in many areas of contribution, not just code. In other words, interns can propose projects like documentation, community management, design, translation, or pretty much any area in which we have people contributing (including code).</span></li>\n<li><span style=\"font-size: 13px;line-height: 19px\">The Gnome Outreach Program for Women doesn&#8217;t require interns to be college students, though students are definitely welcome to participate. This means that women in all stages of life and career can take the opportunity to try working with open source communities for the summer.</span></li>\n<li><span style=\"font-size: 13px;line-height: 19px\">We have to help raise the money to pay the interns. Google funds GSoC on its own, and we only have to provide our mentors&#8217; time. Gnome doesn&#8217;t have the same funding, so we need to pitch in to raise the money to cover our interns. If your company is interested in helping with this, please check out the program&#8217;s </span><a style=\"font-size: 13px;line-height: 19px\" href=\"https://live.gnome.org/OutreachProgramForWomen#For_Organizations_and_Companies\">sponsorship information</a><span style=\"font-size: 13px;line-height: 19px\"> and follow the contact instructions to get involved. You can earmark donations to support WordPress interns, or to support the program in general. (Pick us, pick us! <img src=\'http://wordpress.org/news/wp-includes/images/smilies/icon_smile.gif\' alt=\':)\' class=\'wp-smiley\' />  )</span></li>\n</ol>\n<p>The summer installment of the Gnome Outreach Program for Women follows the same schedule and general application format as GSoC, though there are more potential projects since it covers more areas of contribution. Women college students interested in doing a coding project are encouraged to apply for both programs to increase the odds of acceptance. All the information you need about our participation in the program, projects, mentors, and the application process is available on the <a href=\"http://codex.wordpress.org/Gnome_Summer_Program_for_Women\">Gnome Outreach Program for Women page in the Codex</a>.</p>\n<p>The application period just started, and it lasts another week (May 1 for Gnome, May 3 for GSoC), so if you think you qualify and are interested in getting involved, check out the information pages, get in touch, and apply… Good luck!</p>\n<p><a href=\"http://codex.wordpress.org/GSoC2013\">Google Summer of Code 2013 Information</a><br />\n<a href=\"http://codex.wordpress.org/Gnome_Summer_Program_for_Women\">Gnome Summer Outreach Program for Women 2013 Information</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://wordpress.org/news/2013/04/summer-mentorship-programs-gsoc-and-gnome/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:51:\"\n		\n		\n		\n		\n		\n				\n		\n		\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 10th Anniversary Tees\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/04/wordpress-10th-anniversary-tees/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/04/wordpress-10th-anniversary-tees/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 23 Apr 2013 16:40:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:4:{i:0;a:5:{s:4:\"data\";s:6:\"Events\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:5:\"Store\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:4:\"swag\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:3;a:5:{s:4:\"data\";s:4:\"wp10\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2561\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"In honor of the upcoming 10th anniversary celebrations, we&#8217;ve put a special 10th anniversary tshirt in the swag store at cost &#8212; $10 per shirt plus shipping. They&#8217;ll be on sale at this price until the anniversary on May 27, and they&#8217;ll start shipping out the week of April 29. Some people who are planning [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1943:\"<p><img class=\"alignleft wp-image-2562\" style=\"font-size: 13px;line-height: 19px;margin-right: 10px\" alt=\"WordPress 10th Anniversary logo\" src=\"http://wordpress.org/news/files/2013/04/wp10logo.jpg\" width=\"120\" height=\"119\" />In honor of the upcoming <a title=\"Save the Date: May 27\" href=\"http://wordpress.org/news/2013/04/save-the-date-may-27/\">10th anniversary celebrations</a>, we&#8217;ve put a special<a href=\"http://hellomerch.com/collections/wordpress/products/wordpress-10th-anniversary-t-shirt\"> 10th anniversary tshirt in the swag store</a> at cost &#8212; $10 per shirt plus shipping. They&#8217;ll be on sale at this price until the anniversary on May 27, and they&#8217;ll start shipping out the week of April 29.</p>\n<p>Some people who are planning parties or who organize meetups are already talking about doing group orders to save on shipping costs, which is a great idea &#8212; just make sure you allow enough shipping time. If you&#8217;re not sure if the tees could make it to you in time on your side of the world, use the contact options at the bottom of the store page to ask about shipping times. If they can&#8217;t reach you in time and you want to have a local printer do some for your group, we&#8217;ll post the vector file on the wp10 site within the next week (and this post will get updated accordingly). </p>\n<p>The shirts are available in black or silvery gray. Why silvery gray? Because of trivia: the traditional gift for 10th anniversaries is tin or aluminum. <img src=\'http://wordpress.org/news/wp-includes/images/smilies/icon_smile.gif\' alt=\':)\' class=\'wp-smiley\' /> </p>\n<p><a href=\"http://hellomerch.com/collections/wordpress/products/wordpress-10th-anniversary-t-shirt\"><img class=\"aligncenter size-full wp-image-2563\" alt=\"Silver and Black tshirts with WordPress 10th anniversary logo on them\" src=\"http://wordpress.org/news/files/2013/04/wp10shirtgrayblack.jpg\" width=\"643\" height=\"333\" /></a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/04/wordpress-10th-anniversary-tees/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Save the Date: May 27\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/04/save-the-date-may-27/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/04/save-the-date-may-27/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 11 Apr 2013 13:48:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Uncategorized\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2555\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"What&#8217;s on May 27, you ask? May 27, 2013 is the 10th anniversary of the first WordPress release! We think this is worth celebrating, and we want WordPress fans all over the world to celebrate with us by throwing their own parties. We&#8217;re using Meetup Everywhere to coordinate, and will be putting up a website [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2102:\"<p>What&#8217;s on May 27, you ask?</p>\n<p>May 27, 2013 is the <strong>10th anniversary</strong> of the <a href=\"http://wordpress.org/news/2003/05/wordpress-now-available/\">first WordPress release</a>!</p>\n<p>We think this is worth celebrating, and we want WordPress fans all over the world to celebrate with us by throwing their own parties. <a href=\"http://www.meetup.com/WordPress/\">We&#8217;re using Meetup Everywhere</a> to coordinate, and will be putting up a website just for the 10th Anniversary so that we can collect photos, videos, tweets, and posts from all the parties.</p>\n<p>The rules are very simple:</p>\n<ol>\n<li><span style=\"line-height: 12.997159004211426px\">Pick a place to go where a bunch of people can be merry &#8212; a park, a bar, a backyard, whatever</span></li>\n<li>Spread the word to local meetups, tech groups, press, etc and get people to say they&#8217;ll come to your party</li>\n<li>If 50 or more people RSVP to your party, we&#8217;ll try to send you some WordPress stickers and buttons</li>\n<li>Have party attendees post photos, videos, and the like with the #wp10 hashtag</li>\n</ol>\n<p>We&#8217;ll be using Meetup Everywhere to coordinate parties all over the world, so get your city on the map and <a href=\"http://www.meetup.com/WordPress/\">register your party now</a> !</p>\n<p>We&#8217;ll follow up with registered organizers  over the next few weeks with some tips for how to publicize your party and to get addresses for swag packages. To that end, make sure you check the option that lets WordPress 10th Anniversary know your email, or we won&#8217;t be able to get in touch with you for these things or to give you access to the WP10 blog.</p>\n<p>Whose party will be the biggest? The most fun? The most inventive? Will it be yours?</p>\n<p><em>Note: If you already run a group on meetup.com, making your party an event in your group is great, but you still need to post it and have people RSVP at the <a href=\"http://www.meetup.com/WordPress/\">special party page</a>, because regular groups and Meetup Everywhere groups aren&#8217;t connected yet. </em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/04/save-the-date-may-27/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.6 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 04 Apr 2013 17:25:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Uncategorized\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2547\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:381:\"WordPress 3.6 Beta 1 is now available! This is software still in development and we really don’t recommend that you run it on a production site — set up a test site just to play with the new version. To test WordPress 3.6, try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”). Or you can download the beta here (zip). We&#8217;ve [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mark Jaquith\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4085:\"<p>WordPress 3.6 Beta 1 is now available!</p>\n<p>This is software still in development and <strong>we <em>really</em> don’t recommend that you run it on a production site</strong> — set up a test site just to play with the new version. To test WordPress 3.6, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.6-beta1.zip\">download the beta here</a> (zip).</p>\n<p>We&#8217;ve been working for nearly three months and have completed all the features that are slated for this release. This is a bit of a change from the betas of previous release cycles. I felt very strongly that we shouldn&#8217;t release a beta if we were still working on completing the main features. This beta is <strong>actually a beta</strong>, not an alpha that we&#8217;re calling a beta. If you are a WordPress plugin or theme developer, or a WordPress hosting provider, you should absolutely start testing your code against this new version <strong>now</strong>. More bugs will be fixed, and some of the features will get polished, but we&#8217;re not going to shove in some big new feature. We&#8217;re ready for you to test it, so jump in there! The more you test the beta, the more stable our release candidates and our final release will be.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.6\">everything we&#8217;ve fixed</a> so far.</p>\n<p>Here&#8217;s what&#8217;s new in 3.6:</p>\n<ul>\n<li><strong>Post Formats: </strong> Post Formats now have their own UI, and theme authors have access to templating functions to access the structured data.</li>\n<li><strong>Twenty Thirteen:</strong> We&#8217;re shipping this year&#8217;s default theme in our first release of the year. Twenty Thirteen is an opinionated, color-rich, blog-centric theme that makes full use of the new Post Formats support.</li>\n<li><strong>Audio/Video:</strong> You can embed audio and video files into your posts without relying on a plugin or a third party media hosting service.</li>\n<li><strong>Autosave: </strong> Posts are now autosaved locally. If your browser crashes, your computer dies, or the server goes offline as you&#8217;re saving, you won&#8217;t lose the your post.</li>\n<li><strong>Post Locking: </strong> See when someone is currently editing a post, and kick them out of it if they fall asleep at the keyboard.</li>\n<li><strong>Nav Menus: </strong> Nav menus have been simplified with an accordion-based UI, and a separate tab for  bulk-assigning menus to locations.</li>\n<li><strong>Revisions:</strong> The all-new revisions UI features avatars, a slider that &#8220;scrubs&#8221; through history, and two-slider range comparisons.</li>\n</ul>\n<p><strong>Developers: </strong> You make WordPress awesome(er). One of the things we strive to do with every release is be compatible with existing plugins and themes. But we need your help. <strong>Please test your plugins and themes against 3.6.</strong> If something isn&#8217;t quite right, please let us know. (Chances are, it wasn&#8217;t intentional.) If you&#8217;re a forward-thinking theme developer, you should be looking at implementing the new Post Format support in some of your themes (look to Twenty Thirteen for inspiration).</p>\n<p>We&#8217;re looking forward to your feedback. If you break it (i.e. find a bug), please report it, and if you’re a developer, try to help us fix it. We&#8217;ve already had more than 150 contributors to version 3.6 — it&#8217;s not too late to join the party!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/04/wordpress-3-6-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress 3.5.1 Maintenance and Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/01/wordpress-3-5-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2013/01/wordpress-3-5-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Jan 2013 22:23:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2531\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:363:\"WordPress 3.5.1 is now available. Version 3.5.1 is the first maintenance release of 3.5, fixing 37 bugs. It is also a security release for all previous WordPress versions. For a full list of changes, consult the list of tickets and the changelog, which include: Editor: Prevent certain HTML elements from being unexpectedly removed or modified in rare [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2499:\"<p>WordPress 3.5.1 is now available. Version 3.5.1 is the first maintenance release of 3.5, <a href=\"http://core.trac.wordpress.org/milestone/3.5.1\">fixing 37 bugs</a>. It is also a security release for all previous WordPress versions. For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.5.1\">list of tickets</a> and the <a href=\"http://core.trac.wordpress.org/log/branches/3.5?rev=23341&amp;stop_rev=23167\">changelog</a>, which include:</p>\n<ul>\n<li>Editor: Prevent certain HTML elements from being unexpectedly removed or modified in rare cases.</li>\n<li>Media: Fix a collection of minor workflow and compatibility issues in the new media manager.</li>\n<li>Networks: Suggest proper rewrite rules when creating a new network.</li>\n<li>Prevent scheduled posts from being stripped of certain HTML, such as video embeds, when they are published.</li>\n<li>Work around some misconfigurations that may have caused some JavaScript in the WordPress admin area to fail.</li>\n<li>Suppress some warnings that could occur when a plugin misused the database or user APIs.</li>\n</ul>\n<p>Additionally, a bug affecting Windows servers running IIS can prevent updating from 3.5 to 3.5.1. If you receive the error &#8220;Destination directory for file streaming does not exist or is not writable,&#8221; you will need to <a href=\"http://codex.wordpress.org/Version_3.5.1\">follow the steps outlined on the Codex</a>.</p>\n<p>WordPress 3.5.1 also addresses the following security issues:</p>\n<ul>\n<li>A server-side request forgery vulnerability and remote port scanning using pingbacks. This vulnerability, which could potentially be used to expose information and compromise a site, affects all previous WordPress versions. This was fixed by the WordPress security team. We&#8217;d like to thank security researchers <a href=\"http://codeseekah.com/\">Gennady Kovshenin</a> and <a href=\"http://www.ethicalhack3r.co.uk/\">Ryan Dewhurst</a> for reviewing our work.</li>\n<li>Two instances of cross-site scripting via shortcodes and post content. These issues were discovered by Jon Cave of the WordPress security team.</li>\n<li>A cross-site scripting vulnerability in the external library Plupload. Thanks to the Moxiecode team for working with us on this, and for releasing Plupload 1.5.5 to address this issue.</li>\n</ul>\n<p><strong><a href=\"http://wordpress.org/download/\">Download 3.5.1</a> or visit Dashboard → Updates in your site admin to update now.</strong></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/01/wordpress-3-5-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"2012: A Look Back\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/news/2013/01/2012-a-look-back/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/01/2012-a-look-back/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 01 Jan 2013 02:22:20 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Uncategorized\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2525\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:344:\"Another year is coming to a close, and it&#8217;s time to look back and reflect on what we&#8217;ve accomplished in the past twelve months. The WordPress community is stronger than ever, and some of the accomplishments of the past year are definitely worth remembering. Software Releases We had two major releases of the WordPress web [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4441:\"<p>Another year is coming to a close, and it&#8217;s time to look back and reflect on what we&#8217;ve accomplished in the past twelve months. The WordPress community is stronger than ever, and some of the accomplishments of the past year are definitely worth remembering.</p>\n<h4>Software Releases</h4>\n<p>We had two major releases of the WordPress web application with versions <a href=\"http://wordpress.org/news/2012/06/green/\">3.4</a> and <a href=\"http://wordpress.org/news/2012/12/elvin/\">3.5</a>, as well as 5 security releases during 2012. 3.4 included the theme customizer, while 3.5 became the long awaited &#8220;media release&#8221; featuring a new uploader and gallery management tool. 3.5 contained code contributions from more people than ever, and we hope to continue growing the contributor ranks in the year ahead. We currently have native apps on 6 mobile platforms &#8212; <a href=\"http://ios.wordpress.org/\">iOS</a>, <a href=\"http://android.wordpress.org/\">Android</a>, <a href=\"http://blackberry.wordpress.org/\">Blackberry</a>, <a href=\"http://wpwindowsphone.wordpress.com/\">Windows Phone</a>, <a href=\"http://nokia.wordpress.org/\">Nokia</a>, and <a href=\"http://webos.wordpress.org/\">WebOS</a> &#8212; and saw several updates there as well.</p>\n<h4>Plugin Directory</h4>\n<p>A number of improvements were made to the Plugin Directory in 2012. More cosmetic  updates, like the introduction of branded plugin page headers, make it a nicer browsing experience, while functional changes like better-integrated support forums, plugin reviews, and a favorites system made the plugin directory even more useful as a resource.</p>\n<h4>The &#8220;Make&#8221; Network and Team Reps</h4>\n<p>2012 was the year that saw the creation of <a href=\"http://make.wordpress.org/\">Make.wordpress.org</a>, a network of sites for the teams of contributors responsible for the different areas of the WordPress project. Now anyone can follow along and get involved with the teams that work on <a href=\"http://make.wordpress.org/core/\">core</a>, <a href=\"http://make.wordpress.org/themes/\">theme review</a>, <a href=\"http://make.wordpress.org/support/\">forum support</a>, <a href=\"http://make.wordpress.org/docs/\">documentation</a>, and more. In 2013 we&#8217;ll work to improve these sites to make it easier to become a contributor. Each team also now has elected Team Reps, a new role that has already led to more cross-team communication. Team reps post each week to the <a href=\"https://make.wordpress.org/updates/\">Updates blog</a> so that the other reps can keep up with what&#8217;s going on in other teams.</p>\n<h4>WordPress Community Summit</h4>\n<p>At the end of October, about 100 of the most influential and respected members of the WordPress community attended an inaugural <a href=\"https://make.wordpress.org/summit\">summit</a> to discuss where we all stand, and to figure out where we go next with WordPress. A &#8220;conference of conversations,&#8221; this unconference made everyone an active participant, and while not every issue brought to the table was solved by the end of the event, the right questions were being asked.</p>\n<h4>Meetup.com</h4>\n<p>The WordPress Foundation now has a central account with Meetup.com. We&#8217;ve brought in a couple dozen existing meetup groups as a pilot to test the system, and are in the process of working with more existing meetups (as well as new ones) to join us so that local organizers won&#8217;t have to pay organizer dues and can get more support from the WordPress project.</p>\n<h4>Internet Blackout Day</h4>\n<p>We participated in the protest against SOPA/PIPA, Internet Blackout Day, on January 18. Though we usually stay out of politics, this campaign was important, and we not only participated in the blackout on WordPress.org, we encouraged our users to do so as well, and recommended plugins to provide blackout functionality. It was deemed the <a href=\"http://sopastrike.com/numbers/\">largest online protest in history</a>.</p>\n<h4>WordCamps</h4>\n<p>And finally, it wouldn&#8217;t be a recap without counting up the <a href=\"http://wordcamp.org\">WordCamps</a>! There were 67 WordCamps around the world in 2012, bringing together WordPress users, developers, and fans. If you didn&#8217;t make it to a WordCamp this year, maybe it can be one of your new year resolutions: <a href=\"http://central.wordcamp.org/schedule/\">check the schedule</a> to find one near you!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/news/2013/01/2012-a-look-back/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Wed, 12 Jun 2013 17:08:10 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Sun, 02 Jun 2013 02:32:53 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20130602101200\";}", "no");
INSERT INTO `wp_options` VALUES("305", "_transient_timeout_feed_mod_57bc725ad6568758915363af670fd8bc", "1371100091", "no");
INSERT INTO `wp_options` VALUES("306", "_transient_feed_mod_57bc725ad6568758915363af670fd8bc", "1371056891", "no");
INSERT INTO `wp_options` VALUES("309", "_transient_timeout_dash_de3249c4736ad3bd2cd29147c4a0d43e", "1371100091", "no");
INSERT INTO `wp_options` VALUES("191", "_transient_timeout_feed_1a5f760f2e2b48827d4974a60857e7c2", "1370211088", "no");
INSERT INTO `wp_options` VALUES("192", "_transient_feed_1a5f760f2e2b48827d4974a60857e7c2", "a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WordPress Plugins » View: Recently Updated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/updated/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"WordPress Plugins » View: Recently Updated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 02 Jun 2013 10:10:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Print-O-Matic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/print-o-matic/#post-45367\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 07 Nov 2012 14:04:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"45367@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Adds the ability to print any post or post element using a simple [print-me] shortcode. Extra jQuery Jedi love given to filled out forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Baden\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"viplus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/viplus/#post-53180\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 12 May 2013 08:39:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53180@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:150:\"V.I.Plus registration plug-in enables you to integrate your V.I.Plus account with WordPress system.\nAfter installing the plug-in you will have a widge\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"atplogic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Contextual Related Posts\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/plugins/contextual-related-posts/#post-8666\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 19 Jan 2009 15:09:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8666@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:118:\"Display related posts on your WordPress blog and feed. Supports thumbnails, shortcodes, widgets and custom post types!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Ajay\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Live Chat - Casengo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/plugins/the-casengo-chat-widget/#post-46359\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 Nov 2012 12:48:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"46359@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:112:\"Casengo is Customer Support Software (Live Chat, Email, Social Media) from the Cloud, First User is Always Free!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"casengo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"danixland-countdown\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/plugins/danixland-countdown/#post-53758\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 27 May 2013 12:03:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53758@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"This plugin adds a simple widget and shows a countdown to a future date.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"danixland\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WP Symposium Toolbar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.org/plugins/wp-symposium-toolbar/#post-52635\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 27 Apr 2013 06:39:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"52635@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"Toolbar plugin for WP Symposium - And the WordPress Toolbar can finally be part of your Social Network site\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"AlphaGolf_fr\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Checkbox Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/checkbox-captcha/#post-53976\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 31 May 2013 15:51:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53976@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Captcha made right!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Andrei\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Amazon Explorer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/amazon-explorer/#post-53244\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 13 May 2013 23:53:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53244@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Amazon Search Utility for any site page. Allows your visitors to search all of Amazon. Your Associate Account is Credited for every sale.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Debra Berube\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"GalleryLink\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/gallerylink/#post-53853\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 29 May 2013 06:33:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"53853@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Output as a gallery by find the file extension and directory specified.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"Katsushi Kawamori\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Cumulonimbus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/cumulonimbus/#post-50217\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 04 Mar 2013 15:04:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"50217@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"Cumulonimbus allows you to display your site&#039;s tags on the surface of a rotating sphere.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"beeender\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Google Adsense Plug and Play\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.org/plugins/google-adsense-plug-and-play/#post-45780\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 15 Nov 2012 13:03:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"45780@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"Inserts ads into your posts and pages and has widgets for your sidebar, inserting ads made easy!\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"DeWandelaar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Microblog Poster\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://wordpress.org/plugins/microblog-poster/#post-33140\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 20 Dec 2011 12:48:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"33140@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"Automatically publishes your new blog content to Social Networks. Auto-updates Twitter, Facebook, Plurk, Identica, Delicious..\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"cybperic\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"SEO Plugin by SQUIRRLY\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/squirrly-seo/#post-47657\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 02 Jan 2013 17:06:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"47657@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:127:\"Squirrly SEO Plugin helps you write excellent SEO articles for your WordPress and do keyword researches in less then 2 minutes.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Squirrly Limited UK\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"jContact\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/plugins/jcontact/#post-51482\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 03 Apr 2013 16:13:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"51482@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"This is Ajax based contact form plugin with user notification and admin interface to handle user requests.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"amitmalakar\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Popular Widget\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/popular-widget/#post-24769\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 27 Feb 2011 01:28:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"24769@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:142:\"Display the most commented or most viewed posts in a tabbed widget, filter the post by date range or by category. It also includes a tags tab.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:3:\"Hax\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/updated\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Sun, 02 Jun 2013 10:11:28 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Wed, 07 Nov 2012 14:04:58 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20090627192103\";}", "no");
INSERT INTO `wp_options` VALUES("193", "_transient_timeout_feed_mod_1a5f760f2e2b48827d4974a60857e7c2", "1370211088", "no");
INSERT INTO `wp_options` VALUES("194", "_transient_feed_mod_1a5f760f2e2b48827d4974a60857e7c2", "1370167888", "no");
INSERT INTO `wp_options` VALUES("307", "_transient_timeout_plugin_slugs", "1371166514", "no");
INSERT INTO `wp_options` VALUES("308", "_transient_plugin_slugs", "a:3:{i:0;s:19:\"akismet/akismet.php\";i:1;s:25:\"duplicator/duplicator.php\";i:2;s:9:\"hello.php\";}", "no");
INSERT INTO `wp_options` VALUES("316", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("201", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("202", "_site_transient_update_core", "O:8:\"stdClass\":3:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":9:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:40:\"http://wordpress.org/wordpress-3.5.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":4:{s:4:\"full\";s:40:\"http://wordpress.org/wordpress-3.5.1.zip\";s:10:\"no_content\";s:51:\"http://wordpress.org/wordpress-3.5.1-no-content.zip\";s:11:\"new_bundled\";s:52:\"http://wordpress.org/wordpress-3.5.1-new-bundled.zip\";s:7:\"partial\";b:0;}s:7:\"current\";s:5:\"3.5.1\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.5\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1371080046;s:15:\"version_checked\";s:5:\"3.5.1\";}", "yes");
INSERT INTO `wp_options` VALUES("203", "can_compress_scripts", "1", "yes");
INSERT INTO `wp_options` VALUES("209", "theme_mods_twentyeleven", "a:1:{s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1370168091;s:4:\"data\";a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:6:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:17:\"recent-comments-2\";i:3;s:10:\"archives-2\";i:4;s:12:\"categories-2\";i:5;s:6:\"meta-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("210", "theme_mods_striking", "a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1371059228;s:4:\"data\";a:11:{s:19:\"wp_inactive_widgets\";a:2:{i:0;s:6:\"text-2\";i:1;s:6:\"text-3\";}s:9:\"sidebar-1\";a:3:{i:0;s:8:\"search-2\";i:1;s:14:\"recent-posts-2\";i:2;s:12:\"categories-2\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}s:9:\"sidebar-4\";a:0:{}s:9:\"sidebar-5\";a:0:{}s:9:\"sidebar-6\";N;s:9:\"sidebar-7\";N;s:9:\"sidebar-8\";N;s:9:\"sidebar-9\";N;s:10:\"sidebar-10\";N;}}}", "yes");
INSERT INTO `wp_options` VALUES("211", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("212", "striking_blog", "a:40:{s:9:\"blog_page\";s:0:\"\";s:6:\"layout\";s:5:\"right\";s:7:\"columns\";s:1:\"1\";s:5:\"frame\";b:0;s:20:\"index_featured_image\";b:1;s:19:\"featured_image_type\";s:4:\"full\";s:29:\"index_featured_image_lightbox\";b:0;s:12:\"display_full\";b:0;s:31:\"exclude_categorys_for_blog_page\";a:0:{}s:17:\"exclude_categorys\";a:0:{}s:9:\"posts_gap\";s:2:\"80\";s:6:\"effect\";s:4:\"icon\";s:22:\"author_link_to_website\";b:1;s:13:\"search_layout\";s:5:\"right\";s:19:\"search_display_full\";b:0;s:20:\"search_nothing_found\";s:0:\"\";s:13:\"single_layout\";s:5:\"right\";s:14:\"featured_image\";b:1;s:26:\"single_featured_image_type\";s:4:\"full\";s:23:\"featured_image_lightbox\";b:0;s:31:\"featured_image_lightbox_gallery\";b:0;s:13:\"single_effect\";s:4:\"none\";s:14:\"show_in_header\";b:1;s:6:\"author\";b:1;s:15:\"related_popular\";b:1;s:15:\"related_base_on\";s:4:\"tags\";s:16:\"entry_navigation\";b:0;s:26:\"single_navigation_category\";b:0;s:10:\"meta_items\";a:0:{}s:17:\"single_meta_items\";a:0:{}s:9:\"read_more\";b:1;s:16:\"read_more_button\";b:0;s:14:\"read_more_text\";s:17:\"Read more &raquo;\";s:15:\"adaptive_height\";b:0;s:12:\"fixed_height\";s:3:\"250\";s:10:\"left_width\";s:3:\"200\";s:11:\"left_height\";s:3:\"200\";s:25:\"display_default_thumbnail\";b:1;s:24:\"default_thumbnail_custom\";s:0:\"\";i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("213", "striking_meta_information_fixed", "1", "yes");
INSERT INTO `wp_options` VALUES("214", "striking_page_for_posts_fixed", "1", "yes");
INSERT INTO `wp_options` VALUES("215", "striking_upload_option_source_fixed", "1", "yes");
INSERT INTO `wp_options` VALUES("216", "striking_general", "a:23:{s:13:\"header_height\";s:2:\"90\";s:12:\"display_logo\";b:0;s:4:\"logo\";a:0:{}s:17:\"display_site_desc\";b:1;s:11:\"logo_bottom\";s:2:\"20\";s:13:\"top_area_type\";s:0:\"\";s:13:\"top_area_html\";s:0:\"\";s:10:\"nav_button\";b:0;s:9:\"nav_arrow\";b:0;s:15:\"enable_nav_menu\";b:1;s:14:\"excluded_pages\";a:0:{}s:17:\"enable_box_layout\";b:0;s:6:\"layout\";s:5:\"right\";s:14:\"custom_favicon\";s:0:\"\";s:9:\"introduce\";b:1;s:18:\"disable_breadcrumb\";b:0;s:20:\"lightbox_rel_replace\";b:0;s:13:\"scroll_to_top\";b:0;s:18:\"analytics_position\";s:6:\"bottom\";s:9:\"analytics\";s:0:\"\";s:10:\"custom_css\";s:0:\"\";s:9:\"custom_js\";s:0:\"\";i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("217", "striking_background", "a:26:{s:9:\"box_image\";a:0:{}s:14:\"box_position_x\";s:6:\"center\";s:14:\"box_position_y\";s:3:\"top\";s:10:\"box_repeat\";s:9:\"no-repeat\";s:14:\"box_attachment\";s:6:\"scroll\";s:12:\"header_image\";a:0:{}s:17:\"header_position_x\";s:6:\"center\";s:17:\"header_position_y\";s:3:\"top\";s:13:\"header_repeat\";s:9:\"no-repeat\";s:17:\"header_attachment\";s:6:\"scroll\";s:13:\"feature_image\";a:0:{}s:18:\"feature_position_x\";s:6:\"center\";s:18:\"feature_position_y\";s:3:\"top\";s:14:\"feature_repeat\";s:9:\"no-repeat\";s:18:\"feature_attachment\";s:6:\"scroll\";s:10:\"page_image\";a:0:{}s:15:\"page_position_x\";s:6:\"center\";s:15:\"page_position_y\";s:3:\"top\";s:11:\"page_repeat\";s:9:\"no-repeat\";s:15:\"page_attachment\";s:6:\"scroll\";s:12:\"footer_image\";a:0:{}s:17:\"footer_position_x\";s:6:\"center\";s:17:\"footer_position_y\";s:3:\"top\";s:13:\"footer_repeat\";s:9:\"no-repeat\";s:17:\"footer_attachment\";s:6:\"scroll\";i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("218", "striking_slideshow_source_fixed", "1", "yes");
INSERT INTO `wp_options` VALUES("219", "striking_homepage", "a:8:{s:9:\"home_page\";i:0;s:6:\"layout\";s:4:\"full\";s:17:\"disable_slideshow\";b:0;s:18:\"slideshow_category\";s:3:\"{s}\";s:16:\"slideshow_number\";s:1:\"0\";s:14:\"slideshow_type\";s:4:\"nivo\";s:12:\"page_content\";s:0:\"\";i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("220", "striking_version", "5.1.8.3", "yes");
INSERT INTO `wp_options` VALUES("322", "_transient_timeout_striking_update", "1371102254", "no");
INSERT INTO `wp_options` VALUES("323", "_transient_striking_update", "5.1.9.6", "no");
INSERT INTO `wp_options` VALUES("513", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("514", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1371090856", "yes");
INSERT INTO `wp_options` VALUES("326", "pagenavi_options", "a:12:{s:10:\"pages_text\";s:36:\"Page %CURRENT_PAGE% of %TOTAL_PAGES%\";s:12:\"current_text\";s:13:\"%PAGE_NUMBER%\";s:9:\"page_text\";s:13:\"%PAGE_NUMBER%\";s:10:\"first_text\";s:13:\"&laquo; First\";s:9:\"last_text\";s:12:\"Last &raquo;\";s:9:\"next_text\";s:7:\"&raquo;\";s:9:\"prev_text\";s:7:\"&laquo;\";s:13:\"dotright_text\";s:3:\"...\";s:12:\"dotleft_text\";s:3:\"...\";s:5:\"style\";i:1;s:9:\"num_pages\";i:5;s:11:\"always_show\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("230", "theme_mods_twentytwelve", "a:9:{i:0;b:0;s:16:\"header_textcolor\";s:6:\"0602f2\";s:16:\"background_color\";s:6:\"e6e6e6\";s:16:\"background_image\";s:0:\"\";s:17:\"background_repeat\";s:6:\"repeat\";s:21:\"background_position_x\";s:4:\"left\";s:21:\"background_attachment\";s:5:\"fixed\";s:12:\"header_image\";s:13:\"remove-header\";s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1371059053;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:5:{i:0;s:8:\"search-2\";i:1;s:6:\"text-2\";i:2;s:12:\"categories-2\";i:3;s:14:\"recent-posts-2\";i:4;s:6:\"text-3\";}s:9:\"sidebar-2\";a:0:{}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("325", "theme_mods_flexibility3", "a:1:{i:0;b:0;}", "yes");
INSERT INTO `wp_options` VALUES("327", "flex_blog_width", "920", "yes");
INSERT INTO `wp_options` VALUES("328", "flex_content_width", "560", "yes");
INSERT INTO `wp_options` VALUES("329", "flex_lsidebar_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("330", "flex_lsidebar_width", "190", "yes");
INSERT INTO `wp_options` VALUES("331", "flex_rsidebar_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("332", "flex_rsidebar_width", "130", "yes");
INSERT INTO `wp_options` VALUES("333", "flex_page_backgroundcolor", "526074", "yes");
INSERT INTO `wp_options` VALUES("334", "flex_blog_bgimage", "diaglines.png", "yes");
INSERT INTO `wp_options` VALUES("335", "flex_blog_custombg", "none", "yes");
INSERT INTO `wp_options` VALUES("336", "flex_blog_bgrepeat", "repeat", "yes");
INSERT INTO `wp_options` VALUES("337", "flex_blog_bgfade", "yes", "yes");
INSERT INTO `wp_options` VALUES("338", "flex_blog_bordercolor", "000000", "yes");
INSERT INTO `wp_options` VALUES("339", "flex_blog_borderwidth", "2", "yes");
INSERT INTO `wp_options` VALUES("340", "flex_blog_margin", "15", "yes");
INSERT INTO `wp_options` VALUES("341", "flex_blog_font", "Arial", "yes");
INSERT INTO `wp_options` VALUES("342", "flex_blog_size", "12", "yes");
INSERT INTO `wp_options` VALUES("343", "flex_blog_tc", "333333", "yes");
INSERT INTO `wp_options` VALUES("344", "flex_blog_tclink", "A10000", "yes");
INSERT INTO `wp_options` VALUES("345", "flex_content_color", "F0EBE3", "yes");
INSERT INTO `wp_options` VALUES("346", "flex_header_trans", "no", "yes");
INSERT INTO `wp_options` VALUES("347", "flex_header_backgroundcolor", "A10000", "yes");
INSERT INTO `wp_options` VALUES("348", "flex_header_bg", "Flare.png", "yes");
INSERT INTO `wp_options` VALUES("349", "flex_head_image", "", "yes");
INSERT INTO `wp_options` VALUES("350", "flex_head_height", "120", "yes");
INSERT INTO `wp_options` VALUES("351", "flex_head_toppad", "20", "yes");
INSERT INTO `wp_options` VALUES("352", "flex_blog_logo", "", "yes");
INSERT INTO `wp_options` VALUES("353", "flex_title_seo", "yes", "yes");
INSERT INTO `wp_options` VALUES("354", "flex_title_font", "Georgia", "yes");
INSERT INTO `wp_options` VALUES("355", "flex_title_size", "34", "yes");
INSERT INTO `wp_options` VALUES("356", "flex_title_clr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("357", "flex_title_hvr", "999999", "yes");
INSERT INTO `wp_options` VALUES("358", "flex_tagline_color", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("359", "flex_search_visibility", "yes", "yes");
INSERT INTO `wp_options` VALUES("360", "flex_search_txt", "Search our site...", "yes");
INSERT INTO `wp_options` VALUES("361", "flex_search_img", "topmesh.png", "yes");
INSERT INTO `wp_options` VALUES("362", "flex_search_margin", "0", "yes");
INSERT INTO `wp_options` VALUES("363", "flex_subrss_visibility", "yes", "yes");
INSERT INTO `wp_options` VALUES("364", "flex_rss_icon", "rssglassyblack", "yes");
INSERT INTO `wp_options` VALUES("365", "flex_email_address", "", "yes");
INSERT INTO `wp_options` VALUES("366", "flex_rss_color", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("367", "flex_rss_hover", "999999", "yes");
INSERT INTO `wp_options` VALUES("368", "flex_nav_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("369", "flex_nav_position", "above", "yes");
INSERT INTO `wp_options` VALUES("370", "flex_nav_home", "yes", "yes");
INSERT INTO `wp_options` VALUES("371", "flex_nav_style", "tabs", "yes");
INSERT INTO `wp_options` VALUES("372", "flex_nav_color", "A10000", "yes");
INSERT INTO `wp_options` VALUES("373", "flex_nav_tabhvr", "A10000", "yes");
INSERT INTO `wp_options` VALUES("374", "flex_nav_tabact", "A10000", "yes");
INSERT INTO `wp_options` VALUES("375", "flex_nav_txtclr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("376", "flex_nav_hvrcolor", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("377", "flex_nav_font", "Arial", "yes");
INSERT INTO `wp_options` VALUES("378", "flex_nav_txtsize", "12", "yes");
INSERT INTO `wp_options` VALUES("379", "flex_nav_fontwt", "normal", "yes");
INSERT INTO `wp_options` VALUES("380", "flex_nav_border", "no", "yes");
INSERT INTO `wp_options` VALUES("381", "flex_nav_showarrow", "true", "yes");
INSERT INTO `wp_options` VALUES("382", "flex_nav_subwidth", "150", "yes");
INSERT INTO `wp_options` VALUES("383", "flex_nav_subheight", "30", "yes");
INSERT INTO `wp_options` VALUES("384", "flex_nav_subback", "1F242C", "yes");
INSERT INTO `wp_options` VALUES("385", "flex_nav_subhov", "3D4A57", "yes");
INSERT INTO `wp_options` VALUES("386", "flex_nav_subtext", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("387", "flex_nav_subtexthov", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("388", "flex_nav_subborder", "1", "yes");
INSERT INTO `wp_options` VALUES("389", "flex_nav_subbrdrclr", "000000", "yes");
INSERT INTO `wp_options` VALUES("390", "flex_feat_display", "yes", "yes");
INSERT INTO `wp_options` VALUES("391", "flex_feat_pages", "home only", "yes");
INSERT INTO `wp_options` VALUES("392", "flex_feat_widgets", "2", "yes");
INSERT INTO `wp_options` VALUES("393", "flex_feat_shadow", "yes", "yes");
INSERT INTO `wp_options` VALUES("394", "flex_feat_bgcolor", "1F242C", "yes");
INSERT INTO `wp_options` VALUES("395", "flex_feat_txtcolor", "999999", "yes");
INSERT INTO `wp_options` VALUES("396", "flex_feat_linkcolor", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("397", "flex_feat_hovercolor", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("398", "flex_feat_fontsize", "18", "yes");
INSERT INTO `wp_options` VALUES("399", "flex_feat_titlecolor", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("400", "flex_feat_bullet", "light arrow", "yes");
INSERT INTO `wp_options` VALUES("401", "flex_post_clr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("402", "flex_post_brdr", "D7CAB5", "yes");
INSERT INTO `wp_options` VALUES("403", "flex_post_font", "Georgia", "yes");
INSERT INTO `wp_options` VALUES("404", "flex_post_titalign", "left", "yes");
INSERT INTO `wp_options` VALUES("405", "flex_post_color", "333333", "yes");
INSERT INTO `wp_options` VALUES("406", "flex_post_titlebg", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("407", "flex_post_hover", "999999", "yes");
INSERT INTO `wp_options` VALUES("408", "flex_post_size", "22", "yes");
INSERT INTO `wp_options` VALUES("409", "flex_post_weight", "normal", "yes");
INSERT INTO `wp_options` VALUES("410", "flex_post_h1pad", "8", "yes");
INSERT INTO `wp_options` VALUES("411", "flex_ptitle_uline", "solid", "yes");
INSERT INTO `wp_options` VALUES("412", "flex_ptitle_ulines", "1", "yes");
INSERT INTO `wp_options` VALUES("413", "flex_ptitle_ulinec", "EEEEEE", "yes");
INSERT INTO `wp_options` VALUES("414", "flex_metadata_show", "yes", "yes");
INSERT INTO `wp_options` VALUES("415", "flex_metadata_color", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("416", "flex_metadata_bg", "no", "yes");
INSERT INTO `wp_options` VALUES("417", "flex_metadata_link", "666666", "yes");
INSERT INTO `wp_options` VALUES("418", "flex_posttext_color", "333333", "yes");
INSERT INTO `wp_options` VALUES("419", "flex_link_color", "A10000", "yes");
INSERT INTO `wp_options` VALUES("420", "flex_link_hover", "000000", "yes");
INSERT INTO `wp_options` VALUES("421", "flex_link_und", "no", "yes");
INSERT INTO `wp_options` VALUES("422", "flex_bquote_color", "CCCCCC", "yes");
INSERT INTO `wp_options` VALUES("423", "flex_bquote_border", "999999", "yes");
INSERT INTO `wp_options` VALUES("424", "flex_show_tags", "yes", "yes");
INSERT INTO `wp_options` VALUES("425", "flex_show_cats", "yes", "yes");
INSERT INTO `wp_options` VALUES("426", "flex_show_where", "just posts", "yes");
INSERT INTO `wp_options` VALUES("427", "flex_show_like", "yes", "yes");
INSERT INTO `wp_options` VALUES("428", "flex_pagenavi_bg", "A79789", "yes");
INSERT INTO `wp_options` VALUES("429", "flex_pagenavi_hover", "7A6758", "yes");
INSERT INTO `wp_options` VALUES("430", "flex_pagenavi_active", "900000", "yes");
INSERT INTO `wp_options` VALUES("431", "flex_pagenavi_text", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("432", "flex_comments_background", "F9F7F2", "yes");
INSERT INTO `wp_options` VALUES("433", "flex_comments_border", "D7CAB5", "yes");
INSERT INTO `wp_options` VALUES("434", "flex_admin_comments", "D7CAB5", "yes");
INSERT INTO `wp_options` VALUES("435", "flex_comments_text", "333333", "yes");
INSERT INTO `wp_options` VALUES("436", "flex_comments_link", "A10000", "yes");
INSERT INTO `wp_options` VALUES("437", "flex_comments_linkund", "no", "yes");
INSERT INTO `wp_options` VALUES("438", "flex_comments_reply", "A10000", "yes");
INSERT INTO `wp_options` VALUES("439", "flex_comments_button", "A10000", "yes");
INSERT INTO `wp_options` VALUES("440", "flex_comments_buttext", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("441", "flex_sidebar_visibility", "yes", "yes");
INSERT INTO `wp_options` VALUES("442", "flex_sidebar_toptitle", "About my blog", "yes");
INSERT INTO `wp_options` VALUES("443", "flex_sidebar_boxtext", "You can easily change this information in the Flexibility Theme Options page.<br/><br/> Simply type what you want to say and it will be displayed here!", "yes");
INSERT INTO `wp_options` VALUES("444", "flex_sidebar_boxcolor", "F9F7F2", "yes");
INSERT INTO `wp_options` VALUES("445", "flex_sidebar_topfont", "Arial", "yes");
INSERT INTO `wp_options` VALUES("446", "flex_sidebar_tfontsize", "14", "yes");
INSERT INTO `wp_options` VALUES("447", "flex_sidebar_case", "none", "yes");
INSERT INTO `wp_options` VALUES("448", "flex_sidebar_tfontspace", "0", "yes");
INSERT INTO `wp_options` VALUES("449", "flex_sidebar_align", "left", "yes");
INSERT INTO `wp_options` VALUES("450", "flex_sidebar_title", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("451", "flex_sidebar_titlebackground", "A10000", "yes");
INSERT INTO `wp_options` VALUES("452", "flex_sidebar_arrow", "yes", "yes");
INSERT INTO `wp_options` VALUES("453", "flex_sidebar_boxborder", "D7CAB5", "yes");
INSERT INTO `wp_options` VALUES("454", "flex_sidebar_textcolor", "333333", "yes");
INSERT INTO `wp_options` VALUES("455", "flex_sidebar_textlink", "333333", "yes");
INSERT INTO `wp_options` VALUES("456", "flex_sidebar_hovercolor", "A10000", "yes");
INSERT INTO `wp_options` VALUES("457", "flex_sidebar_list", "dark arrow", "yes");
INSERT INTO `wp_options` VALUES("458", "flex_lsidebar_titlecolor", "A10000", "yes");
INSERT INTO `wp_options` VALUES("459", "flex_sidebar_ssfont", "Arial", "yes");
INSERT INTO `wp_options` VALUES("460", "flex_sidebar_ssfontsize", "15", "yes");
INSERT INTO `wp_options` VALUES("461", "flex_sidebar_scase", "uppercase", "yes");
INSERT INTO `wp_options` VALUES("462", "flex_sidebar_sfontspace", "0", "yes");
INSERT INTO `wp_options` VALUES("463", "flex_sidebar_salign", "left", "yes");
INSERT INTO `wp_options` VALUES("464", "flex_sidebar_uline", "solid", "yes");
INSERT INTO `wp_options` VALUES("465", "flex_sidebar_ulines", "1", "yes");
INSERT INTO `wp_options` VALUES("466", "flex_sidebar_ulinec", "999999", "yes");
INSERT INTO `wp_options` VALUES("467", "flex_lsidebar_txtcolor", "666666", "yes");
INSERT INTO `wp_options` VALUES("468", "flex_lsidebar_linkcolor", "666666", "yes");
INSERT INTO `wp_options` VALUES("469", "flex_lsidebar_hovercolor", "A10000", "yes");
INSERT INTO `wp_options` VALUES("470", "flex_lsidebar_list", "dark arrow", "yes");
INSERT INTO `wp_options` VALUES("471", "flex_footer_color", "6B0000", "yes");
INSERT INTO `wp_options` VALUES("472", "flex_footer_bgimg", "no", "yes");
INSERT INTO `wp_options` VALUES("473", "flex_foot_feature", "no", "yes");
INSERT INTO `wp_options` VALUES("474", "flex_foot_widgets", "2", "yes");
INSERT INTO `wp_options` VALUES("475", "flex_footer_text", "E0E0E0", "yes");
INSERT INTO `wp_options` VALUES("476", "flex_footer_link", "FFCC00", "yes");
INSERT INTO `wp_options` VALUES("477", "flex_footer_widtitle", "21", "yes");
INSERT INTO `wp_options` VALUES("478", "flex_foot_list", "light arrow", "yes");
INSERT INTO `wp_options` VALUES("479", "flex_foot_links", "", "yes");
INSERT INTO `wp_options` VALUES("480", "flex_adsense_id", "", "yes");
INSERT INTO `wp_options` VALUES("481", "flex_adsense_loc1", "no", "yes");
INSERT INTO `wp_options` VALUES("482", "flex_adsense_loc1size", "728x90", "yes");
INSERT INTO `wp_options` VALUES("483", "flex_adsense_loc1type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("484", "flex_adsense_loc1channel", "", "yes");
INSERT INTO `wp_options` VALUES("485", "flex_adsense_loc2", "no", "yes");
INSERT INTO `wp_options` VALUES("486", "flex_adsense_loc2size", "234x60", "yes");
INSERT INTO `wp_options` VALUES("487", "flex_adsense_loc2type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("488", "flex_adsense_loc2channel", "", "yes");
INSERT INTO `wp_options` VALUES("489", "flex_adsense_loc3", "no", "yes");
INSERT INTO `wp_options` VALUES("490", "flex_adsense_loc3size", "234x60", "yes");
INSERT INTO `wp_options` VALUES("491", "flex_adsense_loc3type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("492", "flex_adsense_loc3channel", "", "yes");
INSERT INTO `wp_options` VALUES("493", "flex_adsense_loc4", "no", "yes");
INSERT INTO `wp_options` VALUES("494", "flex_adsense_loc4size", "468x60", "yes");
INSERT INTO `wp_options` VALUES("495", "flex_adsense_loc4type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("496", "flex_adsense_loc4channel", "", "yes");
INSERT INTO `wp_options` VALUES("497", "flex_adsense_loc5", "no", "yes");
INSERT INTO `wp_options` VALUES("498", "flex_adsense_loc5size", "468x60", "yes");
INSERT INTO `wp_options` VALUES("499", "flex_adsense_loc5type", "text_image", "yes");
INSERT INTO `wp_options` VALUES("500", "flex_adsense_loc5channel", "", "yes");
INSERT INTO `wp_options` VALUES("501", "flex_adsense_brdr", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("502", "flex_adsense_back", "FFFFFF", "yes");
INSERT INTO `wp_options` VALUES("503", "flex_adsense_link", "0000CC", "yes");
INSERT INTO `wp_options` VALUES("504", "flex_adsense_text", "000000", "yes");
INSERT INTO `wp_options` VALUES("505", "flex_adsense_url", "666666", "yes");
INSERT INTO `wp_options` VALUES("506", "flex_analytics_id", "", "yes");
INSERT INTO `wp_options` VALUES("507", "flex_footer_script", "", "yes");
INSERT INTO `wp_options` VALUES("508", "flex_css_pack", "yes", "yes");
INSERT INTO `wp_options` VALUES("509", "flex_customcss", "", "yes");
INSERT INTO `wp_options` VALUES("515", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"3817\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2419\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2308\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"1911\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"1822\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1567\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1302\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1302\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1288\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1241\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1200\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1112\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:3:\"969\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:3:\"956\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:3:\"954\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:3:\"925\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:3:\"820\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:3:\"805\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:3:\"760\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"708\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"674\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"668\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"666\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"610\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"609\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"580\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"560\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"547\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"545\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"527\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"517\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"516\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"495\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"490\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"453\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"449\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"448\";}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";s:3:\"447\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"427\";}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"Share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";s:3:\"426\";}}", "yes");
INSERT INTO `wp_options` VALUES("517", "_site_transient_update_plugins", "O:8:\"stdClass\":3:{s:12:\"last_checked\";i:1371080113;s:7:\"checked\";a:3:{s:19:\"akismet/akismet.php\";s:5:\"2.5.7\";s:25:\"duplicator/duplicator.php\";s:5:\"0.4.4\";s:9:\"hello.php\";s:3:\"1.6\";}s:8:\"response\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("518", "duplicator_settings", "a:3:{s:7:\"version\";s:5:\"0.4.4\";s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;}", "yes");
INSERT INTO `wp_options` VALUES("519", "duplicator_version_plugin", "0.4.4", "yes");
INSERT INTO `wp_options` VALUES("520", "duplicator_options", "s:217:\"a:9:{s:6:\"dbhost\";s:9:\"localhost\";s:6:\"dbname\";s:0:\"\";s:6:\"dbuser\";s:0:\"\";s:7:\"url_new\";s:0:\"\";s:8:\"email-me\";s:1:\"0\";s:12:\"email_others\";s:0:\"\";s:10:\"dir_bypass\";s:0:\"\";s:9:\"log_level\";s:1:\"0\";s:8:\"skip_ext\";s:0:\"\";}\";", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("1", "2", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("5", "5", "_link_target", "_self");
INSERT INTO `wp_postmeta` VALUES("4", "5", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("6", "5", "_anything_type", "image");
INSERT INTO `wp_postmeta` VALUES("7", "5", "_image_caption_position", "disable");
INSERT INTO `wp_postmeta` VALUES("8", "5", "_sidebar_position", "left");
INSERT INTO `wp_postmeta` VALUES("9", "5", "_anything_click_stop", "false");
INSERT INTO `wp_postmeta` VALUES("10", "5", "_anything_stop", "false");
INSERT INTO `wp_postmeta` VALUES("11", "5", "_edit_lock", "1370197561:1");
INSERT INTO `wp_postmeta` VALUES("12", "2", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("13", "2", "_wp_trash_meta_time", "1370720285");
INSERT INTO `wp_postmeta` VALUES("14", "1", "_wp_trash_meta_status", "publish");
INSERT INTO `wp_postmeta` VALUES("15", "1", "_wp_trash_meta_time", "1370720294");
INSERT INTO `wp_postmeta` VALUES("16", "1", "_wp_trash_meta_comments_status", "a:1:{i:1;s:1:\"1\";}");
INSERT INTO `wp_postmeta` VALUES("17", "8", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("18", "8", "_edit_lock", "1371056970:1");
INSERT INTO `wp_postmeta` VALUES("21", "10", "_wp_attached_file", "2013/06/images.jpg");
INSERT INTO `wp_postmeta` VALUES("22", "10", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:246;s:6:\"height\";i:205;s:4:\"file\";s:18:\"2013/06/images.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:18:\"images-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("26", "13", "_edit_lock", "1371056921:1");
INSERT INTO `wp_postmeta` VALUES("25", "13", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("34", "19", "_edit_lock", "1371057093:1");
INSERT INTO `wp_postmeta` VALUES("33", "19", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("38", "21", "_edit_lock", "1371057230:1");
INSERT INTO `wp_postmeta` VALUES("37", "21", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("42", "23", "_edit_lock", "1371057335:1");
INSERT INTO `wp_postmeta` VALUES("41", "23", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("46", "25", "_edit_lock", "1371058085:1");
INSERT INTO `wp_postmeta` VALUES("45", "25", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("49", "28", "_wp_attached_file", "2013/06/banner250static02.png");
INSERT INTO `wp_postmeta` VALUES("50", "28", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:250;s:6:\"height\";i:250;s:4:\"file\";s:29:\"2013/06/banner250static02.png\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"banner250static02-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("51", "28", "_edit_lock", "1371058114:1");
INSERT INTO `wp_postmeta` VALUES("52", "29", "_wp_attached_file", "2013/06/cropped-head1.jpg");
INSERT INTO `wp_postmeta` VALUES("53", "29", "_wp_attachment_context", "custom-header");
INSERT INTO `wp_postmeta` VALUES("54", "29", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:960;s:6:\"height\";i:250;s:4:\"file\";s:25:\"2013/06/cropped-head1.jpg\";s:5:\"sizes\";a:3:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"cropped-head1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:24:\"cropped-head1-300x78.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:78;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:14:\"post-thumbnail\";a:4:{s:4:\"file\";s:25:\"cropped-head1-624x162.jpg\";s:5:\"width\";i:624;s:6:\"height\";i:162;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}");
INSERT INTO `wp_postmeta` VALUES("55", "29", "_wp_attachment_is_custom_header", "twentytwelve");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("1", "1", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "trash", "open", "open", "", "hello-world", "", "", "2013-06-08 19:38:14", "2013-06-08 19:38:14", "", "0", "http://blogsforsales.com/video/?p=1", "0", "post", "", "1");
INSERT INTO `wp_posts` VALUES("2", "1", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/video/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "trash", "open", "open", "", "sample-page", "", "", "2013-06-08 19:38:05", "2013-06-08 19:38:05", "", "0", "http://blogsforsales.com/video/?page_id=2", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2013-06-12 17:08:00", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2013-06-12 17:08:00", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/video/?p=17", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("5", "1", "2013-06-02 18:24:30", "2013-06-02 18:24:30", "<iframe width=\"560\" height=\"315\" src=\"http://www.youtube.com/embed/e91_xLKVFZE\" frameborder=\"0\" allowfullscreen></iframe>", "Video Promotion", "", "publish", "closed", "closed", "", "5", "", "", "2013-06-02 18:26:01", "2013-06-02 18:26:01", "", "0", "http://blogsforsales.com/video/?post_type=slideshow&#038;p=5", "0", "slideshow", "", "0");
INSERT INTO `wp_posts` VALUES("6", "1", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://blogsforsales.com/video/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!", "Sample Page", "", "inherit", "open", "open", "", "2-revision", "", "", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "", "2", "http://blogsforsales.com/video/?p=6", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("7", "1", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "Welcome to WordPress. This is your first post. Edit or delete it, then start blogging!", "Hello world!", "", "inherit", "open", "open", "", "1-revision", "", "", "2013-06-01 15:58:51", "2013-06-01 15:58:51", "", "1", "http://blogsforsales.com/video/?p=7", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2013-06-08 19:40:51", "2013-06-08 19:40:51", "How To Submit your videos to multiple sites\r\n\r\n<a href=\"http://blogsforsales.com/video/wp-content/uploads/2013/06/images.jpg\"><img class=\"size-full wp-image-10 alignleft\" alt=\"images\" src=\"http://blogsforsales.com/video/wp-content/uploads/2013/06/images.jpg\" width=\"246\" height=\"205\" /></a>If it\'s a fact that \"a picture says a thousand words\", imagine what a video can do? Compared to a photo or pages of text, a video can tell much more. While most individuals understand the essence of this, getting videos in most of the sharing sites has been a daunting task. It is thus important to learn how to submit your videos to multiple sitesand the benefits that you stand to gain.\r\n\r\nHosting your videos on free video sharing sites such as Vimeo, Dailymotion, YouTube , Blip.tv and other social media sites such as Facebook has immense advantages. Key among these are the fact that this increases the visibility of your brand on search engines and its one of the cheapest content delivery mechanisms since the costs are catered for by the sharing site.\r\nIt goes without saying that video sharing sites are an incredible place to market/showcase your brand and the products it has to offer. These sites host your video at absolutely no cost and allow you to upload as many videos as possible. However, uploading videos to these sites takes immense time since you have to upload the video(s) to each of the sites independently. It is for this fact that you need to learn how to submit your videos to multiple sites simultaneously.\r\n\r\nTo avoid the latter mentioned problem when you want to submit your videos to multiple sites, there are tools available and which could help you upload these videos to the different video sharing sites all at a go. These tools include:\r\n\r\nTubeMogul- It offer free single point for uploading videos to the most common video sharing sites. It also offers a great analysis on who, what, and how your uploaded videos are being watched.\r\nHey!Spread- This tool allows its users to upload videos to different sites all at the same time. Individuals can also check the upload process as it occurs and instantly know when the video is available on the different video portals it supports.\r\nVidMetrix- It enables its users to automatically and reliably syndicate their videos to each of t he major video networks across the internet. In addition, it provides an insightful report on the video viewership, feedback and engagement.", "Submitting Your Videos", "", "publish", "open", "open", "", "submitting-your-videos", "", "", "2013-06-08 19:45:26", "2013-06-08 19:45:26", "", "0", "http://blogsforsales.com/video/?p=8", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2013-06-08 19:40:49", "2013-06-08 19:40:49", "How To Submit your videos to multiple sites\n \n If it\'s a fact that \"a picture says a thousand words\", imagine what a video can do? Compared to a photo or pages of text, a video can tell much more. While most individuals understand the essence of this, getting videos in most of the sharing sites has been a daunting task. It is thus important to learn how to submit your videos to multiple sitesand the benefits that you stand to gain.\n\n Hosting your videos on free video sharing sites such as Vimeo, Dailymotion, YouTube , Blip.tv and other social media sites such as Facebook has immense advantages. Key among these are the fact that this increases the visibility of your brand on search engines and its one of the cheapest content delivery mechanisms since the costs are catered for by the sharing site.\n It goes without saying that video sharing sites are an incredible place to market/showcase your brand and the products it has to offer. These sites host your video at absolutely no cost and allow you to upload as many videos as possible. However, uploading videos to these sites takes immense time since you have to upload the video(s) to each of the sites independently. It is for this fact that you need to learn how to submit your videos to multiple sites simultaneously.\n\nTo avoid the latter mentioned problem when you want to submit your videos to multiple sites, there are tools available and which could help you upload these videos to the different video sharing sites all at a go. These tools include:\n\n TubeMogul- It offer free single point for uploading videos to the most common video sharing sites. It also offers a great analysis on who, what, and how your uploaded videos are being watched.\n Hey!Spread- This tool allows its users to upload videos to different sites all at the same time. Individuals can also check the upload process as it occurs and instantly know when the video is available on the different video portals it supports.\n VidMetrix- It enables its users to automatically and reliably syndicate their videos to each of t he major video networks across the internet. In addition, it provides an insightful report on the video viewership, feedback and engagement.", "Submitting Your Videos", "", "inherit", "open", "open", "", "8-revision", "", "", "2013-06-08 19:40:49", "2013-06-08 19:40:49", "", "8", "http://blogsforsales.com/video/?p=9", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2013-06-08 19:44:50", "2013-06-08 19:44:50", "", "images", "", "inherit", "open", "open", "", "images", "", "", "2013-06-08 19:44:50", "2013-06-08 19:44:50", "", "8", "http://blogsforsales.com/video/wp-content/uploads/2013/06/images.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("11", "1", "2013-06-08 19:44:55", "2013-06-08 19:44:55", "How To Submit your videos to multiple sites\n \nIf it\'s a fact that \"a picture says a thousand words\", imagine what a video can do? Compared to a photo or pages of text, a video can tell much more. While most individuals understand the essence of this, getting videos in most of the sharing sites has been a daunting task. It is thus important to learn how to submit your videos to multiple sitesand the benefits that you stand to gain.\n\n Hosting your videos on free video sharing sites such as Vimeo, Dailymotion, YouTube , Blip.tv and other social media sites such as Facebook has immense advantages. Key among these are the fact that this increases the visibility of your brand on search engines and its one of the cheapest content delivery mechanisms since the costs are catered for by the sharing site.\n It goes without saying that video sharing sites are an incredible place to market/showcase your brand and the products it has to offer. These sites host your video at absolutely no cost and allow you to upload as many videos as possible. However, uploading videos to these sites takes immense time since you have to upload the video(s) to each of the sites independently. It is for this fact that you need to learn how to submit your videos to multiple sites simultaneously.\n\nTo avoid the latter mentioned problem when you want to submit your videos to multiple sites, there are tools available and which could help you upload these videos to the different video sharing sites all at a go. These tools include:\n\n TubeMogul- It offer free single point for uploading videos to the most common video sharing sites. It also offers a great analysis on who, what, and how your uploaded videos are being watched.\n Hey!Spread- This tool allows its users to upload videos to different sites all at the same time. Individuals can also check the upload process as it occurs and instantly know when the video is available on the different video portals it supports.\n VidMetrix- It enables its users to automatically and reliably syndicate their videos to each of t he major video networks across the internet. In addition, it provides an insightful report on the video viewership, feedback and engagement.", "Submitting Your Videos", "", "inherit", "open", "open", "", "8-autosave", "", "", "2013-06-08 19:44:55", "2013-06-08 19:44:55", "", "8", "http://blogsforsales.com/video/?p=11", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("12", "1", "2013-06-08 19:40:51", "2013-06-08 19:40:51", "How To Submit your videos to multiple sites\r\n \r\n If it\'s a fact that \"a picture says a thousand words\", imagine what a video can do? Compared to a photo or pages of text, a video can tell much more. While most individuals understand the essence of this, getting videos in most of the sharing sites has been a daunting task. It is thus important to learn how to submit your videos to multiple sitesand the benefits that you stand to gain.\r\n\r\n Hosting your videos on free video sharing sites such as Vimeo, Dailymotion, YouTube , Blip.tv and other social media sites such as Facebook has immense advantages. Key among these are the fact that this increases the visibility of your brand on search engines and its one of the cheapest content delivery mechanisms since the costs are catered for by the sharing site.\r\n It goes without saying that video sharing sites are an incredible place to market/showcase your brand and the products it has to offer. These sites host your video at absolutely no cost and allow you to upload as many videos as possible. However, uploading videos to these sites takes immense time since you have to upload the video(s) to each of the sites independently. It is for this fact that you need to learn how to submit your videos to multiple sites simultaneously.\r\n\r\nTo avoid the latter mentioned problem when you want to submit your videos to multiple sites, there are tools available and which could help you upload these videos to the different video sharing sites all at a go. These tools include:\r\n\r\n TubeMogul- It offer free single point for uploading videos to the most common video sharing sites. It also offers a great analysis on who, what, and how your uploaded videos are being watched.\r\n Hey!Spread- This tool allows its users to upload videos to different sites all at the same time. Individuals can also check the upload process as it occurs and instantly know when the video is available on the different video portals it supports.\r\n VidMetrix- It enables its users to automatically and reliably syndicate their videos to each of t he major video networks across the internet. In addition, it provides an insightful report on the video viewership, feedback and engagement.", "Submitting Your Videos", "", "inherit", "open", "open", "", "8-revision-2", "", "", "2013-06-08 19:40:51", "2013-06-08 19:40:51", "", "8", "http://blogsforsales.com/video/?p=12", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2013-06-08 19:47:27", "2013-06-08 19:47:27", "<strong>How to acquire more views for online video</strong>\r\n\r\nIn recent years, the industry of online marketing has advanced at a rapid pace, especially due to marketing through online videos. With passing time, commercialized technology has progressed immensely, so using videos for social media is simple and economical. Now, it is also extremely important to promote the video-based websites properly, so that many viewers are satisfactorily convinced, and the aim of stimulating sales through online marketing is accomplished. Some proven effective techniques are mentioned below:\r\n\r\nSharing should be enabled  The amount of publicity is directly proportional to the bulk of videos shared. It is predicted that, more the number of views by end-users, more are the possibilities of sales. It should be ensured that the created videos have the in-built option of sharing in them, so that viewers can share them via social media websites or through e-mails.\r\n\r\nBuzz should be generated  Usually, little hype around the marketed product acquires some views easily, as humans are curious by nature. With the help of teasers and video adverts, the product can definitely become the topic of discussion for quite some time.  Subscriber base should be amplified  It is essential to place the video on the correct forum, so that the appropriate clients are able to view it.\r\n\r\nUsage of functions like RSS feed can be of aid to create subscriber base, which in turn would frame the foundation of sales strategy. If a proper channel is created through video sharing websites, then it will definitely result in high publicity followed by loyal subscribers and huge number of guaranteed consumers.\r\n\r\nMaking the marketed product easily accessible  While a viewer is watching a video and wants to access the item immediately, sufficient and prompt links should be available. Even if the video is the best ever, but without any such accessible links, potential purchasers might just change their mind about buying the item.", "Getting Views To Your Video", "", "publish", "open", "open", "", "13", "", "", "2013-06-12 17:08:39", "2013-06-12 17:08:39", "", "0", "http://blogsforsales.com/video/?p=13", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2013-06-08 19:46:43", "2013-06-08 19:46:43", "<strong>How to acquire more views for online videos</strong>\n\nIn recent years, the industry of online marketing has advanced at a rapid pace, especially due tomarketing through online videos. With passing time, commercialized technology has progressed immensely, so using videos for social media is simple and economical. Now, it is also extremely important to promote the video-based websites properly, so that many viewers are satisfactorily convinced, and the aim of stimulating sales through online marketing is accomplished. Some proven effective techniques are mentioned below:\nSharing should be enabled\nThe amount of publicity is directly proportional to the bulk of videos shared. It is predicted that, more the number of views by end-users, more are the possibilities of sales. It should be ensured that the created videos have the in-built option of sharing in them, so that viewers can share them via social media websites or through e-mails.\nBuzz should be generated\nUsually, little hype around the marketed product acquires some views easily, as humans are curious by nature. With the help of teasers and video adverts, the product can definitely become the topic of discussion for quite some time.\nSubscriber base should be amplified\nIt is essential to place the video on the correct forum, so that the appropriate clients are able to view it. Usage of functions like RSS feed can be of aid to create subscriber base, which in turn would frame the foundation of sales strategy. If a proper channel is created through video sharing websites, then it will definitely result in high publicity followed by loyal subscribers and huge number of guaranteed consumers.\nMaking the marketed product easily accessible\nWhile a viewer is watching a video and wants to access the item immediately, sufficient and prompt links should be available. Even if the video is the best ever, but without any such accessible links, potential purchasers might just change their mind about buying the item.", "", "", "inherit", "open", "open", "", "13-revision", "", "", "2013-06-08 19:46:43", "2013-06-08 19:46:43", "", "13", "http://blogsforsales.com/video/?p=14", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2013-06-08 19:47:27", "2013-06-08 19:47:27", "<strong>How to acquire more views for online video</strong>\r\n\r\nIn recent years, the industry of online marketing has advanced at a rapid pace, especially due to marketing through online videos. With passing time, commercialized technology has progressed immensely, so using videos for social media is simple and economical. Now, it is also extremely important to promote the video-based websites properly, so that many viewers are satisfactorily convinced, and the aim of stimulating sales through online marketing is accomplished. Some proven effective techniques are mentioned below:  Sharing should be enabled  The amount of publicity is directly proportional to the bulk of videos shared. It is predicted that, more the number of views by end-users, more are the possibilities of sales. It should be ensured that the created videos have the in-built option of sharing in them, so that viewers can share them via social media websites or through e-mails.  Buzz should be generated  Usually, little hype around the marketed product acquires some views easily, as humans are curious by nature. With the help of teasers and video adverts, the product can definitely become the topic of discussion for quite some time.  Subscriber base should be amplified  It is essential to place the video on the correct forum, so that the appropriate clients are able to view it. Usage of functions like RSS feed can be of aid to create subscriber base, which in turn would frame the foundation of sales strategy. If a proper channel is created through video sharing websites, then it will definitely result in high publicity followed by loyal subscribers and huge number of guaranteed consumers.  Making the marketed product easily accessible  While a viewer is watching a video and wants to access the item immediately, sufficient and prompt links should be available. Even if the video is the best ever, but without any such accessible links, potential purchasers might just change their mind about buying the item.", "", "", "inherit", "open", "open", "", "13-revision-2", "", "", "2013-06-08 19:47:27", "2013-06-08 19:47:27", "", "13", "http://blogsforsales.com/video/?p=15", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2013-06-08 19:48:31", "0000-00-00 00:00:00", "", "Auto Draft", "", "auto-draft", "open", "open", "", "", "", "", "2013-06-08 19:48:31", "0000-00-00 00:00:00", "", "0", "http://blogsforsales.com/video/?p=16", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2013-06-08 19:48:27", "2013-06-08 19:48:27", "<strong>How to acquire more views for online video</strong>\r\n\r\nIn recent years, the industry of online marketing has advanced at a rapid pace, especially due to marketing through online videos. With passing time, commercialized technology has progressed immensely, so using videos for social media is simple and economical. Now, it is also extremely important to promote the video-based websites properly, so that many viewers are satisfactorily convinced, and the aim of stimulating sales through online marketing is accomplished. Some proven effective techniques are mentioned below:\r\n\r\nSharing should be enabled  The amount of publicity is directly proportional to the bulk of videos shared. It is predicted that, more the number of views by end-users, more are the possibilities of sales. It should be ensured that the created videos have the in-built option of sharing in them, so that viewers can share them via social media websites or through e-mails.\r\n\r\nBuzz should be generated  Usually, little hype around the marketed product acquires some views easily, as humans are curious by nature. With the help of teasers and video adverts, the product can definitely become the topic of discussion for quite some time.  Subscriber base should be amplified  It is essential to place the video on the correct forum, so that the appropriate clients are able to view it.\r\n\r\nUsage of functions like RSS feed can be of aid to create subscriber base, which in turn would frame the foundation of sales strategy. If a proper channel is created through video sharing websites, then it will definitely result in high publicity followed by loyal subscribers and huge number of guaranteed consumers.\r\n\r\nMaking the marketed product easily accessible  While a viewer is watching a video and wants to access the item immediately, sufficient and prompt links should be available. Even if the video is the best ever, but without any such accessible links, potential purchasers might just change their mind about buying the item.", "", "", "inherit", "open", "open", "", "13-revision-3", "", "", "2013-06-08 19:48:27", "2013-06-08 19:48:27", "", "13", "http://blogsforsales.com/video/?p=18", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2013-06-12 17:11:33", "2013-06-12 17:11:33", "<strong>How to use videos to promote your business</strong>\r\n\r\nVideos can be a very powerful marketing tool for your business. In fact, the use of videos is perhaps one of the most effective internet marketing tactics today. However, this tactic can fail to be effective if you don\'t know how to use videos to promote your business. But how can you get it right? Well, here are a few things you should always keep in mind when using videos for marketing.\r\n\r\nFirst of all, don\'t just use any vide. Let\'s face it, we have all seen some amateur home videos becoming hits on YouTube, but things are different when it comes to marketing. You have to use high quality videos if you are to stand a chance of being noticed. Websites like YouTube have advanced their technology and so should you.\r\n\r\nYour video should also be interesting. It should not be too long because some viewers will lose interest very fast. As much as you can, stick to the important details about your company; the kind of things that a potential client would like to know.\r\n\r\nWhen uploading your video on YouTube, remember to place there something that points to your company. You can place a company logo or the URL to your company website, so that a viewer is reminded of your company even as they watch the video. If you are using a company logo, make sure that company name can be read clearly by the viewer. But at the same time, you should ensure that the logo or the URL is not too large such that the video becomes boring to watch.\r\n\r\nThe landing page on your website should also be very highly optimized for you tube.\r\nAnd remember to end the video with a short but catchy call to action. Tell the viewer the name of your company and what you do.", "How to use videos to promote your business", "", "publish", "open", "open", "", "how-to-use-videos-to-promote-your-business", "", "", "2013-06-12 17:11:33", "2013-06-12 17:11:33", "", "0", "http://blogsforsales.com/video/?p=19", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2013-06-12 17:11:10", "2013-06-12 17:11:10", "<strong>How to use videos to promote your business</strong>\n\nVideos can be a very powerful marketing tool for your business. In fact, the use of videos is perhaps one of the most effective internet marketing tactics today. However, this tactic can fail to be effective if you don\'t know how to use videos to promote your business. But how can you get it right? Well, here are a few things you should always keep in mind when using videos for marketing.\n\nFirst of all, don\'t just use any vide. Let\'s face it, we have all seen some amateur home videos becoming hits on YouTube, but things are different when it comes to marketing. You have to use high quality videos if you are to stand a chance of being noticed. Websites like YouTube have advanced their technology and so should you.\n\nYour video should also be interesting. It should not be too long because some viewers will lose interest very fast. As much as you can, stick to the important details about your company; the kind of things that a potential client would like to know.\n\nWhen uploading your video on YouTube, remember to place there something that points to your company. You can place a company logo or the URL to your company website, so that a viewer is reminded of your company even as they watch the video. If you are using a company logo, make sure that company name can be read clearly by the viewer. But at the same time, you should ensure that the logo or the URL is not too large such that the video becomes boring to watch.The landing page on your website should also be very highly optimized for you tube.\nAnd remember to end the video with a short but catchy call to action. Tell the viewer the name of your company and what you do.", "", "", "inherit", "open", "open", "", "19-revision", "", "", "2013-06-12 17:11:10", "2013-06-12 17:11:10", "", "19", "http://blogsforsales.com/video/?p=20", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2013-06-12 17:13:49", "2013-06-12 17:13:49", "<strong>How video marketing on social media platforms can help grow your business</strong>\r\n\r\nEspecially these days everyone who wants to advertise his/hers products to an huge audience will probably go with social media platforms that support videos like YouTube or dailymotion. But what is required in order to succeed in that huge market? This article will talk about strategies and tips on how to successfully advertise your video in order to reach more potential customers.\r\n\r\nIf you think that ranking on YouTube is easy then you are probably wrong. It\'s not just about getting as much views as you can in order to rank on the first page. There are several factors that you need to keep in mind in order to succeed.\r\n\r\nThe first one we want to talk about is \"audience retention\". This means how long people have watched your video. For example if you upload a video with a length of 1:30 minutes you probably want people to watch it for at least 1 minute. Why? Well you want to reach a retention rate of at least 60-80% since this factor is very important when it comes to the actual ranking.\r\n\r\nYou probably wonder \"But where do I get such retention views?\" . One very trustworthy provider is for example viralsocials.com . Their retention views packages start at 4$ and they usually over-deliver. However you need to make sure that your video receives constantly views in order to make it look more legit.\r\n\r\nLike I mentioned previously views is not the only factor you need to consider. Another important thing you need to take care of is \"Video Optimization\" which means that you need to define high quality tags along with keywords that go into your video description. The video itself should have a title which contains your main keyword you want to rank for and also an detailed description is a must if you want to reach a wide audience and make your video look more legit.\r\n\r\nIn conclusion we can say that when you keep these two important factors in mind you are very likely to succeed in YouTube\'s ranking system.", "Videos on Social Media", "", "publish", "open", "open", "", "videos-on-social-media", "", "", "2013-06-12 17:13:49", "2013-06-12 17:13:49", "", "0", "http://blogsforsales.com/video/?p=21", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2013-06-12 17:13:02", "2013-06-12 17:13:02", "How video marketing on social media platforms can help grow your business\n\nEspecially these days everyone who wants to advertise his/hers products to an huge audience will probably go with social media platforms that support videos like YouTube or dailymotion. But what is required in order to succeed in that huge market? This article will talk about strategies and tips on how to successfully advertise your video in order to reach more potential customers.\n\nIf you think that ranking on YouTube is easy then you are probably wrong. It\'s not just about getting as much views as you can in order to rank on the first page. There are several factors that you need to keep in mind in order to succeed.\n\nThe first one we wanna talk about is \"audience retention\". This means how long people have watched your video. For example if you upload a video with a length of 1:30 minutes you probably want people to watch it for at least 1 minute. Why? Well you want to reach a retention rate of at least 60-80% since this factor is very important when it comes to the actual ranking.\n\nYou probably wonder \"But where do I get such retention views?\" . One very trustworthy provider is for example viralsocials.com . Their retention views packages start at 4$ and they usually over-deliver. However you need to make sure that your video receives constantly views in order to make it look more legit.\n\nLike I mentioned previously views is not the only factor you need to consider. Another important thing you need to take care of is \"Video Optimization\" which means that you need to define high quality tags along with keywords that go into your video description. The video itself should have a title which contains your main keyword you want to rank for and also an detailed description is a must if you want to reach a wide audience and make your video look more legit.\n\nIn conclusion we can say that when you keep these two important factors in mind you are very likely to succeed in YouTube\'s ranking system.", "Videos on Social Media", "", "inherit", "open", "open", "", "21-revision", "", "", "2013-06-12 17:13:02", "2013-06-12 17:13:02", "", "21", "http://blogsforsales.com/video/?p=22", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2013-06-12 17:15:34", "2013-06-12 17:15:34", "<strong>How to Boost Sales With Video Marketing</strong>\r\n\r\nYoutube, Metacafe, and many other sites offer free video hosting, and over the years this has become extremely popular and very much a source of entertainment on the web. But how can you benefit with youtube or other video hosting sites? The answer is very simple. Promote your product or service over these video sharing sites and you can be having more sales. But you have to know How to Boost Sales With Video Marketing.\r\n\r\nThere are many valid reasons on why videos can help boost your sales. When people watch real people reviewing a product through a video message. They can trust it more than any writing or anything else. So to boost your sales you have to boost your video views first. Make a very high quality video and make sure it is related to the topic. Picking a good topic is also very crucial as well. A good topic that can catch viewers, for example a very small, exciting description of your product could be a good idea. This video then if gets a lot of views will get ranked much better and more people will be exposed to your video. If people are genuinely interested by your video for the product then you will see some good sales rolling in and quite fast at that.\r\n\r\nIncrease your video views by sharing it with friends, giving links to places such as blogs and forums where relevant and also sharing it on facebook. Promote your video well so it gets ranked well and more people can get to watch your video. People wont generally watch videos that have low views or likes, so make sure you tell your fans to like and view your videos as much as possible. This can be very successful if done properly so you can then earn more money and prosper in your business. Boost sales with video marketing today and see excellent results.", "Boosting Sales With Videos", "", "publish", "open", "open", "", "boosting-sales-with-videos", "", "", "2013-06-12 17:15:34", "2013-06-12 17:15:34", "", "0", "http://blogsforsales.com/video/?p=23", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2013-06-12 17:15:27", "2013-06-12 17:15:27", "<strong>How to Boost Sales With Video Marketing</strong>\n\nYoutube, Metacafe, and many other sites offer free video hosting, and over the years this has become extremely popular and very much a source of entertainment on the web. But how can you benefit with youtube or other video hosting sites? The answer is very simple. Promote your product or service over these video sharing sites and you can be having more sales. But you have to know How to Boost Sales With Video Marketing.\n\nThere are many valid reasons on why videos can help boost your sales. When people watch real people reviewing a product through a video message. They can trust it more than any writing or anything else. So to boost your sales you have to boost your video views first. Make a very high quality video and make sure it is related to the topic. Picking a good topic is also very crucial as well. A good topic that can catch viewers, for example a very small, exciting description of your product could be a good idea. This video then if gets a lot of views will get ranked much better and more people will be exposed to your video. If people are genuinely interested by your video for the product then you will see some good sales rolling in and quite fast at that.\n\nIncrease your video views by sharing it with friends, giving links to places such as blogs and forums where relevant and also sharing it on facebook. Promote your video well so it gets ranked well and more people can get to watch your video. People wont generally watch videos that have low views or likes, so make sure you tell your fans to like and view your videos as much as possible. This can be very successful if done properly so you can then earn more money and prosper in your business. Boost sales with video marketing today and see excellent results.", "Boosting Sales With Videos", "", "inherit", "open", "open", "", "23-revision", "", "", "2013-06-12 17:15:27", "2013-06-12 17:15:27", "", "23", "http://blogsforsales.com/video/?p=24", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2013-06-12 17:17:02", "2013-06-12 17:17:02", "Why Video Marketing Is the Future of the Internet\r\n\r\nVideo marketing is the future of the internet because it draws more traffic to the website than other marketing methods used on the internet today. Lots of people visit the internet to watch videos. It is estimated that well over two billion videos are watched on the internet everyday. The boom of the internet video is attributed to the pioneering efforts of YouTube. Many people spend their times on the internet watching videos more than they watch televisions. It has become the most useful tool in the hand of the internet marketer. Here are some of the few reasons video marketing is considered as the future of the internet:\r\n\r\nMany people come online to watch videos more than they even read the texts. Because of its motions, videos are more engaging and attention grabbing than other marketing tools. Many people like to watch videos online. The best way to reach at the marketing audience is through viral marketing.\r\n\r\nPeople easily understand the video message more than articles and written messages this is because video messages go straight to the point. The message is very specific and people could easily understand them by its demonstrations.\r\n\r\nVideo marketing is cheaper than most other forms of traditional marketing techniques. Video marketing does not involve too much money. People are often scared about video production; this is because they are not well informed about the cheap methods of producing and uploading videos.\r\n\r\nThe search engines especially Google love video. Many people who want their sites to get favorable search engine ranking should always support their website with videos. This helps a lot in positioning the website at the top of the search engine results. Google would always want to index websites with video upload.\r\n\r\nMany online buyers love the video because it best conveys the message they want about the products they want to buy. Moreover, the video demonstrates how the product works and the way they could be used. Because of the special love for videos it is obvious that is the future of the internet marketing.", "Video Marketing Introduction", "", "publish", "open", "open", "", "video-marketing-introduction", "", "", "2013-06-12 17:17:02", "2013-06-12 17:17:02", "", "0", "http://blogsforsales.com/video/?p=25", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2013-06-12 17:16:46", "2013-06-12 17:16:46", "Why Video Marketing Is the Future of the Internet\n\nVideo marketing is the future of the internet because it draws more traffic to the website than other marketing methods used on the internet today. Lots of people visit the internet to watch videos. It is estimated that well over two billion videos are watched on the internet everyday. The boom of the internet video is attributed to the pioneering efforts of YouTube. Many people spend their times on the internet watching videos more than they watch televisions. It has become the most useful tool in the hand of the internet marketer. Here are some of the few reasons video marketing is considered as the future of the internet:\n\nMany people come online to watch videos more than they even read the texts. Because of its motions, videos are more engaging and attention grabbing than other marketing tools. Many people like to watch videos online. The best way to reach at the marketing audience is through viral marketing.\n\nPeople easily understand the video message more than articles and written messages this is because video messages go straight to the point. The message is very specific and people could easily understand them by its demonstrations.\n\nVideo marketing is cheaper than most other forms of traditional marketing techniques. Video marketing does not involve too much money. People are often scared about video production; this is because they are not well informed about the cheap methods of producing and uploading videos.\n\nThe search engines especially Google love video. Many people who want their sites to get favorable search engine ranking should always support their website with videos. This helps a lot in positioning the website at the top of the search engine results. Google would always want to index websites with video upload.\n\nMany online buyers love the video because it best conveys the message they want about the products they want to buy. Moreover, the video demonstrates how the product works and the way they could be used. Because of the special love for videos it is obvious that is the future of the internet marketing.", "Video Marketing Introduction", "", "inherit", "open", "open", "", "25-revision", "", "", "2013-06-12 17:16:46", "2013-06-12 17:16:46", "", "25", "http://blogsforsales.com/video/?p=26", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2013-06-12 17:18:05", "2013-06-12 17:18:05", "Why Video Marketing Is the Future of the Internet\n\nVideo marketing is the future of the internet because it draws more traffic to the website than other marketing methods used on the internet today. Lots of people visit the internet to watch videos. It is estimated that well over two billion videos are watched on the internet everyday. The boom of the internet video is attributed to the pioneering efforts of YouTube. Many people spend their times on the internet watching videos more than they watch televisions. It has become the most useful tool in the hand of the internet marketer. Here are some of the few reasons video marketing is considered as the future of the internet:\n\nMany people come online to watch videos more than they even read the texts. Because of its motions, videos are more engaging and attention grabbing than other marketing tools. Many people like to watch videos online. The best way to reach at the marketing audience is through viral marketing.\n\nPeople easily understand the video message more than articles and written messages this is because video messages go straight to the point. The message is very specific and people could easily understand them by its demonstrations.\n\nVideo marketing is cheaper than most other forms of traditional marketing techniques. Video marketing does not involve too much money. People are often scared about video production; this is because they are not well informed about the cheap methods of producing and uploading videos.\n\nThe search engines especially Google love video. Many people who want their sites to get favorable search engine ranking should always support their website with videos. This helps a lot in positioning the website at the top of the search engine results. Google would always want to index websites with video upload.\n\nMany online buyers love the video because it best conveys the message they want about the products they want to buy. Moreover, the video demonstrates how the product works and the way they could be used. Because of the special love for videos it is obvious that is the future of the internet marketing.", "Video Marketing Introduction", "", "inherit", "open", "open", "", "25-autosave", "", "", "2013-06-12 17:18:05", "2013-06-12 17:18:05", "", "25", "http://blogsforsales.com/video/?p=27", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2013-06-12 17:28:29", "2013-06-12 17:28:29", "", "banner250static02", "", "inherit", "open", "open", "", "banner250static02", "", "", "2013-06-12 17:28:29", "2013-06-12 17:28:29", "", "0", "http://blogsforsales.com/video/wp-content/uploads/2013/06/banner250static02.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2013-06-12 17:42:28", "2013-06-12 17:42:28", "http://blogsforsales.com/video/wp-content/uploads/2013/06/cropped-head1.jpg", "cropped-head1.jpg", "", "inherit", "closed", "open", "", "cropped-head1-jpg", "", "", "2013-06-12 17:42:28", "2013-06-12 17:42:28", "", "0", "http://blogsforsales.com/video/wp-content/uploads/2013/06/cropped-head1.jpg", "0", "attachment", "image/jpeg", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("1", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("1", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("2", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("3", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("4", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("5", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("6", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("7", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("8", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("13", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("19", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("23", "1", "0");
INSERT INTO `wp_term_relationships` VALUES("21", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("25", "4", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "4");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "link_category", "", "0", "7");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "category", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "category", "", "0", "1");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Video Marketing", "videomarketing", "0");
INSERT INTO `wp_terms` VALUES("2", "Blogroll", "blogroll", "0");
INSERT INTO `wp_terms` VALUES("3", "Social Media", "social-media", "0");
INSERT INTO `wp_terms` VALUES("4", "Introduction", "introduction", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("2", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "nickname", "admin");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("7", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("8", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("9", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("10", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";s:1:\"1\";}");
INSERT INTO `wp_usermeta` VALUES("11", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("13", "1", "show_welcome_panel", "1");
INSERT INTO `wp_usermeta` VALUES("14", "1", "wp_dashboard_quick_press_last_post_id", "17");
INSERT INTO `wp_usermeta` VALUES("15", "1", "wp_user-settings", "editor=tinymce&libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("16", "1", "wp_user-settings-time", "1370720722");
INSERT INTO `wp_usermeta` VALUES("17", "1", "dismissed_wp_pointers", "wp350_media,wp340_choose_image_from_library");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "video", "$P$B6t7EruVRBT4PAllOsGujdzHrZK4wH1", "Admin", "anton241@herbalcuresandremedies.info", "", "2013-06-01 15:58:51", "", "0", "Admin");

SET FOREIGN_KEY_CHECKS = 1;